' Track Redirection & Synchronization
'
' Version: 3.4.2
' Date: 2015-10-05
' Author: Zvezdan Dimitrijevic
' URL: http://solair.eunet.rs/~zvezdand/TrackRedirection.htm
'
' Description:
' This script is for use with MediaMonkey (www.mediamonkey.com) v3.x or up.
' It tries to resolve a problem when some song is located on many albums.
' Instead of having multiple audio files with same song for every album,
' you could keep just one audio file for one album and on another albums you
' could have small .asx files as redirection files. With this script you could
' create .asx files and use them instead of original audio files, you could
' play them (MM 3.1 or up) and you could modify their metadata using Track
' Properties dialog box. Beside of the master audio file, the .asx file could
' also refence to its album cover bitmaps. There is also an option to update
' the playcount and the last played date of the master (referenced) file
' whenever you play some .asx file which refers to it. Many software and
' hardware players could reproduce audio files referenced by .asx files.
' Version 1.2 has added a possibility to create redirections between two audio
' files, for those users who like to keep duplicates on disk.
'
' For discussion about this script you could visit the MediaMonkey forum:
' http://www.mediamonkey.com/forum/viewtopic.php?f=2&t=39312
'
' Installation:
' - For MediaMonley 3.x, double click on MMIP file.
'
' Legal Notice:
' This add-on is donationware and may not be distributed or sold for profit.
' You are free to use it for the purpose mentioned in the Description section.
' No part of the included software may be redistributed for any purpose without
' the author's consent. Commercial use of this software is not allowed without
' written permission of the author.
'
' This add-on is developed by me, the author, in my own free time. I am not
' employed by Ventis Media, the company behind MediaMonkey, nor I've been paid
' by them for this add-on. So, if you find it useful and/or want to help its
' further development, it would be nice if you send me some small donation
' using PayPal or direct bank transfer. You could donate as much as you think
' that is appropriate, any amount would be really appreciated.
' http://solair.eunet.rs/~zvezdand/Donate.htm

' Disclaimer:
' This software is provided 'as-is', without any express or implied warranty.
' In no event will the author be held liable for any damages arising from the
' use of this software.
'
''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
Option Explicit:Const eq="Track Redirection & Synchronization",j8="3.4.2",hz=True,ay=4,jj=3,h3=0,d4=2:Dim aw,a2,jl:Set jl=CreateObject("Scripting.Dictionary"):With jl:.adD"Title","Title":.Add"Artist","ArtistName":.AdD"Composer","Author":.ADd"Album","AlbumName":.Add"Album Artist","AlbumArtistName":If Sdb.vErsiONhi>=3 Then .Add"Conductor","Conductor":End If:.add"Lyricist","Lyricist":.adD"Involved people","InvolvedPeople":If sDb.VERsionhI>=3 Then .aDD"Date","Year & dp(l.Month > 0, ""-"" & l.Month & dp(l.Day > 0, ""-"" & l.Day, """"), """")":Else .adD"Date","Year":End If:.adD"Genre","Genre":.aDD"Rating","Rating":.adD"Length","SongLength":If sDb.vERSIONhI<3 Then .ADD"Track #","TrackOrder":Else .Add"Track #","TrackOrderStr":.aDD"Disc #","DiscNumberStr":End If:.aDd"Track Volume","Leveling":If Sdb.VERsiONHI>=3 Then .AdD"Album Volume","LevelingAlbum":End If:.ADD"Bitrate","Bitrate":.Add"File size","FileLength":.Add"Timestamp","FileModified":.Add"Added","DateAdded":.Add"Played #","PlayCounter":.Add"Last Played","LastPlayed":.adD"Custom 1","Custom1":.aDD"Custom 2","Custom2":.adD"Custom 3","Custom3":If sdb.VersiOnhi>=3 Then .ADD"Custom 4","Custom4":.Add"Custom 5","Custom5":End If:.add"Tempo","Tempo":.AdD"Mood","Mood":.aDD"Occasion","Occasion":.Add"Quality","Quality":.aDd"BPM","BPM":.aDd"Sample Rate","SampleRate":.aDd"Channels","Channels":.aDD"Original Artist","OriginalArtist":.aDD"Original Album Title","OriginalTitle":If sdB.VerSIONHI>=3 Then .ADd"Original Date","OriginalYear & dp(l.OriginalMonth > 0, ""-"" & l.OriginalMonth & dp(l.OriginalDay > 0, ""-"" & l.OriginalDay, """"), """")":Else .ADd"Original Date","OriginalYear":End If:.adD"Comment","Comment":.ADD"Lyrics","Lyrics":If SDB.VERSioNhi>=3 Then .aDd"Grouping","Grouping":End If:.add"Copyright","Copyright":.ADd"Encoder","Encoder":.adD"ISRC","ISRC":.aDD"Original Lyricist","OriginalLyricist":.add"Publisher","Publisher":.ADD"VBR","VBR":.add"Peak Value","PeakValue":End With:Function iw(au,a5,kg):Dim a0:Select Case kg:Case 0:Set a0=CreateObject("Scripting.FileSystemObject").OPenTExTfiLe(au,2,True):a0.Write SDb.toAscii(a5):Case 2:Set a0=CreateObject("Scripting.FileSystemObject").OPENteXTfILe(au,2,True,-1):a0.Write a5:Case 1:Set a0=CreateObject("ADODB.Stream"):a0.opeN:a0.CHArSEt="UTF-8":a0.pOSiTIoN=0:a0.WRiTEtext a5:a0.sAvETOfile au,2:End Select:a0.ClosE:If Err Then iw=Err.Description:End If:End Function:Sub l7(h):a7=h.cHEcKeD:End Sub:Sub k1(h):h.CoMmoN.ParEnT.cOmMON.childcONTROl("DuplicatesExtList").cOmMoN.ENabled=Not h.cHecKeD:End Sub:Sub ka(h):Dim n,jy,x,cx:kj=h.TExt:de=h.itEMIndEx:If sdB.SeLEcTEDSoNgLiSt.Count>1 Then Exit Sub:End If:cx=bs.itEmcouNT-1:Do While cx>=0:bs.DELEtEitEm cx:cx=cx-1:Loop:jy=-1:cx=0:x=" Artist = '"&fz(gi)&"' AND Album = '"&fz(kj)&"'":If Len(gp)Then x=x&" AND"&gp:End If:If Not i4 Then Set n=sDB.DaTABASe.oPEnSqL("SELECT AlbumArtist FROM Songs WHERE "&x&" GROUP BY AlbumArtist ORDER BY AlbumArtist"):If Not n.EOf Then ac.TeXT=n.sTringBYIndEX(0):Else ac.tExT=sDb.sELECTedsONGLIST.Item(0).AlbUmArtIStnamE:End If:dx ac:hh=SDB.SeLEcteDsonGlIst.Item(0).titLE:Set n=sdB.dAtABasE.opEnSQl("SELECT SongTitle FROM Songs WHERE SongTitle = '"&fz(hh)&"' AND"&x):If n.Eof Then Set n=Sdb.dAtAbaSe.OPeNsQl("SELECT SongTitle FROM Songs WHERE SongTitle LIKE '"&fz(hh)&"%' AND"&x):If Not n.eOF Then hh=n.StRinGByiNDEX(0):End If:End If:End If:Set n=Sdb.DAtabasE.OpeNsQL("SELECT SongTitle FROM Songs WHERE "&x&" GROUP BY SongTitle ORDER BY SongTitle"):Do While Not n.eoF And cx<32000:bs.aDDiTEm n.STRiNgbYinDeX(0):If jy=-1 And hh=n.sTringBYiNdEx(0)Then jy=cx:End If:n.Next:cx=cx+1:Loop:Set n=Nothing:If jy>=0 Then bs.ITemiNdex=jy:Else bs.tExt=hh:End If:k6 bs:End Sub:Dim j1:Set j1=CreateObject("Scripting.Dictionary"):With j1:If sDB.VErsIONhI>=3 Then .adD"Date","l.Year = dp(m = ""0"", 0, Year(m & dp(InStr(m, ""-""), """", ""-1""))): If Len(cs(m, ""\d{4}-\d\d?"", 0)) Then l.Month = Month(m): If Len(cs(m, ""\d{4}-\d\d?-\d\d?"", 0)) Then l.Day = Day(m)":.ADd"Original Date","l.OriginalYear = dp(m = ""-1"" Or m = ""0"", m, Year(m & dp(InStr(m, ""-""), """", ""-1""))): If Len(cs(m, ""\d{4}-\d\d?"", 0)) Then l.OriginalMonth = Month(m): If Len(cs(m, ""\d{4}-\d\d?-\d\d?"", 0)) Then l.OriginalDay = Day(m)":End If:End With:Sub e2(jb):fj"DISTINCT IDref FROM TrackRedirection UNION SELECT IDasx FROM TrackRedirection":End Sub:Sub k7(h):f=h.Text:If LCase(Right(f,4))=".asx"And Not iy Then hr.CoMmOn.ENaBled=False:j6.coMMON.eNaBLEd=False:Else hr.COMMON.eNAblED=Not fm:j6.cOMMOn.eNAbled=True:End If:End Sub:Sub ReplaceWithAlbumTrackMain(jb):l2 jb,"Album","Main":End Sub:Sub jn(dt,e8,iz):Dim c9,z,e9,d,es,g:Set g=sdB.iNiFIlE:Set z=Sdb.Ui.AdDmeNuITeMsEP(dt,e8,0):Set c9=Sdb.uI.AddMENUITemSUb(dt,e8,0):c9.CapTIon=Sdb.lOCaLIZE("Track Redirection"):sDB.OBJeCts("mnu"&iz&"TrackRedirection")=c9:Set e9=sDB.uI.addmEnuIteMsub(c9,0,0):e9.cAPtIoN=SDb.locaLIZE("Find Referenced Master Track"):If g.BoOLvAlue("TrackRedirection","HideMenuFindReferencedMaster")Then e9.VisIBlE=False:End If:SdB.oBJects("mnu"&iz&"FindReferencedMaster")=e9:d=" a master track referenced by the selected .asx/audio file":Set z=sdB.UI.aDDMEnuitEM(e9,0,0):z.captiOn=SDb.localiZE("Search "&dp(sDb.VeRSIoNHi>=4,"Entire ","")&"Library/Album Folder"):z.hINT="Find album that contains"&d:z.OncLicKFuNc="ae":z.uSescRIpt=scRiPT.scRIPTPATh:Set z=SDB.ui.ADDMENuItem(e9,0,0):z.cAPTiON=sdB.lOcalIZE("Search "&dp(SDB.versIonHi>=4,"Entire ","")&"Library/Location Folder"):z.HINT="Find folder that contains"&d:z.ONcLicKfUNC="fw":z.uSeScrIpT=SCrIpt.ScriPtpaTH:es=True:On Error Resume Next:If SDB.vErSIONbuiLD<1218 Then es=False:End If:If Err Then es=False:End If:On Error GoTo 0:If es Then Set z=sdb.ui.AddMeNuitEM(e9,0,0):z.CApTion=SDB.LocaliZE("Search Current Tracklist"):z.HiNT="Find"&d&" in the current tracklist":z.onclICkfuNc="l6":z.UsescriPt=script.scRIPTPatH:Set z=SDB.uI.AddmENuitEm(c9,0,0):z.CaPtIoN=sDB.lOcaLIze("Find Duplicate Titles and Select Max. Bitrate/Ext."):z.HinT="Find duplicate Titles from same Artists and select tracks with maximal Bitrate or specified extension":z.onclIckFUNC="ft":z.UsescrIPt=ScriPt.ScRIptPATH:If g.bOOlvalUe("TrackRedirection","HideMenuFindDuplicateTitles")Then z.visIbLE=False:End If:Set z=SDb.Ui.ADDMeNUIteM(c9,0,0):z.captIoN=sdB.lOCAlIZE("Select Duplicates Using Specified Crtiteria"):z.hint="Select tracks with same Artist and Title using a criteria specified in the Options dialog box; it could be a maximal Bitrate or list of extensions":z.OnCliCkfunc="cp":z.uSEscRipt=SCrIPT.SCRiPTpATh:If g.bOOlValuE("TrackRedirection","HideMenuSelectDuplicatesCriteria")Then z.VISiBLe=False:End If:Set e9=Sdb.Ui.AdDMEnuitEmsUb(c9,0,0):e9.CApTiOn=SDB.localIZE("Select Linked Tracks"):If g.bOOlvAluE("TrackRedirection","HideMenuSelectLinkedTracks")Then e9.ViSIblE=False:End If:Set z=sdb.UI.aDDmEnuiTem(e9,0,0):z.CApTioN=SDB.lOCaLiZe("Masters"):z.hINT="Select master tracks":z.onClIcKfUnC="c1":z.UsEscRiPt=scRIPT.scrIpTpaTh:Set z=sdb.uI.AddmenUiTEm(e9,0,0):z.caPTiOn=Sdb.locaLIZE("Redirected"):z.hInt="Select redirected tracks":z.OncliCKfUnc="by":z.usEScRiPT=ScRipt.scriPtPAtH:Set z=sDb.UI.AdDmENUITEM(e9,0,0):z.CAPTION=sdb.LoCAlIze("All Linked"):z.HINt="Select masters and redirected tracks":z.oNCLICKFunC="e2":z.USEsCripT=ScRIPT.sCriPtPAth:Set z=SDb.uI.ADDMeNuITeM(c9,0,0):z.cAPtioN=Sdb.locaLIZe("Select Unsynchronized Master Tracks"):z.HinT="Select master tracks with metadata different from redirected ones":z.ONCliCkFuNc="hn":z.uSeScriPT=SCriPt.ScRipTPATH:If g.BoolvALuE("TrackRedirection","HideMenuSelectUnsynchronized")Then z.vIsiblE=False:End If:Select Case iz:Case"NPPopup":d="Now Playing List":Case"Main":d="Tracklist/NP List":Case Else d="Tracklist":End Select:d=" the "&d:Set z=SDB.Ui.addmEnuItEM(c9,0,0):z.CaPtION=sdB.LoCalIzE("Remove Duplicates from"&d):z.HiNt="Remove duplicates from"&d&" and keep tracks with maximal bitrate or master tracks which are already referenced":z.ONCLIckFUNc="iv":z.USEscRipt=SCRIPt.SCRiptPaTH:If g.BoOLvALue("TrackRedirection","HideMenuRemoveDuplicates")Then z.visIBLE=False:End If:Set e9=sdB.ui.ADDmENUItEmsUB(c9,0,0):e9.caPTION=SDB.LOCAlIZe("Remove Linked Tracks from"&d):If g.BoOLVAlue("TrackRedirection","HideMenuRemoveLinkedTracks")Then e9.VISiBle=False:End If:Set z=sdb.ui.aDdMeNuiTem(e9,0,0):z.CApTIon=sDb.LOCAlIze("Masters"):z.HiNt="Remove master tracks from"&d:z.oNclIcKfunc="cc":z.uSEscRipT=ScrIpT.SCrIPTPatH:Set z=SDB.uI.AdDMEnUItEm(e9,0,0):z.cAptiON=SDB.LOCAlIze("Redirected"):z.HinT="Remove redirected tracks from"&d:z.oNcliCkfUNC="d2":z.usESCRIPT=SCRIPT.sCriPtpatH:Set z=sdB.ui.AddMenuiTem(e9,0,0):z.CapTioN=SDb.LOcalizE("All Linked"):z.HINT="Remove masters and redirected tracks from"&d:z.oNCLiCkfunC="ad":z.usEScriPT=SCrIpT.scrIpTpatH:Set e9=sdb.uI.ADdMeNUITeMSUB(c9,0,0):e9.capTIon=SDb.LOCalize("Keep Only Linked Tracks in"&d):If g.BoOLvaLUE("TrackRedirection","HideMenuKeepLinkedTracks")Then e9.vISibLE=False:End If:Set z=SdB.ui.aDdmEnUITEm(e9,0,0):z.capTIOn=SDb.LocaliZE("Masters"):z.hint="Keep only master tracks in"&d:z.oNClICKFUnC="j2":z.USEsCrIPt=scRIPt.scRIpTPath:Set z=sdb.Ui.AddmENUiTem(e9,0,0):z.capTiOn=sdB.LoCAliZE("Redirected"):z.hInT="Keep only redirected tracks in"&d:z.ONClIckfunC="jo":z.uSEscrIpt=sCrIPT.scRiptPatH:Set z=SDb.UI.aDdMenUitEM(e9,0,0):z.CAptIoN=Sdb.loCAliZE("All Linked"):z.HinT="Keep only masters and redirected tracks in"&d:z.onClicKFUnc="e7":z.USesCript=ScriPT.sCrIPTPATh:If Not g.bOOLVAlUE("TrackRedirection","HideMenuReplaceWithAlbumTrack")Then Set z=SdB.ui.ADdMENUITEm(c9,0,0):z.CaPtion=sDb.LOcAlize("Replace with Duplicates from Another Albums"):z.HiNT="Replace selected tracks in tracklist or Now Playing list with duplicated ones from another Albums":z.oncLickfUnc="ReplaceWithAlbumTrack"&iz:z.USEscRIpT=sCrIpt.sCRipTpATH:sDB.oBjeCtS("mnu"&iz&"ReplaceWithAlbumDups")=z:z.ViSIBle=False:Set z=SdB.uI.aDDmeNUitemsUB(c9,0,0):z.CAPtiOn=SDb.loCalIze("Replace with Duplicate from Album"):z.hInt="Replace selected track in tracklist or Now Playing list with the duplicated one from Album":z.oncLicKFunc="ReplaceWithAlbumTrack"&iz:z.USescRIPt=sCRipt.SCRIPtpAth:sDb.oBJecTS("mnu"&iz&"ReplaceWithAlbumTrack")=z:End If:If Not g.boOLVaLUE("TrackRedirection","HideMenuReplaceWithLinkedTrack")Then Set z=SdB.UI.aDDmENuITeM(c9,0,0):z.cAPtIon=sdB.lOcAlize("Replace with Linked Tracks"):z.hInT="Replace selected tracks in tracklist or Now Playing list with the linked ones (master or redirected)":z.OnclIcKfunc="ReplaceWithLinkedTrack"&iz:z.UseScRIPT=scRIPt.ScRIptpATh:sdB.oBJEcts("mnu"&iz&"ReplaceWithLinkedDups")=z:z.VIsIbLE=False:Set z=sDB.ui.aDDmEnUITemSUb(c9,0,0):z.caPTiOn=sdb.LOcalIzE("Replace with Linked Track"):z.hINt="Replace selected track in tracklist or Now Playing list with the linked one (master or redirected)":z.ONcLiCkfuNc="ReplaceWithLinkedTrack"&iz:z.uSesCRipT=scrIpt.SCRipTPAtH:sdb.objECTs("mnu"&iz&"ReplaceWithLinkedTrack")=z:End If:End If:Set z=sDb.UI.aDdMenuitEmSEp(c9,0,0):Set z=SdB.uI.addMEnUItEM(c9,0,0):z.capTioN=SdB.LOcALIzE("Create Redirections for Specified Tracks..."):z.Hint="Create redirections for an existing album or unselected tracks with same Artist and Title as selected ones and update the Library":z.ONclICkFUnc="i7":z.uSEsCRIPt=ScrIpT.ScrIpTPaTH:sdb.OBJECts("mnu"&iz&"CreateTrackRedirections")=z:If g.boolvALUE("TrackRedirection","HideMenuCreateTrackRedirections")Then z.VISiblE=False:End If:es=True:On Error Resume Next:If sDb.VErSionBUilD<1208 Then es=False:End If:If Err Then es=False:End If:On Error GoTo 0:If es Then Set z=sDB.Ui.ADdmeNuITEM(c9,0,0):z.cAPTion=SdB.LoCaliZe("Create Redirections/Copy Metadata..."):z.hiNT="Create redirections or copy metadata for tracks with same Artist and Title or for specified foder and its sub-folders and update the Library":z.onCliCKfUNC="hm":z.usEsCrIPT=ScRIPT.SCRipTpAth:sDb.objEcts("mnu"&iz&"CreateDuplicateRedirections")=z:If g.BOOlvALUE("TrackRedirection","HideMenuCreateDuplicateRedirections")Then z.VIsIbLe=False:End If:End If:Set z=SDB.Ui.ADDMenUitEm(c9,0,0):z.CaPTion=sdb.localIze("Add/Rescan .asx Files to the Library..."):z.HInt="Scan for existing .asx files and add or update them in the Library":z.OnCLiCkfuNC="b8":z.UseScRiPT=scrIPt.scriPtPath:If g.boOlvaLUE("TrackRedirection","HideMenuAddRescanAsxFiles")Then z.VIsible=False:End If:Set z=SDB.Ui.AdDmEnuITEm(c9,0,0):z.CAPTIoN=sDb.lOcALIze("Synchronize Metadata of .asx Files"):z.hINT="Update metadata of selected .asx files to match the Library":z.OnCLICKFUnC="b6":z.uSesCriPT=SCrIPT.SCRIPtpATh:sdb.OBJEcts("mnu"&iz&"SynchronizeAsxMetadata")=z:If g.bOolValue("TrackRedirection","HideMenuSynchronizeAsxMetadata")Then z.visibLe=False:End If:Set z=SDB.UI.AdDMeNuITEM(c9,0,0):z.CaptIon=Sdb.localIZe("Synchronize References in .asx Files"):z.HInt="Update paths for tracks referenced in .asx files to match the Library; it could be used after changing of the ""Save references with relative paths"" option":z.ONClICkfUNC="hg":z.uSEScript=scrIPt.sCriPTpAtH:If g.bOOLvalue("TrackRedirection","HideMenuSynchronizeAsxReferences")Then z.vIsiBLE=False:End If:Set z=SdB.Ui.addmenuiTEM(c9,0,0):z.cAptiON=sDB.loCAlize("Edit .asx File with Notepad..."):z.hint="Edit .asx file with Notepad and update the Library (metadata could be changed with the Properties dialog as well)":z.oNclIcKfunc="g5":z.USeSCript=Script.SCriptPAtH:Sdb.ObJectS("mnu"&iz&"EditAsxFileWithNotepad")=z:If g.boolvaLue("TrackRedirection","HideMenuEditAsxFileWithNotepad")Then z.viSible=False:End If:Set z=SDb.uI.ADdmeNUITem(c9,0,0):z.cAptiOn=sDb.LOcaliZE("Assign Redirections to the .asx Files"):z.HiNT="Update the Path information in the Library with the corresponding .asx file(s) from same folder as selected track(s)":z.onCliCKFuNC="br":z.USEsCRipt=sCRipT.ScriPtPaTH:SDb.OBJEcts("mnu"&iz&"AssignRedirections")=z:If g.BoolvALue("TrackRedirection","HideMenuAssignRedirections")Then z.vISIblE=False:End If:Set z=sdB.ui.AddMENUIteM(c9,0,0):z.cApTion=sDB.locALize("Remove Redirection from the Track"):z.hINT="Remove redirection from the selected track and resume the Path information in the Library with the corresponding audio file from same folder in case that .asx file is selected":z.onClIckfunc="j7":z.usesCriPT=sCRIpt.sCRIPTpATh:sdb.oBjects("mnu"&iz&"RemoveRedirection")=z:If g.bOOlVaLue("TrackRedirection","HideMenuRemoveRedirection")Then z.vISiBLe=False:End If:Set z=SDb.Ui.adDmenuItEm(c9,0,0):z.cAPtION=sdB.localizE("Transfer Redirected Playstats to Master Tracks"):z.hINt=sDB.locALIzE("Transfer existing playcounts and play dates from selected tracks or all redirected tracks to their corresponding masters"):z.oncLicKfUNc="kr":z.USeScrIPt=scRiPT.scRIptpAtH:sdb.OBJectS("mnu"&iz&"TransferRedirectedPlaystats")=z:If g.bOolVaLue("TrackRedirection","HideMenuTransferRedirectedPlaystats")Then z.VISiBle=False:End If:Set z=sDB.UI.adDMENUiteM(c9,0,0):z.caPTiON=SDB.lOcaliZE("Synchronize Metadata of Redirected Tracks"):z.hint=SDb.loCaliZE("Update metadata of linked tracks to match the selected ones or update all redirected tracks to match their corresponding masters"):z.oNCLICkFUNC="a9":z.USEsCRIpt=scrIPT.scriPTPaTH:If g.BoolVaLUe("TrackRedirection","HideMenuSynchronizeRedirectedMetadata")Then z.VisIbLE=False:End If:If es Then Set z=sDb.uI.addmENuItem(c9,0,0):z.CapTiOn=sDb.locAlIze("Maintain Redirections..."):z.hInT="Show table of redirections and allow some operations on them (remove, transfer playstats, synchronize)":z.oNCliCKfunc="fg":z.usescript=SCRIPT.SCRIPtPaTh:If g.boolvalUe("TrackRedirection","HideMenuMaintainRedirections")Then z.VisIBlE=False:End If:End If:Set z=sdB.ui.ADdmEnUItEMseP(c9,0,0):Set z=SDb.uI.aDDMEnUiTEm(c9,0,0):z.CaptIon=SdB.locAliZE("Options..."):z.iCOnINdEX=27:z.ONclICKFunC="ai":z.UsEsCRipT=SCRiPT.sCRiptpatH:End Sub:Function ej(ei):Dim fo,fi,js,cx,bv:If Len(ei)Then fo=Split(ei,"\"):Set fi=SdB.plAYlistBYTitLE(""):For cx=0 To UBound(fo):Set js=fi.CHIlDPlAYlIsTS:bv=0:Do:If bv>=js.Count Then Set fi=fi.CreATECHIlDPLAyLiST(fo(cx)):Exit Do:Else If js.Item(bv).TITLe=fo(cx)Then Set fi=js.Item(bv):Exit Do:End If:End If:bv=bv+1:Loop Until bv>js.Count:Next:Else Set fi=Nothing:End If:Set ej=fi:End Function:Function e0(j9,kq,q,t):Dim al,cl,r,u,b,ky:For Each cl in j9.fileS:r=cl.paTh:If LCase(Right(r,4))=".asx"Then u=f0(r):If Len(u)Then t.texT="Updating library for: "&r:If eb(r,u,kq,q)Then ky=ky+1:End If:End If:End If:sDB.prOcesSmESsAgeS:If t.tErmINatE Then e0=-ky:Exit Function:End If:Next:For Each al In j9.SubfoLdErS:b=e0(al,kq,q,t):If b<0 Then e0=-ky+b:Exit Function:Else ky=ky+b:End If:Next:e0=ky:End Function:Sub dk(h):cg=h.TEXt:End Sub:Sub ReplaceWithLinkedTrackNPList(jb):l2 jb,"Linked","NPList":End Sub:Sub hm(jb):Dim c,h,jk,ki,kb,kh,g6,fv,gg,dy,bg,jz,q,kq,ge,ar,g,kg,fl,bh,b3,dl,h0,kt,io,k,y,gq,t,o,cx,bv:Set g=SDB.iNIFILe:Set c=sdb.uI.NewFORM:dy=c.commOn.wiDth-c.COmmOn.ClIENTwIdtH:bg=c.CoMMON.heIgHt-c.CoMmoN.CLiENTHEIgHt:c.COMMoN.setrECt 100,100,700+dy,370+bg:c.coMMon.MInwIdTH=680:c.CommON.miNheighT=250:c.fOrmPoSitIOn=ay:ci=SdB.localIZe("Create Redirections/Copy Metadata for Duplicates/Folders"):c.CAPtion=ci:Set ki=SDB.UI.NewgRoUpBoX(c):ki.COmMon.SEtRecT 10,10,190,76:Set kb=Sdb.Ui.nEWRaDIoBuTToN(ki):kb.COmmoN.setReCT 10,3,160,20:kb.cApTiON=sdB.LOCalIzE("Replace with .asx metafiles"):sCRIPt.RegiSTerEVent kb.CoMMoN,"OnClick","gs":Set hr=sdB.ui.neWcHeckBox(ki):hr.comMon.sETreCT 25,28,130,20:hr.CAPtion=sDB.LocALize("and delete audio files"):ScRIpt.reGISterEvEnt hr.cOMMOn,"OnClick","go":hr.chEcKeD=g.bOolvALue("TrackRedirection","DeleteAudioFiles"):Set kh=sdb.uI.NeWRadiObUTtON(ki):kh.CoMmon.setrecT 10,53,175,20:kh.cAPtioN=sdB.loCaLizE("Create links between audio files"):sCRiPt.REGIstEReveNt kh.cOMMON,"OnClick","k8":Set ki=Sdb.uI.NEWgrOupbOX(c):ki.CoMmON.SETrECT 210,10,160,76:Set h=sdB.Ui.newlaBEl(ki):h.cOmmoN.SETREcT 10,6,130,17:h.AuTOSizE=False:h.captiOn=SDB.LocALizE("When create redirection:"):dz=g.bOoLvALUE("TrackRedirection","SyncPlaystat"):Set j6=sdb.UI.NEwCHECkBOx(ki):j6.COMMOn.sEtrEcT 25,28,125,20:j6.CAptiON=sDB.lOCALIZE("transfer playstats"):If dz Then j6.comMoN.EnAbled=False:Else scrIPT.REGiSTeREVEnt j6.coMMOn,"OnClick","aq":j6.ChECKEd=g.boOlvaLuE("TrackRedirection","TransferPlaystatsOnCreate"):End If:Set av=sdb.Ui.NEWchecKboX(ki):av.CoMmon.SETReCt 25,53,125,20:av.captioN=sdB.lOCalizE("synchronize metadata"):scrIPt.REgIsTErevenT av.coMMOn,"OnClick","ab":av.CHEcKeD=g.BoOlVALuE("TrackRedirection","SynchronizeOnCreate"):Set ki=sDB.Ui.NewgRoUpbOX(c):ki.coMmOn.SeTRECt 380,10,310,76:ki.CommOn.aNcHoRS=1+2+4:Set g6=SdB.Ui.newraDioBUTtoN(ki):g6.COmmoN.SETReCt 10,3,70,20:g6.CAPtiOn=Sdb.locaLIzE("Duplicates"):scrIpt.REgIstEReveNt g6.COMMoN,"OnClick","aj":On Error Resume Next:If SdB.Ui.mAINwiNdoWFOCUs<>4 Then gq="main tracklist":Else gq="Now Playing panel":End If:On Error GoTo 0:Set du=SDb.uI.neWcHeckboX(ki):du.cOMMon.seTRect 90,3,190,20:du.CAPtIOn=sdb.LocAlIZE("only for "&SdB.SeleCtEdSONGLIST.Count&" selected in "&gq):scRiPt.rEgisteReveNt du.ComMoN,"OnClick","hc":Set gm=sDB.ui.newcheCKbOx(ki):gm.comMOn.SeTrEct 290,3,90,20:gm.CApTIoN=sDB.lOcaliZE("Filtered tracks"):ScrIPT.reGIStErEVeNt gm.cOMMON,"OnClick","ec":Set fv=Sdb.ui.nEWrADiOBuTtON(ki):fv.coMMoN.setrEct 10,28,60,20:fv.cAPtion=sDb.loCalIzE("Folders"):scRipT.reGISterEvEnt fv.CoMMOn,"OnClick","jt":Set h=sDB.Ui.NEWlabEl(ki):h.cOMmON.setReCT 90,31,30,20:h.cAPtiOn=sdB.lOcalIze("Master:"):Set hd=SdB.ui.newEDIt(ki):hd.COMmon.SeTrect 134,27,150,21:hd.COmmOn.anCHors=1+2+4:ScrIPT.rEgistEreVENt hd,"OnChange","bf":Set dq=sDb.UI.NEwBUttoN(ki):dq.COMmoN.sETrECT 284,27,21,21:dq.cAption="...":dq.cOMMon.ancHORs=2+4:scRIpt.rEGIStEReVeNt dq,"OnClick","d3":Set h=Sdb.ui.nEwlABel(ki):h.COMmOn.SeTRECT 90,56,30,20:h.CAPTION=Sdb.localiZE("Copy:"):Set gf=Sdb.UI.nEweDIT(ki):gf.cOmMON.SeTReCT 134,52,150,21:gf.CoMMoN.AnchoRs=1+2+4:SCript.rEgisTERevenT gf,"OnChange","bc":Set ba=SdB.uI.neWbUtTOn(ki):ba.comMoN.seTRECt 284,52,21,21:ba.CAPtIon="...":ba.CoMMon.ANChorS=2+4:ScrIPT.rEgISTereVEnt ba,"OnClick","dr":Set p=Sdb.Ui.NEWTreeLiSt(c):p.CommON.seTRect 10,95,680,235:p.heAdeRVisIbLe=True:p.HeaDeRaDDCOLuMn"":p.HeaDERAdDcolUmN"Artist":p.hEaDERaDDCOLuMn"Title":p.hEAdErAdDcolumn"Master Album":p.heADeRAddCOlumn"Master Track":p.heAdeRAddcOlumn"Redirecting Album":p.HeadErAdDCOlUmN"Redirecting Track":p.HeadErCoLUmNwIDTh(0)=50:p.heaDeRcOLUMNwIDTH(1)=80:p.hEADerColuMnWIdTh(2)=80:p.HeaDErcOlUmNWIDtH(3)=80:p.HeAdERcoLumNWidTh(4)=160:p.HEADeRcoluMnwIdtH(5)=80:p.HEAdErcOlUmNwIDTh(6)=160:p.rOOTnoDEcOunt=0:p.ShOwtrEElINES=False:p.iNdent=0:p.FULLrowSeLECt=True:p.eXtEndEdfocus=False:p.mULtIsELeCt=False:p.gRidextEnSIonS=False:p.sHoWrOoT=False:p.COMmON.AnCHOrS=1+2+4+8:p.COmmON.CONTROlNAme="lvw_Table":sCRIpt.rEgISTeREVENT p,"OnGetText","f3":scrIpT.rEgISTeReVeNt p,"OnChecked","at":scrIpT.reGiSTEREvEnt p,"OnFocusChanged","bz":ScRIPt.rEgistEREvenT c.CoMmON,"OnResize","el":Set jk=sdB.uI.NeWcheCKbOx(c):jk.cOMmOn.SetreCt 20,104,26,17:jk.caPTIOn="#":ScrIpT.RegistERevEnT jk.cOMmON,"OnClick","bo":Set gg=SDb.ui.NewbuTTon(c):gg.CApTION=SdB.locALize("S&elect unsync"):gg.CoMMon.hiNT="Select redirections with unsynchronized metadata":gg.cOmmOn.seTRECT 10,337,73,25:gg.CoMMON.anchORs=1+8:gg.cOMMoN.EnAblEd=False:sCRIPt.rEGiStEreveNt gg.CoMMON,"OnClick","b4":Set sDB.ObJEcTS("btnRedirUnsync")=gg:Set ea=sDB.Ui.newBUtton(c):ea.CapTIon=sdB.lOcalizE("S&wap"):ea.coMMON.HiNT="Swap selected masters and redirecting tracks":ea.cOMmON.SetrEcT 90,337,73,25:ea.cOMMon.anCHOrS=1+8:ea.ComMON.EnAbLEd=False:SCriPt.REgisteReVENT ea.cOMmoN,"OnClick","it":Set dc=SDb.ui.newLABEL(c):dc.COmmON.SeTreCt 167,343,50,17:dc.autosize=False:dc.aLIGNMeNT=2:dc.cOmmoN.ANcHORS=1+8:Set hb=sDb.UI.NeWPANEL(c):hb.CoMmoN.setRect 220,337,150,25:hb.CoMMoN.aNcHoRs=1+4+8:hb.COmMON.visibLe=False:Set i8=sDb.ui.nEWlabel(hb):i8.comMOn.SeTReCt 6,5,138,17:i8.auTOSiZe=False:i8.cOMmOn.AnCHors=1+4:Set k3=sdB.ui.newBUttoN(c):k3.CApTion=SdB.localIze("&Transfer ps."):k3.COMMON.HinT="Transfer playcounts and play dates from redirecting tracks to their corresponding masters":k3.comMon.SETrect 377,337,73,25:k3.comMOn.anchOrS=4+8:k3.ModalREsuLt=3:k3.comMON.enABlED=False:Set cj=SdB.UI.nEWBUttON(c):cj.CAPtiOn=sDb.LocaLIze("&Synchronize"):cj.COmMoN.hiNt="Update metadata of redirecting tracks to match their corresponding masters":cj.COMMon.SEtrEct 457,337,73,25:cj.cOmmon.aNcHOrS=4+8:cj.moDalresulT=4:cj.cOMmOn.enAbleD=False:Set im=SDB.Ui.NEWbUTTON(c):im.cAPtIOn=SdB.LoCalizE("C&reate"):im.cOmMon.hiNT="Create redirections for selected tracks":im.coMmoN.seTrEcT 537,337,73,25:im.coMMON.aNCHORs=4+8:im.moDALRESULt=1:im.CoMMON.eNabLeD=False:Set gu=sDb.Ui.NewbUtToN(c):gu.capTiON=sdb.LocAliZE("&Close"):gu.cOmMOn.Setrect 617,337,73,25:gu.CommoN.anChoRS=4+8:gu.Default=True:gu.cAnCel=True:gu.MODalREsUlT=2:If Sdb.inIfIle.boOlvAlUE("TrackRedirection","AudioFileRedirect")Then kh.cHeCked=True:k8 kh:Else kb.cheCked=True:gs kb:End If:ey=True:If sDb.inifile.BOolVALuE("TrackRedirection","RedirectFolders")Then fv.ChEcKed=True:Else g6.ChECkeD=True:End If:ey=True:du.ChECkeD=g.boolvAlUE("TrackRedirection","SelectedDuplicatesOnly"):a4=Sdb.DaTabAse.opeNSQl("SELECT Name FROM Filters WHERE ID ="&SDB.DATabasE.AcTiVEfiltErid).strinGbyINdEx(0):If Len(a4)=0 Then gm.cOmMOn.EnablEd=False:cw=False:End If:ey=True:gm.CheCkeD=g.BOolvalue("TrackRedirection","FilteredDuplicatesOnly"):gn="":l5="":ey=True:hd.TExt=g.StrIngValUE("TrackRedirection","MasterFolders"):ey=True:gf.teXt=g.sTRiNgvaLUe("TrackRedirection","CopyFolders"):ey=False:jx:c.sAVEposItIOnnaME=ci:jz=c.ShOWmODal:ScRIPT.UnREGIstEreVEnTs c.commoN:Set gu=Nothing:Set im=Nothing:Set cj=Nothing:Set k3=Nothing:Set SdB.OBJECTS("btnRedirUnsync")=Nothing:Set ea=Nothing:Set p=Nothing:SDB.InIFIlE.BOolVALue("TrackRedirection","RedirectFolders")=h1:sDB.INIfiLE.BOoLVAluE("TrackRedirection","SelectedDuplicatesOnly")=f6:Sdb.iNiFIlE.BOOLVALue("TrackRedirection","FilteredDuplicatesOnly")=cw:If h1 Then Sdb.InIfIlE.sTrinGvALUe("TrackRedirection","MasterFolders")=gn:Sdb.iNiFIle.stringvaLUe("TrackRedirection","CopyFolders")=l5:End If:If i3 And jz<>2 Then gq="Are you sure you want to ":Select Case jz:Case 1:gq=gq&"create redirection":Case 3:gq=gq&"transfer playstats":Case 4:gq=gq&"synchronize metadata":End Select:If sdB.MESsAgEbOx(gq&" for "&i3&" selected track pair"&dp(i3>1,"s?","?"),MTcONFirMaTiON,Array(mbyeS,MbnO))=mRYES Then Select Case jz:Case 1:sDb.InifILe.BOolvALUe("TrackRedirection","AudioFileRedirect")=fm:Sdb.InIfIlE.bOOlVaLUe("TrackRedirection","DeleteAudioFiles")=dj:Sdb.INIFilE.BoOLVAluE("TrackRedirection","TransferPlaystatsOnCreate")=bn:SDb.iNifiLe.BoOlValUe("TrackRedirection","SynchronizeOnCreate")=fn:c5=i3:iy=False:Call e1(c6,gh,True,bn,fn,g):Case 3,4:fl=aw:aw=True:Set q=New RegExp:kq=jl.keYS:Set ge=SdB.ToOls.FileSystem:Set ar=CreateObject("Scripting.FileSystemObject"):dl=g.bOOLvAluE("Options","StoreID3AfterEdit"):kg=g.iNtvaluE("TrackRedirection","AsxFileFormat"):h0=g.BOolVaLue("TrackRedirection","SyncAlbumArt"):kt=g.inTVALUE("TrackRedirection","AlbumArtStorage"):io=g.stRIngvAluE("TrackRedirection","AlbumArtFileName"):bv=0:Set t=Nothing:o=4+CLng(Timer*10):For cx=0 To UBound(s,2):If s(0,cx)=1 Then Set k=c6.Item(CStr(cx)):Set y=gh.Item(CStr(cx)):If jz=4 Then aa k,y,dl,dz,q,kq,ge,g,kg,h0,kt,io,ar,t:Else l0 y,k,dl,True,q,kq,ge,kg:End If:bv=bv+1:If o<CLng(Timer*10)Then o=1+CLng(Timer*10):SDB.pROCESsMesSaGEs:If t Is Nothing Then Set t=sdb.pROGRESs:t.MAXvALUe=i3-1:Else If t.TeRMInATe Then Exit For:End If:End If:t.Value=cx:t.TExt="Updated "&bv&" of "&i3&" selected tracks":End If:End If:Next:aw=fl:End Select:End If:End If:ey=False:End Sub:Function g9(l,f,bv,ge):Dim ck,dm,a0,i5,u,m:u="":Set i5=l.AlbuMArT.Item(bv):If i5.ITemSToragE=0 Then Set ck=i5.IMagE:dm=Left(f,InStrRev(f,"."))&bv+1&"."&cs(ck.ImAgEForMAT,"([^/-]+)$",0):Set a0=ge.CREaTeTExtfILe(dm,True):If a0 Is Nothing Then Exit Function:End If:a0.wRiTEdaTa ck.iMaGEDaTA,ck.ImaGedAtaLeN:a0.cLoSE:dm=Mid(dm,InStrRev(dm,"\")+1):Else If Len(i5.reLAtiVepICtUrEPATh)Then dm=i5.ReLAtiVEPiCtUrePatH:Else If Len(i5.PicTUrEPATh)Then dm=i5.PiCTuRePaTh:Else Exit Function:End If:End If:End If:u=u&"    <BANNER HREF = """&dm&""">"&vbNewLine:m=i5.Description:If Len(m)>0 Then u=u&"      <ABSTRACT>"&m&"</ABSTRACT>"&vbNewLine:End If:u=u&"  "&c3("Item Storage",i5.itemsTOragE):u=u&"  "&c3("Item Type",i5.itemTyPE):u=u&"    </BANNER>"&vbNewLine:g9=u:End Function:Sub k8(h):fm=True:hr.coMMOn.enaBLed=False:End Sub:Sub ReplaceWithLinkedMain(jb):Dim hf,cx:hf=sDB.obJecTs("colReplaceWithLinkedMain").keyS:For cx=0 To sdb.ObJEcTs("colReplaceWithLinkedMain").Count-1:If jb Is SDB.OBJectS("colReplaceWithLinkedMain").Item(hf(cx))Then f2"Linked","Main",hf(cx):Exit For:End If:Next:End Sub:Function fz(h6):fz=Replace(h6,"'","''"):End Function:Sub a3(f9,g4,d):Dim cx,k9:For cx=0 To g4.Count-1:If Not g4.Item(cx).iSAutoPlaYlIST Then k9="":k9=k9&g4.Item(cx).TiTle:If Not f9.exIsTS(k9)Then f9.AdD k9,g4.Item(cx).iD:End If:End If:Next:End Sub:Sub ht(w,cn):Dim a,g,gq,dl,ic,dz,fl,kq,v,x,cx:Set g=SDb.InIfiLE:dl=g.BoOLvAlUE("Options","StoreID3AfterEdit"):ic=g.BOOLvalUE("TrackRedirection","SyncMetadataMasterOnly"):dz=g.bOolVAlUe("TrackRedirection","SyncPlaystat"):gq="Do you want to synchronize metadata for"&vbCr:If w.Count>0 Then gq=gq&"linked tracks to match the selected ones or"&vbCr:End If:Select Case sdB.MeSsAgEBOx(gq&"all redirected tracks to match their masters?",MTconFiRmATioN,dp(w.Count>0,Array(mbyeS,mByeStoAlL,mBcaNcEl),Array(MByestOALl,dp(cn,mbNo,MbCAncel)))):Case MRYEs:fl=aw:aw=True:ak w,dl,False,True,ic,dz,False:aw=fl:Case mRYeStoalL:If dl Or g.BOOlvalue("TrackRedirection","SyncAlbumArt")Then x="ID IN (SELECT IDref FROM TrackRedirection)":bi x,True,dz:Else kq=ji.KEyS:For cx=0 To ji.Count-1:v=ji.Item(kq(cx)):If g.bOOlvaLuE("TrackRedirection","Sync"&v)Then x=x&"Songs."&v&" = (SELECT S1."&v&" FROM Songs AS S1 INNER JOIN TrackRedirection ON S1.ID = TrackRedirection.IDref WHERE TrackRedirection.IDasx = Songs.ID), ":End If:Next:If dz Then x=x&"Songs.PlayCounter = (SELECT S1.PlayCounter FROM Songs AS S1 INNER JOIN TrackRedirection ON S1.ID = TrackRedirection.IDref WHERE TrackRedirection.IDasx = Songs.ID), Songs.LastTimePlayed = (SELECT S1.LastTimePlayed FROM Songs AS S1 INNER JOIN TrackRedirection ON S1.ID = TrackRedirection.IDref WHERE TrackRedirection.IDasx = Songs.ID), ":End If:If Len(x)Then SDb.DatAbaSE.BegiNTraNSacTION:sdb.daTaBASe.eXECSqL"UPDATE Songs SET "&Left(x,Len(x)-2)&" WHERE ID IN (SELECT IDasx FROM TrackRedirection)":SdB.DATabAse.coMmIt:SDb.mAinTRackSWinDow.rEfReSH:If g.BOOLVALUE("TrackRedirection","LogReport")Then jh Now&" - Metadata synchronization for all redirected tracks":End If:End If:End If:Case Else Exit Sub:End Select:End Sub:Sub jd(w,ii,bj):Dim l,d6,a,y,r,kg,u,f,q,ij,h4,g7,t,o,gc,cx,bv:If bj Then g7=sDB.inIFILe.boOLVaLUE("TrackRedirection","RelativePaths"):kg=Sdb.inifiLe.inTvALue("TrackRedirection","AsxFileFormat"):Set q=New RegExp:q.Pattern="(<REF HREF ?= ?"")(.*)("" />)":gc=w.Count:Set t=Nothing:o=4+CLng(Timer*10):For cx=0 To w.Count-1:Set l=w.Item(cx):If LCase(Right(l.PatH,4))<>".asx"Then d6=ii.Item(cx):Set a=sDb.DATAbaSE.QuErYsOnGs("ID = (SELECT IDasx FROM TrackRedirection WHERE IDref = "&l.Id&")"):Do While Not a.eOf:Set y=a.Item:r=y.patH:If LCase(Right(r,4))=".asx"Then u=f0(r):If Len(u)Then Set ij=q.Execute(u):If ij.Count>0 Then If g7 Then d6=ch(d6,Left(r,InStrRev(r,"\"))):End If:If LCase(ij.Item(0).SubMatches.Item(1))<>LCase(d6)Then u=q.Replace(u,"$1"&d6&"$3"):Call iw(r,u,kg):End If:End If:End If:End If:a.Next:Loop:Else If g7 Then r=l.pAtH:d6=ii.Item(cx):u=f0(r):If Len(u)Then Set ij=q.Execute(u):If ij.Count>0 Then Set a=sdb.dATaBasE.QUerySonGs("ID = (SELECT IDref FROM TrackRedirection WHERE IDasx = "&l.Id&")"):If Not a.EOF Then Set l=a.Item:d6=ch(l.Path,Left(d6,InStrRev(d6,"\"))):If LCase(ij.Item(0).SubMatches.Item(1))<>LCase(d6)Then u=q.Replace(u,"$1"&d6&"$3"):Call iw(r,u,kg):End If:End If:End If:End If:End If:End If:If o<CLng(Timer*10)Then o=1+CLng(Timer*10):SDb.proceSSmessAges:If t Is Nothing Then Set t=Sdb.pRoGrEsS:t.mAXvaluE=gc-1:Else If t.terminATe Then Exit For:End If:End If:t.Value=cx:t.Text=cx&"/"&gc:End If:Next:Set a=Nothing:End If:End Sub:Sub ReplaceWithLinkedNPList(jb):Dim hf,cx:hf=Sdb.ObjECTS("colReplaceWithLinkedNPList").kEyS:For cx=0 To sdb.OBJEctS("colReplaceWithLinkedNPList").Count-1:If jb Is sDb.OBJECtS("colReplaceWithLinkedNPList").Item(hf(cx))Then f2"Linked","NPList",hf(cx):Exit For:End If:Next:End Sub:Dim cr:Set cr=CreateObject("Scripting.Dictionary"):With cr:.add"Date","0":.adD"Rating",-1:.aDD"Length",-1:.ADd"Track Volume",-999999:If sdB.VeRsionHI>=3 Then .aDd"Album Volume",-999999:End If:.ADD"Bitrate",-1:.adD"File size",-1:.add"Timestamp",#12/29/1899#:.add"Added",#12/29/1899#:.AdD"Played #",0:.ADD"Last Played",0:.aDD"BPM",-1:.Add"Sample Rate",-1:.ADD"Channels",-1:.Add"Original Date","-1":.aDD"VBR",-1:.add"Peak Value",-1:End With:Sub cc(jb):ib" = IDref",False:End Sub:Sub b1(h):h.coMMON.PAREnt.cOMMoN.cHIldcONtROl("DuplicatesExtList").coMMoN.enAblEd=h.ChEcKEd:End Sub:Sub ReplaceWithAlbumTrackNPPopup(jb):l2 jb,"Album","NPPopup":End Sub:Sub ad(jb):ib" IN (IDasx, IDref)",False:End Sub:Sub dr():Dim g1,d5:If Len(gf.tEXt)Then g1=gf.TexT:Else g1=sDb.InIFILE.STrINgvALue("Scripts","LastExportM3UsDir"):End If:d5=sdB.SeLECtFoldEr(g1,sdb.lOcaLIze("Select a folder with copied tracks")):If Len(d5)=0 Then Exit Sub:Else If Right(d5,1)<>"\"Then d5=d5&"\":End If:End If:If gf.TEXt<>d5 Then gf.TEXt=d5:End If:End Sub:Sub i7(jb):Dim c,ki,eg,h2,cm,em,h,dy,bg,ao,w,l,m,d1,ku,g,cx:Set w=sDb.SeLecTedSongLISt:If w.Count=0 Then Exit Sub:End If:If w.Count=1 Then If Not SDB.DATaBaSe.OPeNSqL("SELECT * FROM TrackRedirection WHERE IDasx = "&w.Item(0).ID).eOf Then SDb.MeSSagEbOx"The selected track is the redirected one."&vbCr&"You cannot create redirection for it.",MTInfoRMatIOn,Array(MBOK):Exit Sub:End If:ao=False:Else ao=True:End If:Set g=SdB.InIfILE:Set c=SDb.uI.newForM:c.bORDeRstyLE=jj:dy=c.CoMMoN.widTh-c.COMMoN.ClIenTWiDtH:bg=c.coMmOn.heIghT-c.COmMOn.cLieNtheiGht:c.CoMMON.sEtrEct 100,100,476+dy,440+bg:c.forMPOsiTion=ay:ci=sDb.LOCAliZE("Create Track Redirections"):c.caPTioN=ci:On Error Resume Next:Set ki=SDB.UI.NeWgrouPBox(c):If Err Then Set ki=sdb.Ui.nEwpANEl(c):End If:On Error GoTo 0:ki.cOmMOn.SeTReCt 10,10,207,50:Set eg=sDB.UI.nEwRadiObUTton(ki):eg.COmMoN.SeTREcT 10,3,190,20:eg.CapTIon="Create .asx metafile"&dp(ao,"s","")&" and replace:":scRiPT.reGistEReVent eg.cOMmON,"OnClick","a6":Set h2=SdB.UI.newradioBuTtOn(ki):h2.comMon.SeTRECt 10,28,160,20:h2.CapTiOn="Create redirection link"&dp(ao,"s","")&" for:":SCrIPT.rEGisteREVeNT h2.COMMon,"OnClick","e6":On Error Resume Next:Set ki=sDB.UI.nEwGROUpbOX(c):If Err Then Set ki=SdB.UI.newPaNeL(c):End If:On Error GoTo 0:ki.COmmon.seTRect 227,10,237,50:Set ex=SDb.UI.nEWraDiobuTtoN(ki):ex.captIon="Track"&dp(ao,"s","")&" from specified Album":ex.cOMmon.setReCT 10,3,150,17:sCripT.REGIStEreveNt ex.COmMOn,"OnClick","bq":Set gm=sDb.ui.nEWcHECKbOx(ki):gm.COmMoN.sEtrecT 170,3,60,20:gm.CaPTion=sdB.LocaLIzE("Filtered"):SCRipT.regiStErevEnT gm.COmmon,"OnClick","b9":Set iq=sdb.UI.NewRadiObUTTOn(ki):iq.CaPTIOn="Unselected tracks in tracklist":iq.cOMmON.setreCT 10,28,160,17:scRIpT.regISteREvEnt iq.CoMmON,"OnClick","l4":Set dc=SDb.uI.neWlabeL(c):dc.common.setReCT 10,70,400,40:Set h=SdB.Ui.neWlaBEL(c):h.cOMMon.setreCT 10,123,55,20:h.CaptiOn=SDB.LoCAlIze("Artist:"):Set b0=SDB.Ui.NEwDRopdOwN(c):b0.CoMmON.sETREct 70,120,395,19:If ao Then b0.STylE=d4:End If:scRipt.reGIsTeRevenT b0,"OnChange","kp":SCRIpT.RegiSTEReVEnt b0,"OnSelect","ix":Set h=sdB.ui.neWlABel(c):h.COMMON.sETREct 10,153,55,20:h.CapTiON=sDB.locaLize("Album:"):Set cv=sDb.UI.neWDrOPdOwN(c):cv.CommoN.SeTREct 70,150,395,19:If ao Then cv.STYLE=d4:End If:SCRipT.rEGIStEREvEnt cv,"OnChange","ip":sCRipT.REGIStErEVEnT cv,"OnSelect","ka":Set h=SDB.uI.neWLABel(c):h.coMmON.seTrecT 10,183,55,20:h.caPTIoN=sDB.locALiZE("Title:"):Set bs=sDB.Ui.newDROPDOWn(c):bs.coMmOn.seTrect 70,180,395,19:If ao Then bs.StyLe=d4:End If:Script.regiStEREvENt bs,"OnChange","az":sCRiPT.REgiSTeREVENt bs,"OnSelect","k6":Set h=sDB.UI.nEwlAbeL(c):h.CoMMoN.sETReCT 10,213,55,20:h.CaPTion=sDb.LocALIZE("AlbumArtist:"):Set ac=sDB.uI.neWEdIT(c):ac.ComMOn.sEtRect 70,210,395,19:sCRipT.ReGistEReVeNT ac,"OnChange","dx":Set h=Sdb.Ui.NewlabEl(c):h.COmMon.SetreCT 10,243,55,20:h.caPTiON=SDB.LocaLiZe("Track #:"):Set fh=sDB.UI.NeweDIT(c):fh.CoMmoN.sETRecT 70,240,80,19:ScRIpT.REgiSTereveNT fh,"OnChange","gl":Set h=SdB.uI.NEWLABel(c):h.cOMmon.SetREcT 174,243,55,20:h.CaptiOn=sdb.locAlizE("Disc #:"):Set hs=sdB.ui.nEwEdit(c):hs.coMMON.SEtRecT 227,240,80,19:sCrIPt.reGiSterEVeNt hs,"OnChange","a1":Set h=sdB.Ui.NeWlAbEl(c):h.COMmon.sETREct 334,243,55,20:h.CaptIoN=SDb.locAlIze("Date:"):Set jq=Sdb.UI.NewEdiT(c):jq.coMMON.setREcT 385,240,80,19:SCRIpT.rEgIsTereVENt jq,"OnChange","dk":Set h=Sdb.uI.NEWlAbeL(c):h.coMmoN.SeTrEct 10,273,55,20:h.CaPTIoN=sDb.locaLIzE("File Path:"):Set hv=Sdb.Ui.neWEdit(c):hv.CoMmon.seTrect 70,270,374,19:ScRIPT.REGisTeReVent hv,"OnChange","k7":Set cu=SdB.UI.NEWbutTOn(c):cu.cOmMON.SeTREct 445,270,21,21:cu.CaPTiOn="...":sCrIPt.reGISTErEvEnT cu,"OnClick","fx":Set hr=SdB.Ui.neWCHeckBOX(c):hr.COMmoN.sETRecT 10,300,450,20:ScRIpt.REGIsTeREVENT hr.COmMoN,"OnClick","go":hr.cHECkED=g.boOlVAluE("TrackRedirection","DeleteAudioFiles"):Set c8=SDB.ui.NeWcHecKbOx(c):c8.COMmOn.seTrECt 10,325,450,20:scRIPt.RegiStereVENT c8.comMOn,"OnClick","l7":c8.cheCkED=g.bOOlvAlUE("TrackRedirection","CopyAudioFiles"):Set j6=Sdb.Ui.newchEcKBoX(c):j6.cAPtION="Transfer playcounts and play dates from redirected tracks to corresponding masters":j6.CoMmON.seTRECT 10,350,450,20:SCrIPt.regIStErEVenT j6.COMMon,"OnClick","aq":j6.cHECkEd=g.bOOlvaLue("TrackRedirection","TransferPlaystatsOnCreate"):Set av=SDb.UI.newCheCkBOX(c):av.CaPTION="Synchronize metadata of redirected tracks to match corresponding masters":av.CoMMON.SetrECt 10,375,450,20:scRIPt.rEgISTerEVenT av.coMMON,"OnClick","ab":av.ChECKED=g.booLvalue("TrackRedirection","SynchronizeOnCreate"):Set ki=sdb.ui.neWPANEl(c):ki.COmmOn.SetrecT 8,403,305,33:Set ew=SdB.uI.NeWlaBeL(ki):If ao Then ew.caPtIOn="There are "&w.Count&" selected master tracks":Else ew.CAPtion="Master track: "&w.Item(0).PATh:End If:ew.COMmon.SetrEcT 6,2,293,29:ew.AuToSizE=False:ew.mUlTiLinE=True:Set cm=SDb.uI.NewBuTTON(c):cm.caPtioN=sdb.LOcAlize("&OK"):cm.ComMon.SetREct 320,407,70,25:cm.Default=True:cm.moDAlRESUlT=1:Set em=SDB.ui.nEwbutTON(c):em.CaPTiON=sdb.loCaLiZE("&Cancel"):em.comMOn.SETREct 397,407,70,25:em.caNcEl=True:em.mODaLRESULT=2:a4=sDb.DAtabasE.OpENsql("SELECT Name FROM Filters WHERE ID ="&sDb.DAtabaSe.ACtiVEfiLtERID).StrIngByInDeX(0):If Len(a4)=0 Then gm.comMOn.eNaBLeD=False:cw=False:End If:If g.bOolVaLuE("TrackRedirection","FilteredDuplicatesOnly")Then gm.ChEckEd=True:Else b9 gm:End If:Set d1=CreateObject("Scripting.Dictionary"):Set ku=CreateObject("Scripting.Dictionary"):For cx=0 To w.Count-1:Set l=w.Item(cx):If Not d1.eXIsTs(CStr(l.ID))Then d1.add CStr(l.Id),l:End If:m=l.ARTIstNaME&"@#$"&l.TitLE:If Not ku.exIstS(m)Then ku.aDd m,l:End If:Next:Set w=sdB.aLlVIsiblesOnGLisT:c5=0:For cx=0 To w.Count-1:Set l=w.Item(cx):If Not d1.ExIsTs(CStr(l.id))Then m=l.arTIstNAMe&"@#$"&l.title:If ku.eXiStS(m)Then c5=c5+1:End If:End If:Next:If SdB.INIfiLE.bOOlvaLue("TrackRedirection","CreateAsxSelectedMode")Then iq.cHEcKEd=True:Else ex.CHEcked=True:End If:If sDB.iNifILE.boolvalUE("TrackRedirection","AudioFileRedirect")Then h2.ChECKEd=True:e6 h2:Else eg.CHecKED=True:a6 eg:End If:c.sAvEPOsitIOnNAmE=ci:If c.sHOWMOdAL=2 Then Exit Sub:End If:sDb.inIFile.BOOLvaLue("TrackRedirection","CreateAsxSelectedMode")=iy:sdb.iNiFIlE.BoolVAluE("TrackRedirection","AudioFileRedirect")=fm:sDb.iNifIle.bOOLvAlue("TrackRedirection","FilteredDuplicatesOnly")=cw:sdb.iNIFile.BOolValuE("TrackRedirection","DeleteAudioFiles")=dj:sDB.INIfILE.BoOlvAlue("TrackRedirection","CopyAudioFiles")=a7:sDB.iNIfIle.boOlvALUE("TrackRedirection","TransferPlaystatsOnCreate")=bn:sdB.INIfiLe.BoOlvAlue("TrackRedirection","SynchronizeOnCreate")=fn:Call e1(d1,ku,False,bn,fn,g):End Sub:Sub iv(jb):Dim w,l,kx,an,cb,m,a,hp,e,gv,ds,k4,t,o,cx:On Error Resume Next:If SDB.VErSioNBuild<1218 Then Exit Sub:End If:If Err Then Exit Sub:End If:On Error GoTo 0:gv=SDb.uI.mAINWiNdOWfoCuS:If gv=4 Then Set w=sDb.PLayeR.CuRReNtsONglIst:Else Set w=sDB.AlLVISibleSonglIST:Set ds=Nothing:If Not sdB.mAiNtREE.cUrrENTnode Is Nothing Then Select Case sDb.MAIntRee.CUrrENTnOdE.nodetype:Case 7:gv=4:Case 61:Set ds=hl():End Select:End If:End If:Set kx=CreateObject("Scripting.Dictionary"):Set an=CreateObject("Scripting.Dictionary"):Set cb=CreateObject("Scripting.Dictionary"):Set t=Nothing:o=4+CLng(Timer*10):k4=w.Count:For cx=0 To k4-1:Set l=w.Item(cx):Set a=sDb.dATABasE.QUErYsonGS("ID = (SELECT IDref FROM TrackRedirection WHERE IDref = "&l.Id&")"):If Not a.eOF Then hp=2147483647:Else hp=l.BITraTE:End If:m=UCase(l.arTisTname&"@#$"&l.tiTle):If Not kx.ExIstS(m)Then kx.ADD m,hp:an.aDD m,1:cb.AdD m,l.Id:Else If kx.Item(m)<hp Then kx.Item(m)=hp:cb.Item(m)=l.iD:End If:an.Item(m)=an.Item(m)+1:End If:If o<CLng(Timer*10)Then o=1+CLng(Timer*10):SDb.pROcESSmEsSageS:If t Is Nothing Then Set t=sDb.prOgReSs:t.MAxVAlue=k4-1:Else If t.TeRmiNaTe Then Exit For:End If:End If:t.Value=cx:t.text=cx&"/"&k4:End If:Next:Set a=Nothing:For cx=k4-1 To 0 Step-1:Set l=w.Item(cx):m=UCase(l.ARTistNAMe&"@#$"&l.Title):If an.ExIstS(m)Then If an.Item(m)>1 And cb.Item(m)<>l.ID Then e=True:Else e=False:End If:Else e=False:End If:If gv=4 Then If e Then Sdb.pLAYER.pLaYlIsTdEletE cx:End If:Else If ds Is Nothing Then sdB.MAintrACKSwindow.sElEctEd(cx)=e:Else If e Then w.DeLetE cx:End If:End If:End If:Next:If gv<>4 Then If ds Is Nothing Then SDB.MAINtRacKsWINdoW.RemOveSELECTeDtracks:Else If k4<>w.Count Then ds.Clear:ds.AdDtrAcKS w:End If:End If:End If:End Sub:Sub kc(k0,g8):Dim d0,t,o,a,l,dw,cx:Sdb.proceSsMesSages:d0=False:sDB.OBjEcTs("colTrackRedirection").Item("TracksAdded")=d0:sDB.mAInTrACKsWiNDoW.rEFREsH:On Error Resume Next:If sDB.VeRSIonBuIld<1255 Then On Error GoTo 0:Set a=sdb.dATabASe.QUErYsONGs("ID = "&k0):If Not a.eOf Then Set l=a.Item:dw=l.pUBLISheR:sDB.pRoCessmEsSaGES:End If:Set a=Nothing:End If:On Error Resume Next:If SdB.vERSIonbuiLd<1218 Then:Else If g8 Then On Error GoTo 0:SdB.PRoceSsmessAGES:For cx=0 To sDB.ALlVIsibLESOnGLiST.Count-1:Set l=SdB.AllviSIBleSonglISt.Item(cx):If l.ID=k0 Then sdb.maiNtrACKSwInDow.seLECTeD(cx)=True:SdB.mAinTracKswIndoW.fOcUSEd=cx:Exit For:Else If cx=0 Then sDB.MaiNtRaCKSWiNdow.sElECtEd(cx)=False:End If:End If:Next:End If:End If:End Sub:Sub g5(jb):Dim kq,q,r,u,hq:If sdb.sEleCtedSoNglIst.Count=0 Then Exit Sub:End If:r=sDB.SelEcTEDSOnGlisT.Item(0).Path:If LCase(Right(r,4))<>".asx"Then Exit Sub:End If:hq=f0(r):If Len(hq)Then Call CreateObject("WScript.Shell").run("notepad """&r&"""",1,True):u=f0(r):If hq<>u And Len(u)>0 Then kq=jl.KeyS:Set q=New RegExp:If eb(r,u,kq,q)Then kn:End If:End If:End If:End Sub:Sub by(jb):fj"IDasx FROM TrackRedirection":End Sub:Sub j7(jb):Dim y,a:If SdB.sELecTEdsOnGList.Count<>1 Then Exit Sub:End If:Set y=Sdb.SelECTeDsOnGLiST.Item(0):Set a=SDB.dAtabasE.QUERysoNgS("ID = (SELECT IDref FROM TrackRedirection WHERE IDasx = "&y.Id&")"):If a.EoF Then sdb.MESSAGEBOx"The selected track doesn't have a refence to any master track.",MTInFormatioN,Array(MBOK):Exit Sub:End If:Set a=Nothing:SDb.DaTABase.BeGINTRanSaCtion:If f5(y,True)>0 Then sdb.DATAbaSe.cOMmIT:Call kc(y.iD,True):kn:Else SDB.DAtAbASe.COMmit:End If:End Sub:Sub af(h):If h.chEckeD Then h.coMMON.pAREnT.COMMon.chIlDCONTRol("SyncPlaystat").cHeCked=Not h.ChEcKED:End If:End Sub:Sub jh(h6):Dim ge,ks:Set ge=CreateObject("Scripting.FileSystemObject"):Set ks=ge.openTExTfiLE(SCrIpT.scRiPTpaTh&".log",8,True,-1):ks.WriteLine h6:ks.cLosE:End Sub:Sub OnStartup():Dim h5,y,r,u,f,bl,q,ij,er,t,o,cx:If Len(SDb.iNiFiLe.StRINgVAlUe("TrackRedirection","AsxFileFormat"))=0 Then sDb.iNIFILE.BoOlValUE("TrackRedirection","AsxFileFormat")=sDB.INIfilE.BOolVAluE("Options","StoreM3UinUTF8"):End If:If Len(Sdb.iNiFile.sTriNgvalUE("TrackRedirection","RelativePaths"))=0 Then Sdb.InifIlE.bOoLvaluE("TrackRedirection","RelativePaths")=False:End If:If Len(Sdb.INiFiLe.sTRInGVALue("TrackRedirection","UpdateRedirectedPlaylist"))=0 Then sdB.inIFILE.bOolvALuE("TrackRedirection","UpdateRedirectedPlaylist")=False:End If:If Len(SDb.INifIle.sTRiNgVALue("TrackRedirection","RedirectedTracksPlaylist"))=0 Then sdB.INIfilE.StriNGVALUe("TrackRedirection","RedirectedTracksPlaylist")="":End If:If Len(Sdb.iNIFilE.sTrInGvalue("TrackRedirection","UpdateRefPlaystats"))=0 Then Sdb.INifiLE.booLVAlUe("TrackRedirection","UpdateRefPlaystats")=True:End If:If Len(Sdb.INifIle.strIngVAlue("TrackRedirection","SyncMetadataMasterOnly"))=0 Then sDB.iNiFILE.bOOlvALue("TrackRedirection","SyncMetadataMasterOnly")=False:End If:If Len(SdB.inifile.stRInGValue("TrackRedirection","SyncSongTitle"))=0 Then SdB.iniFilE.BooLvaluE("TrackRedirection","SyncSongTitle")=True:End If:If Len(sDB.inifiLe.sTrINGValue("TrackRedirection","SyncArtist"))=0 Then SDB.inIfIlE.bOoLvalue("TrackRedirection","SyncArtist")=True:End If:If Len(SDb.iNIfILE.stRiNGVAlue("TrackRedirection","SyncAuthor"))=0 Then Sdb.INIfilE.boOlVALuE("TrackRedirection","SyncAuthor")=True:End If:If Len(sDb.INifile.strInGVaLUE("TrackRedirection","SyncAlbum"))=0 Then SdB.InIfiLE.BoolVAlue("TrackRedirection","SyncAlbum")=False:End If:If Len(Sdb.Inifile.StRInGvaLUE("TrackRedirection","SyncAlbumArtist"))=0 Then sdb.INIfiLE.bOOlValUE("TrackRedirection","SyncAlbumArtist")=False:End If:If Len(sdB.InifiLe.STRINgvaLue("TrackRedirection","SyncConductor"))=0 Then sDb.iniFILE.BoOlvAlUE("TrackRedirection","SyncConductor")=True:End If:If Len(SDB.iNIFILE.STrIngvALuE("TrackRedirection","SyncLyricist"))=0 Then sDB.INiFile.BOOlVAlUe("TrackRedirection","SyncLyricist")=True:End If:If Len(SDb.INiFiLE.STriNgVAlUe("TrackRedirection","SyncInvolvedPeople"))=0 Then SDb.InifilE.BOoLVaLUe("TrackRedirection","SyncInvolvedPeople")=True:End If:If Len(sdb.inIfIlE.STRinGvAlue("TrackRedirection","SyncYear"))=0 Then sdB.iNifilE.boolValUE("TrackRedirection","SyncYear")=False:End If:If Len(SDb.inIFilE.STrINgValUE("TrackRedirection","SyncGenre"))=0 Then sdb.iNIfiLE.boOlvaLUE("TrackRedirection","SyncGenre")=True:End If:If Len(SDb.iniFile.STRINgVALuE("TrackRedirection","SyncRating"))=0 Then SdB.INiFile.BooLVALuE("TrackRedirection","SyncRating")=True:End If:If Len(sdB.iNIfiLe.StrinGvALue("TrackRedirection","SyncTrackNumber"))=0 Then SdB.inIfIlE.bOOlvalUE("TrackRedirection","SyncTrackNumber")=False:End If:If Len(sDb.inifilE.StRingValUe("TrackRedirection","SyncDiscNumber"))=0 Then SDB.InifiLE.BOolVaLUE("TrackRedirection","SyncDiscNumber")=False:End If:If Len(sdb.inifiLE.StRInGvaLUE("TrackRedirection","SyncCustom1"))=0 Then SDb.inIfile.BoolvALUe("TrackRedirection","SyncCustom1")=True:End If:If Len(SdB.INifile.StringVaLUE("TrackRedirection","SyncCustom2"))=0 Then sdb.InIfIle.bOolvaLuE("TrackRedirection","SyncCustom2")=True:End If:If Len(sDb.INifilE.STriNGVAlUe("TrackRedirection","SyncCustom3"))=0 Then sdb.iNifile.bOolvaluE("TrackRedirection","SyncCustom3")=True:End If:If Len(sDB.iNIFiLe.strinGvALuE("TrackRedirection","SyncCustom4"))=0 Then SdB.InIfilE.bOOLvalUE("TrackRedirection","SyncCustom4")=True:End If:If Len(Sdb.iNIfile.STrInGVAluE("TrackRedirection","SyncCustom5"))=0 Then sdb.INIFiLe.BoOLVaLue("TrackRedirection","SyncCustom5")=True:End If:If Len(sDB.InIFiLe.STriNgVAlue("TrackRedirection","SyncTempo"))=0 Then SDB.iNiFILE.bOOLValue("TrackRedirection","SyncTempo")=True:End If:If Len(SDB.iNifilE.StriNGVALue("TrackRedirection","SyncMood"))=0 Then sdb.inIfILE.bOoLVALuE("TrackRedirection","SyncMood")=True:End If:If Len(sdb.inIFILE.stRiNgVaLuE("TrackRedirection","SyncOccasion"))=0 Then sDb.IniFiLE.boolvaluE("TrackRedirection","SyncOccasion")=True:End If:If Len(Sdb.inIfile.sTrInGvalUE("TrackRedirection","SyncQuality"))=0 Then SdB.inIFIle.bOoLVALUE("TrackRedirection","SyncQuality")=False:End If:If Len(sDB.INIfiLe.sTRInGValUe("TrackRedirection","SyncBPM"))=0 Then SDB.iniFIle.booLvALue("TrackRedirection","SyncBPM")=True:End If:If Len(sDb.iniFIlE.stRiNgvALUe("TrackRedirection","SyncOrigArtist"))=0 Then Sdb.INIfILE.BOolvaLuE("TrackRedirection","SyncOrigArtist")=True:End If:If Len(SDb.iniFiLe.sTRINgValue("TrackRedirection","SyncOrigTitle"))=0 Then SDb.INiFiLe.BoolValUe("TrackRedirection","SyncOrigTitle")=True:End If:If Len(sdb.INIfile.stRiNgvalue("TrackRedirection","SyncOrigYear"))=0 Then sdb.inifilE.boOLvALUE("TrackRedirection","SyncOrigYear")=True:End If:If Len(SDB.INIfIlE.strINgVaLUE("TrackRedirection","SyncOrigLyricist"))=0 Then sDB.InIFiLe.boOLValUe("TrackRedirection","SyncOrigLyricist")=True:End If:If Len(SDb.InifiLE.sTriNGVAlue("TrackRedirection","SyncComment"))=0 Then SDb.iNIfiLe.BOolvalUE("TrackRedirection","SyncComment")=True:End If:If Len(sdb.inIFiLe.stRINGVAluE("TrackRedirection","SyncLyrics"))=0 Then sDb.InIfILE.boolvalue("TrackRedirection","SyncLyrics")=True:End If:If Len(SDB.iNiFiLE.StRingvAlUE("TrackRedirection","SyncGroupDesc"))=0 Then sDB.INIfilE.BOoLVALUE("TrackRedirection","SyncGroupDesc")=True:End If:If Len(Sdb.iNifILe.STrInGValUe("TrackRedirection","SyncCopyright"))=0 Then Sdb.INiFIle.bOoLValUe("TrackRedirection","SyncCopyright")=True:End If:If Len(sDb.InIFile.sTriNgVaLuE("TrackRedirection","SyncEncoder"))=0 Then sdB.InIfILE.bOoLvAluE("TrackRedirection","SyncEncoder")=False:End If:If Len(sDB.IniFILe.strIngvaLUE("TrackRedirection","SyncISRC"))=0 Then SDb.InIFilE.BOolVALuE("TrackRedirection","SyncISRC")=True:End If:If Len(SDB.IniFiLE.StRIngvAluE("TrackRedirection","SyncPublisher"))=0 Then sDb.IniFIle.booLvaLuE("TrackRedirection","SyncPublisher")=False:End If:If Len(SDB.IniFIle.stRinGValuE("TrackRedirection","SyncPlaystat"))=0 Then sDB.InIFilE.boOLvALue("TrackRedirection","SyncPlaystat")=False:End If:If Len(sdB.INIfILE.STRIngvaLue("TrackRedirection","SyncAlbumArt"))=0 Then SDB.InIFilE.BOOlVaLue("TrackRedirection","SyncAlbumArt")=False:End If:If Len(sdb.inIfIlE.STRingVAlUe("TrackRedirection","AlbumArtStorage"))=0 Then SdB.iNifiLE.InTvaLUe("TrackRedirection","AlbumArtStorage")=0:End If:If Len(SDb.IniFiLe.strINGValUe("TrackRedirection","AlbumArtFileName"))=0 Then SDb.inIFIle.StringvAlue("TrackRedirection","AlbumArtFileName")="folder.jpg":End If:If Len(Sdb.InIFiLe.StriNgvaLue("TrackRedirection","SynchronizedMetadata"))=0 Then sDb.InIFIle.BooLVALue("TrackRedirection","SynchronizedMetadata")=False:End If:If Len(sDb.INIfiLe.StRIngvAlue("TrackRedirection","DuplicatesCriteria"))=0 Then sdb.iNifILE.BOolVALUE("TrackRedirection","DuplicatesCriteria")=False:End If:If Len(Sdb.InifiLe.STriNGvaLuE("TrackRedirection","DuplicatesExtList"))=0 Then Sdb.inIfilE.stRIngValuE("TrackRedirection","DuplicatesExtList")="ape|flac":End If:If Len(sDb.iNIFIlE.StRINGValuE("TrackRedirection","AutoReplaceRedirected"))=0 Then sDB.INIfILE.bOOlValue("TrackRedirection","AutoReplaceRedirected")=True:End If:If Len(Sdb.iNifile.STRinGvAlue("TrackRedirection","DeleteAudioFiles"))=0 Then SdB.inIfilE.BoolvaLuE("TrackRedirection","DeleteAudioFiles")=False:End If:If Len(Sdb.iNIfiLe.StrinGVaLue("TrackRedirection","CopyAudioFiles"))=0 Then SdB.INifiLE.bOOLvalUe("TrackRedirection","CopyAudioFiles")=False:End If:If Len(sdB.IniFILE.sTriNgVAlUe("TrackRedirection","HideMenuFindReferencedMaster"))=0 Then sdb.inIFiLe.BOoLVaLUE("TrackRedirection","HideMenuFindReferencedMaster")=False:End If:If Len(SDB.iNIFIle.strINgVaLUe("TrackRedirection","HideMenuFindDuplicateTitles"))=0 Then SDb.iNifilE.BoOLvaLUE("TrackRedirection","HideMenuFindDuplicateTitles")=False:End If:If Len(sDb.InIfiLe.stRINGvALUE("TrackRedirection","HideMenuSelectDuplicatesCriteria"))=0 Then sDb.iNIfIle.BOOLvALuE("TrackRedirection","HideMenuSelectDuplicatesCriteria")=False:End If:If Len(SDB.INIfilE.stRINGvalUE("TrackRedirection","HideMenuSelectLinkedTracks"))=0 Then SDB.iNiFIlE.bOOLvalue("TrackRedirection","HideMenuSelectLinkedTracks")=False:End If:If Len(sdB.INiFILe.sTRingVAluE("TrackRedirection","HideMenuSelectUnsynchronized"))=0 Then sdb.iNIFile.BoOlvalUE("TrackRedirection","HideMenuSelectUnsynchronized")=False:End If:If Len(SDB.iNifIlE.STRingVaLuE("TrackRedirection","HideMenuRemoveDuplicates"))=0 Then Sdb.IniFIlE.boolvaluE("TrackRedirection","HideMenuRemoveDuplicates")=False:End If:If Len(sdb.iNifile.StRInGVaLUe("TrackRedirection","HideMenuRemoveLinkedTracks"))=0 Then SDb.INIfile.BoolvalUE("TrackRedirection","HideMenuSelectLinkedTracks")=False:End If:If Len(SDb.iNifIle.StringvAlUE("TrackRedirection","HideMenuKeepLinkedTracks"))=0 Then sDb.iniFile.BOOLvAlUe("TrackRedirection","HideMenuKeepLinkedTracks")=False:End If:If Len(sDB.INifILe.strInGvALUe("TrackRedirection","HideMenuReplaceWithAlbumTrack"))=0 Then sdb.iNIFIlE.BoOLvALuE("TrackRedirection","HideMenuReplaceWithAlbumTrack")=False:End If:If Len(Sdb.INIFilE.StrInGvAlue("TrackRedirection","HideMenuReplaceWithLinkedTrack"))=0 Then SdB.iNifILE.boOLvaLUE("TrackRedirection","HideMenuReplaceWithLinkedTrack")=False:End If:If Len(SdB.iniFiLe.STrInGVAluE("TrackRedirection","HideMenuCreateTrackRedirections"))=0 Then Sdb.INiFiLe.BoOlVALue("TrackRedirection","HideMenuCreateTrackRedirections")=False:End If:If Len(SDB.INifIlE.strinGvaLuE("TrackRedirection","HideMenuCreateDuplicateRedirections"))=0 Then sDb.inIFiLE.BOOLvaLUe("TrackRedirection","HideMenuCreateDuplicateRedirections")=False:End If:If Len(SDb.iNifILe.STRIngVaLue("TrackRedirection","HideMenuAddRescanAsxFiles"))=0 Then sDb.IniFiLe.BoOLVAlUE("TrackRedirection","HideMenuAddRescanAsxFiles")=False:End If:If Len(SDB.inifILe.STRInGvaluE("TrackRedirection","HideMenuSynchronizeAsxMetadata"))=0 Then sdb.iNifILE.BoOlVAluE("TrackRedirection","HideMenuSynchronizeAsxMetadata")=False:End If:If Len(sDB.InIfILe.sTrINGVAlue("TrackRedirection","HideMenuSynchronizeAsxReferences"))=0 Then sDB.iniFIle.boolvaLue("TrackRedirection","HideMenuSynchronizeAsxReferences")=False:End If:If Len(sdb.inIFILE.stRINgvaLuE("TrackRedirection","HideMenuEditAsxFileWithNotepad"))=0 Then SDb.InIfiLe.boOlvALue("TrackRedirection","HideMenuEditAsxFileWithNotepad")=False:End If:If Len(SDB.iniFIlE.striNGVaLUe("TrackRedirection","HideMenuAssignRedirections"))=0 Then sDB.iNIFiLE.bOOLvAlUE("TrackRedirection","HideMenuAssignRedirections")=False:End If:If Len(sDB.inIfile.StriNgvalUE("TrackRedirection","HideMenuRemoveRedirection"))=0 Then SDB.INIfilE.BOOlVALuE("TrackRedirection","HideMenuRemoveRedirection")=False:End If:If Len(sdb.INifiLE.StRINgvALuE("TrackRedirection","HideMenuTransferRedirectedPlaystats"))=0 Then Sdb.inifiLE.boOLValuE("TrackRedirection","HideMenuTransferRedirectedPlaystats")=False:End If:If Len(SdB.inIFILe.STRiNGValue("TrackRedirection","HideMenuSynchronizeRedirectedMetadata"))=0 Then sDb.iNiFILE.BoOLvalUe("TrackRedirection","HideMenuSynchronizeRedirectedMetadata")=False:End If:If Len(sdB.iNiFiLe.sTRInGValuE("TrackRedirection","HideMenuMaintainRedirections"))=0 Then sDb.InIFiLe.BoolVALUe("TrackRedirection","HideMenuMaintainRedirections")=False:End If:If sdb.oBJEcTs("mnuMainTrackRedirection")Is Nothing Then jn SdB.UI.meNu_tooLS,-2,"Main":Else sDB.obJECtS("mnuMainTrackRedirection").vIsIBlE=True:End If:If SDb.OBjECtS("mnuPopupTrackRedirection")Is Nothing Then jn sdb.UI.meNu_pOP_trackLiST,-2,"Popup":Else SDb.OBjEcTS("mnuPopupTrackRedirection").vIsibLe=True:End If:If SdB.OBJectS("mnuNPPopupTrackRedirection")Is Nothing Then jn sdB.uI.MEnu_poP_nP,-3,"NPPopup":Else sdb.ObjeCts("mnuNPPopupTrackRedirection").ViSible=True:End If:If sDB.objects("mnuNPListTrackRedirection")Is Nothing Then jn sDb.UI.MeNu_poP_np_mAInWInDoW,-2,"NPList":Else SDB.OBjEcTS("mnuNPListTrackRedirection").VISIBLE=True:End If:If sDB.INifiLE.boOLvALue("TrackRedirection","SyncPlaystat")Then sdb.Objects("mnuMainTransferRedirectedPlaystats").enablED=False:SdB.oBjECTS("mnuPopupTransferRedirectedPlaystats").eNaBlED=False:SDb.oBJECTS("mnuNPPopupTransferRedirectedPlaystats").EnaBlED=False:sDb.obJEcTs("mnuNPListTransferRedirectedPlaystats").enAblEd=False:End If:d8:If SDB.oBJEcTs("colTrackRedirection")Is Nothing Then Set SdB.ObJEcts("colTrackRedirection")=CreateObject("Scripting.Dictionary"):sdB.ObJECTs("colTrackRedirection").aDD"OptionSheet",Sdb.uI.aDDOptioNshEEt("Track Redirection",ScRIpt.SCRiPtPATH,"gr","c7",-1):sdB.objEcTS("colTrackRedirection").add"TracksAdded",True:End If:If sdB.oBJects("colReplaceWithAlbumMain")Is Nothing Then Set Sdb.ObJEcTS("colReplaceWithAlbumMain")=CreateObject("Scripting.Dictionary"):End If:If sdB.OBJeCts("colReplaceWithAlbumPopup")Is Nothing Then Set sDB.ObjEctS("colReplaceWithAlbumPopup")=CreateObject("Scripting.Dictionary"):End If:If SDB.ObjEctS("colReplaceWithAlbumNPPopup")Is Nothing Then Set SdB.oBJEcTS("colReplaceWithAlbumNPPopup")=CreateObject("Scripting.Dictionary"):End If:If Sdb.OBjecTS("colReplaceWithAlbumNPList")Is Nothing Then Set Sdb.OBJECtS("colReplaceWithAlbumNPList")=CreateObject("Scripting.Dictionary"):End If:If SdB.ObJEcts("colReplaceWithLinkedMain")Is Nothing Then Set sDb.ObJeCTS("colReplaceWithLinkedMain")=CreateObject("Scripting.Dictionary"):End If:If SDB.oBJecTS("colReplaceWithLinkedPopup")Is Nothing Then Set SdB.ObjEcTs("colReplaceWithLinkedPopup")=CreateObject("Scripting.Dictionary"):End If:If sDB.ObJectS("colReplaceWithLinkedNPPopup")Is Nothing Then Set sdB.objeCts("colReplaceWithLinkedNPPopup")=CreateObject("Scripting.Dictionary"):End If:If sDb.OBjecTs("colReplaceWithLinkedNPList")Is Nothing Then Set SDb.ObJEctS("colReplaceWithLinkedNPList")=CreateObject("Scripting.Dictionary"):End If:bl=SDb.IniFILE.BooLVaLuE("TrackRedirection","UpdateRedirectedPlaylist"):If bl Then Set SdB.oBjECts("RedirectionPlaylist")=e5(sDB.InifILE.stringvaLUe("TrackRedirection","RedirectedTracksPlaylist")):Else SDB.ObJeCtS("RedirectionPlaylist")=Nothing:End If:Set t=Nothing:cx=sDb.daTAbASE.oPEnsQl("SELECT Count(*) FROM sqlite_master WHERE name = 'TrackRedirection'").ValUeBYInDEX(0):If cx=0 Then Set q=New RegExp:q.Pattern="<REF HREF ?= ?""(.*)"" />":SdB.DatAbase.ExecsQl"CREATE TABLE IF NOT EXISTS TrackRedirection (ID integer PRIMARY KEY, IDref integer, IDasx integer)":er=GetLocale:SetLocale"en-us":Set h5=SdB.datABASE.QUERySoNgS("SubStr(SongPath, -4, 4) = '.asx' COLLATE IUnicode"):cx=0:o=4+CLng(Timer*10):Do While Not h5.EOf:Set y=h5.Item:r=y.patH:u=f0(r):If Len(u)Then Set ij=q.Execute(u):If ij.Count>0 Then f=fz(jc(ij.Item(0).SubMatches.Item(0),r)):Else f="":End If:If Len(f)>0 Then sDb.datAbASe.EXecSqL"INSERT OR REPLACE INTO TrackRedirection (IDref, IDasx) SELECT ID, "&y.id&" FROM Songs WHERE SongPath = SubStr('"&f&"', -Length(SongPath), Length(SongPath)) COLLATE IUnicode":End If:End If:h5.Next:cx=cx+1:If o<CLng(Timer*10)Then o=1+CLng(Timer*10):SDb.ProcEssmesSagES:If t Is Nothing Then Set t=SDB.PROGrESS:Else If t.teRMInAtE Then Exit Do:End If:End If:t.TeXT="Track Redirection found "&cx&" .asx file(s)":End If:Loop:Set h5=Nothing:SetLocale er:kn:End If:End Sub:Sub e1(d1,ku,jv,bh,b3,g):Dim w,kq,n,a,l,k,eh,u,v,m,gw,g2,am,ge,ar,r,ff,q,i5,c0,df,fl,b,fk,kg,ao,g7,dg,ez,km,dl,dz,h0,kt,io,er,t,o,dw,cx,bv:fk=0:kq=jl.KEYs:er=GetLocale:Set g=sdB.iNIFIlE:kg=g.inTVaLUE("TrackRedirection","AsxFileFormat"):g7=g.booLValuE("TrackRedirection","RelativePaths"):ez=g.boolVALue("Options","UseFileToGuessMetadata")And Not g.boolValUe("Options","PreferTagsForMetadata"):dl=g.boOlvaLuE("Options","StoreID3AfterEdit"):dz=g.boolvalue("TrackRedirection","SyncPlaystat"):h0=g.booLvALUE("TrackRedirection","SyncAlbumArt"):kt=g.iNTVAlUE("TrackRedirection","AlbumArtStorage"):io=g.StriNgValue("TrackRedirection","AlbumArtFileName"):Set km=Nothing:Set ge=sdb.toOLS.FileSystem:Set ar=CreateObject("Scripting.FileSystemObject"):Set ff=sdb.nEwSTRINGLISt:Set q=New RegExp:If jv Then b=d1.Count:Else If Not iy Then Set w=sdb.SELEctEdsonGlIst:c5=w.Count:b=w.Count:Else Set w=SDB.ALLViSiBlesonGLIST:b=w.Count:End If:End If:If SDB.sELecteDSOnGLiSt.Count=1 Then ao=False:Else ao=True:End If:SdB.datABASE.BeginTrAnsACTIoN:Set t=Nothing:o=4+CLng(Timer*10):For cx=0 To b-1:r="":dg=False:If jv Then If s(0,cx)=1 Then Set k=d1.Item(CStr(cx)):Set l=ku.Item(CStr(cx)):Else Set k=Nothing:Set l=Nothing:End If:Else If iy Then Set l=w.Item(CStr(cx)):Set k=Nothing:If Not d1.exISTS(CStr(l.ID))Then m=l.aRtIstnaMe&"@#$"&l.tItLE:If ku.ExiStS(m)Then Set k=ku.Item(m):End If:End If:Else Set k=w.Item(cx):Set l=Nothing:If Not ao Then Set a=sDb.DAtABaSE.QUeRYSoNgS("SongPath = SubStr('"&fz(f)&"', -Length(SongPath), Length(SongPath)) COLLATE IUnicode"):If Not a.Eof Then dg=True:Set l=a.Item:End If:Set a=Nothing:End If:End If:End If:If Not k Is Nothing And Not fm Then u="<ASX version = ""3.0"">"&vbNewLine:If kg=1 Then u=u&"  <PARAM NAME = ""Encoding"" VALUE = ""utf-8"" />"&vbNewLine:End If:u=u&"  <TITLE>MediaMonkey redirection file</TITLE>"&vbNewLine&"  <ABSTRACT>Generated with Track Redirection script</ABSTRACT>"&vbNewLine&"  <COPYRIGHT>(C) 2009-2011 by Zvezdan Dimitrijevic</COPYRIGHT>"&vbNewLine&"  <ENTRY>"&vbNewLine&"    <REF HREF = """:End If:If k Is Nothing Then:Else If Not ao And(LCase(Right(f,4))=".asx"Or fm And Not dg)And Not iy And Not jv Then If fm And Not dg Then If a7 Or ge.FilEeXIstS(f)Then If Not ge.fIleexiSts(f)Then ar.coPYFILe k.PAth,f:End If:g2=k.SOnGlenGTH:Set l=sdb.NEWsONgDAtA:l.PaTH=f:If ez Then l.MEtaDATafRomfILEName:Else l.REaDtagS:End If:If Len(gi)Then l.ARTIsTnAmE=gi:End If:If Len(kj)Then l.aLbumNamE=kj:End If:If Len(hh)Then l.tITLe=hh:End If:If Len(cz)Then l.ALbUMartISTnAMe=cz:End If:If Len(d7)Then l.TRACkOrdErStR=d7:End If:If Len(he)Then l.DiScnumbERStr=he:End If:If Len(cg)Then On Error Resume Next:l.Year=Year(cg&dp(InStr(cg,"-"),"","-1")):If Len(cs(cg,"\d{4}-\d\d?",0))Then l.Month=Month(cg):End If:If Len(cs(cg,"\d{4}-\d\d?-\d\d?",0))Then l.Day=Day(cg):End If:On Error GoTo 0:End If:If a7 Then l.SoNgleNGTh=g2:End If:fl=aw:aw=True:l.uPDAtEDb:aw=fl:End If:Else If g7 Then eh=ch(k.paTH,Left(f,InStrRev(f,"\"))):Else eh=k.PAth:End If:u=u&eh&""" />"&vbNewLine:g2=k.sonGLEnGtH:If dg Then m=f0(f):If Len(m)Then q.Pattern="(<REF HREF ?= ?"").*("" />)":If q.Test(m)Then u=q.Replace(m,"$1"&eh&"$2"):r=f:Else Set l=Nothing:End If:Else Set l=Nothing:End If:Else Set l=sDb.NEWsOnGDaTA:l.patH=f:l.aRtISTName=gi:l.ALBuMNAMe=kj:l.titlE=hh:l.AlBuMARTIStnaME=cz:l.TRaCkoRDERstR=d7:l.dISCnuMBErstR=he:On Error Resume Next:If Len(cg)Then l.Year=Year(cg&dp(InStr(cg,"-"),"","-1")):If Len(cs(cg,"\d{4}-\d\d?",0))Then l.Month=Month(cg):End If:If Len(cs(cg,"\d{4}-\d\d?-\d\d?",0))Then l.Day=Day(cg):End If:End If:On Error GoTo 0:l.sonGlENgTH=g2:fl=aw:aw=True:l.UPDatEDb:aw=fl:End If:If Len(r)=0 Then If Len(hh)Then u=u&c3("Title",hh):Else If Len(l.TiTlE)Then u=u&c3("Title",l.tITLE):End If:End If:If Len(gi)Then u=u&c3("Artist",gi):Else If Len(l.ArtIStnAMe)Then u=u&c3("Artist",l.ArTISTNAMe):End If:End If:If Len(kj)Then u=u&c3("Album",kj):Else If Len(l.aLBUmNaMe)Then u=u&c3("Album",l.AlBUmnAMe):End If:End If:If Len(cz)Then u=u&c3("Album Artist",cz):Else If Len(l.AlbUmArTistnAMe)Then u=u&c3("Album Artist",l.aLbuMARTisTNAmE):End If:End If:If Len(d7)Then u=u&c3("Track #",d7):End If:If Len(he)Then u=u&c3("Disc #",he):End If:If Len(cg)Then u=u&c3("Date",cg):End If:u=u&c3("Length",g2):u=u&"  </ENTRY>"&vbNewLine&"</ASX>":r=f:End If:End If:am="":Else If iy Or jv Then am="ID = "&l.id:If Not fm Then eh=l.paTH:Set a=sDB.DaTabASe.quERYSoNGs("SongPath = SubStr('"&fz(Left(eh,InStrRev(eh,"."))&"asx")&"', -Length(SongPath), Length(SongPath)) COLLATE IUnicode"):If Not a.EoF Then Set l=Nothing:End If:Set a=Nothing:End If:Else If Not ao Then am="SongPath = SubStr('"&fz(f)&"', -Length(SongPath), Length(SongPath)) COLLATE IUnicode":Else am="Artist COLLATE IUnicode = '"&fz(k.ArtIsTNaMe)&"' AND SongTitle COLLATE IUnicode = '"&fz(k.Title)&"'":End If:If Len(gp)Then am=am&" AND"&gp:End If:Set a=Sdb.dAtAbasE.qUErYSoNgS(am&" AND SubStr(SongPath, -4, 4) <> '.asx' COLLATE IUnicode AND ID NOT IN (SELECT IDasx FROM TrackRedirection) AND ID <> "&k.ID&" AND "&k.Id&" NOT IN (SELECT IDasx FROM TrackRedirection)"):If Not a.Eof Then Set l=a.Item:Else Set l=Nothing:End If:Set a=Nothing:End If:If Not l Is Nothing And Not fm Then If g7 Then u=u&ch(k.pAtH,Left(l.pAtH,InStrRev(l.pAtH,"\"))):Else u=u&k.PAth:End If:u=u&""" />"&vbNewLine:For bv=0 To jl.Count-1:v=kq(bv):m=Eval("l."&jl.Item(v)):If gk.EXiSts(v)Then gw=gk.Item(v):Else If cr.exIsTs(v)Then gw=cr.Item(v):Else gw="":End If:End If:Select Case VarType(m):Case vbBoolean:If m Then m=1:Else m=0:End If:Case vbDate:If m<>gw Then m=Year(m)&"-"&Right("0"&Month(m),2)&"-"&Right("0"&Day(m),2)&" "&Right("0"&Hour(m),2)&":"&Right("0"&Minute(m),2)&":"&Right("0"&Second(m),2):End If:Case 20:If v="File size"Then m=CCur(m):End If:End Select:If bh And kv.eXISTS(v)And k.iD>-1 Then:Else If gk.eXIstS(v)Then If m>gw Then u=u&c3(v,m):End If:Else If m<>gw Then u=u&c3(v,m):End If:End If:End If:Next:f=l.paTh:For bv=0 To l.aLBumArt.Count-1:u=u&g9(l,f,bv,ge):Next:u=u&"  </ENTRY>"&vbNewLine&"</ASX>":r=Left(f,InStrRev(f,"."))&"asx":End If:End If:End If:If Len(r)Then If Len(iw(r,u,kg))=0 Then If Len(am)Then df=True:If Not b3 Or Not h0 Then For bv=l.AlbuMaRt.Count-1 To 0 Step-1:Set i5=l.aLbUmArt.Item(bv):If i5.itEMSToRAGe=0 Then eh=Left(f,InStrRev(f,"."))&bv+1&"."&cs(i5.iMAgE.imAgeforMAt,"([^/-]+)$",0):eh=Mid(eh,InStrRev(eh,"\")+1):SDb.DATaBAse.ExEcsQL"UPDATE Covers SET CoverStorage = 1, CoverPath = '"&fz(eh)&"' WHERE IDSong = "&l.Id&" AND CoverOrder = "&bv:End If:Next:End If:r=fz(r):If Mid(r,2,1)=":"Then r=Mid(r,2):End If:sdB.DatabaSe.eXeCSQL"UPDATE Songs SET SongPath = '"&r&"' WHERE SongPath = SubStr('"&fz(f)&"', -Length(SongPath), Length(SongPath)) COLLATE IUnicode AND "&am:If dj And ge.FIlEExisTS(f)Then ff.add f:End If:End If:Else r="":End If:End If:If Len(r)Or fm And Not k Is Nothing And Not l Is Nothing Then If k.iD>-1 Then fk=fk+1:SetLocale"en-us":Set n=SDB.DAtaBase.OPENSqL("SELECT ID FROM TrackRedirection WHERE IDasx = "&l.iD):If Not n.EoF Then m="UPDATE TrackRedirection SET IDref = "&k.ID&" WHERE IDasx = "&l.iD:Else m="INSERT OR REPLACE INTO TrackRedirection (IDref, IDasx) VALUES ("&k.ID&", "&l.iD&")":End If:Set n=Nothing:If bh And Len(am)Then SDb.dAtABaSE.execsql"UPDATE Songs SET PlayCounter = PlayCounter + "&l.PlAyCoUnTeR&", LastTimePlayed = Max(LastTimePlayed, "&CDbl(l.lAsTPLayED)&") WHERE ID = "&k.ID:sdb.dAtabaSE.ExECsqL"UPDATE Songs SET PlayCounter = 0, LastTimePlayed = 0.0 WHERE ID = "&l.id:SDb.dATaBASe.execsqL"UPDATE Played SET IDSong = "&k.ID&" WHERE IDSong = "&l.ID:End If:SdB.DAtaBAsE.eXecsQL m:SetLocale er:If b3 Then aa k,l,dl,dz,q,kq,ge,g,kg,h0,kt,io,ar,km:End If:End If:End If:If o<CLng(Timer*10)Then o=1+CLng(Timer*10):sdB.PrOCessMESSAGES:If t Is Nothing Then Set t=sDb.prOgrEss:t.MAxVaLue=b-1:Else If t.teRmINAtE Then Exit For:End If:End If:t.Value=cx:t.text=cx&"/"&b:End If:Next:sDb.DAtabase.cOmmIt:sdB.pROceSSMESSaGEs:If df Then SDB.mAINTraCKsWIndOw.RefreSh:On Error Resume Next:If SDb.veRSIonBUILd<1255 Then On Error GoTo 0:Set a=SDb.dATAbasE.quERYSOnGs("SubStr(SongPath, -4, 4) = '.asx' COLLATE IUnicode"):If Not a.eOF Then Set l=a.Item:dw=l.pUBLIsHER:Sdb.pROCEssmESsaGES:End If:Set a=Nothing:Else On Error GoTo 0:End If:End If:If fk>0 Then kn:End If:If ff.Count>0 Then If SDB.MEssagEBOX("Are you absolutely sure you want to delete "&dp(ff.Count=1,"the track:"&vbCr&ff.Item(0)&"?",ff.Count&" replaced tracks?"),mTCOnfiRmAtIOn,Array(mByeS,MBNo))=mRYeS Then For cx=0 To ff.Count-1:If ge.fILeeXiSTs(ff.Item(cx))Then ge.dELEtEFilE ff.Item(cx):End If:Next:End If:End If:If fm Then m="redirected to the audio file":Else m="replaced with the .asx file":End If:If c5-fk=1 Then If c5=1 Then sDB.mEssaGeBox"The specified track is not "&m&".",MtwArniNg,Array(MboK):Else SDb.MEsSaGEBoX"There is one track that is not "&m&".",MTwarnING,Array(mBok):End If:Else If c5>fk Then SDB.MeSSAGebOx"There are "&c5-fk&" tracks that are not "&m&"s.",MTwArnINg,Array(mboK):End If:End If:End Sub:Sub kr(jb):a8 sdb.seLECteDsONGLIst,False:End Sub:Function c3(v,m):Dim fs:If gd.eXiSTS(v)Then If Len(m)Then c3="    "&Replace(Replace(gd.Item(v)," ?",""),")(.*)(",m)&vbNewLine:End If:Else If dd.exISTs(v)Then fs=dd.Item(v):Else fs=v:End If:c3="    <PARAM NAME = """&fs&""" VALUE = """&ca(m)&""" />"&vbNewLine:End If:End Function:Dim gk:Set gk=CreateObject("Scripting.Dictionary"):With gk:.adD"Track Volume",-999999:If sdB.vErsIOnhI>=3 Then .ADD"Album Volume",-999999:End If:.Add"BPM",0:End With:Sub at(ct):If s(0,ct.indEX)=1 And ct.CheCkSTAte=0 Then i3=i3-1:Else If s(0,ct.Index)=0 And ct.CHeckStaTE=1 Then i3=i3+1:End If:End If:s(0,ct.IndeX)=ct.chEcKstaTE:If IsObject(ea)Then If Not ea Is Nothing Then ea.COmmOn.eNABLED=(i3>0):End If:End If:im.cOMmoN.enABlED=(i3>0):k3.coMmON.enaBLeD=Not dz And(i3>0):cj.COMMOn.eNabLEd=(i3>0):dc.CaPTIon=i3&"/"&UBound(s,2)+1:End Sub:Sub hx(w):Dim g,dl,bh,dz,ho,ic:If aw Then Exit Sub:End If:aw=True:Set g=Sdb.inIFiLE:dl=g.bOOlVAlue("Options","StoreID3AfterEdit"):bh=g.booLvaLUe("TrackRedirection","UpdateRefPlaystats"):ic=g.Boolvalue("TrackRedirection","SyncMetadataMasterOnly"):dz=g.Boolvalue("TrackRedirection","SyncPlaystat"):ho=g.boOlvALUE("TrackRedirection","SynchronizedMetadata"):ak w,dl,bh,ho,ic,dz,True:aw=False:End Sub:Sub gx(h):h.coMmon.pARENT.COMMoN.chILDcoNtROl("AlbumArtFileName").COmMon.enAbLeD=h.Checked:End Sub:Function e3(c4,j3,gp):Dim x,f4:x="ID IN (SELECT ID FROM Songs WHERE SongTitle || '@#$' || Artist || '|' || ":f4="CASE WHEN ID IN (SELECT IDref FROM TrackRedirection) THEN 1000000000 ELSE ":If Len(j3)Then f4=f4&"CASE WHEN UpperW(SubStr(SongPath, Length(RTrim(SongPath, Replace(SongPath, '.', ''))) + 1, 9999)) IN ('"&Replace(UCase(j3),"|","', '")&"') THEN ":If c4 Then f4=f4&"Bitrate + 10000000 ELSE Bitrate":Else f4=f4&"Bitrate * 2 + 1 ELSE Bitrate * 2":End If:f4=f4&" END":Else f4="Bitrate":End If:f4=f4&" END":x=x&f4&" COLLATE IUnicode IN (SELECT SongTitle || '@#$' || Artist || '|' || Max("&f4&") COLLATE IUnicode FROM Songs WHERE SubStr(SongPath, -4, 4) <> '.asx' COLLATE IUnicode AND Songs.ID NOT IN (SELECT IDasx FROM TrackRedirection)":If Len(gp)Then x=x&" AND"&gp:End If:x=x&" GROUP BY Artist, SongTitle COLLATE IUnicode HAVING Count(*) > 1) AND SubStr(SongPath, -4, 4) <> '.asx' COLLATE IUnicode AND ID NOT IN (SELECT IDasx FROM TrackRedirection)":If Len(gp)Then x=x&" AND"&gp:End If:x=x&" GROUP BY Artist, SongTitle COLLATE IUnicode)":e3=x:End Function:Function cs(bk,i0,c2):Dim eo,dv:Set eo=New RegExp:eo.Pattern=i0:eo.Global=True:eo.IgnoreCase=True:Set dv=eo.Execute(bk):If dv.Count>c2 Then cs=dv.Item(c2).Value:End If:End Function:Function ch(ed,b2):Dim i2,ev,l3,bp:i2=InStr(InStr(b2,"\\")+2,b2,"\"):If i2=0 Or UCase(Left(b2,i2))<>UCase(Left(ed,i2))Then ch=ed:Exit Function:End If:ev=Mid(b2,i2+1):l3=Mid(ed,i2+1):If Right(ev,1)="\"Then ev=Left(ev,Len(ev)-1):End If:If Right(l3,1)="\"Then l3=Left(l3,Len(l3)-1):End If:Do:If Len(ev)=0 Then ch=bp&l3:Exit Function:End If:If InStr(1,l3&"\",ev&"\",1)=1 Then ch=bp&Mid(l3,Len(ev)+2):Exit Function:Else bp=bp&"..\":If InStrRev(ev,"\")Then ev=Left(ev,InStrRev(ev,"\")-1):Else ev="":End If:End If:Loop:End Function:Sub f2(ju,iz,k0):Dim w,l,x,gp,a,hy,ep,h8,ik,be,e,fq,j0,b,fu,cx:Set w=SDB.selectedsOngList:If iz="Main"And sDb.ui.MAinWiNDOwfOCUS=4 Or iz="NPPopup"Then h8=True:be=False:b=sDB.pLAyER.CUrreNtSOnGLIST.Count:Else If Not Sdb.MAiNTReE.cuRReNTNODE Is Nothing Then If sdB.MAINtREE.CUrRENTNODE.NODEtYpE=7 Then ik=True:End If:End If:If iz="Main"And sDB.ui.MAiNwiNdOwFOCUs<>4 And ik Or iz="NPList"Then h8=True:Else h8=False:Set hy=sdb.NEWsONGLIST:End If:be=True:b=sDb.ALlVISIBLEsOngLisT.Count:Set ep=CreateObject("Scripting.Dictionary"):j0=sDb.MAiNtRacksWINdoW.foCusEd:End If:cx=0:iu=True:For fq=0 To b-1:If h8 And Not be Then e=SdB.PlAYeR.pLaYlIStselectED(fq):Else e=Sdb.mAintRackSwindow.sELeCted(fq):End If:If e Then Set l=w.Item(cx):If w.Count=1 Then x="ID = "&k0:Else If ju="Album"Then x="Artist COLLATE IUnicode = '"&fz(l.ArTIsTnAme)&"' AND SongTitle COLLATE IUnicode = '"&fz(l.tITle)&"' AND ID <> "&l.Id:Else x="(ID = (SELECT IDref FROM TrackRedirection WHERE IDasx = "&l.iD&") OR ID IN (SELECT IDasx FROM TrackRedirection WHERE IDref = "&l.Id&") OR ID IN (SELECT IDasx FROM TrackRedirection WHERE IDref = (SELECT IDref FROM TrackRedirection WHERE IDasx = "&l.id&"))) AND ID <> "&l.Id:End If:If Len(gp)Then x=x&" AND"&gp:End If:End If:Set a=SdB.DataBaSe.qUErYsonGs(x):If Not a.EOf Then If h8 Then sDB.PLAyeR.PlaYlisTaddTRAcK a.Item:SDb.pLAyeR.PLaYLISTMOvETracK Sdb.pLayer.curreNtSonGLiST.Count-1,fq:SdB.player.PLAYlisTdElEtE fq+1:End If:If be Then If Not h8 Then hy.aDd a.Item:End If:fu=a.Item.iD:If Not ep.ExiSts(fu)Then ep.ADd CStr(fu),fu:End If:End If:Else If Not h8 Then hy.aDd SdB.AlLViSibleSonGLisT.Item(fq):End If:End If:cx=cx+1:Else If Not h8 Then hy.aDD sdb.AllViSIbLesongLIsT.Item(fq):End If:End If:Next:Set a=Nothing:If be Then If Not h8 Then If b>w.Count Then For fq=0 To b-1:SDB.MaInTRaCkSwiNDOW.SEleCTeD(fq)=True:Next:End If:SdB.MAINtRACksWINdoW.remOVESElecTEDTRaCKS:SDB.MaInTrACkSWIndOW.finIsHADdinG:For fq=0 To hy.Count-1:sdB.MaInTraCkSwiNDOw.ADdtrACk hy.Item(fq):Next:Sdb.MAiNTRACkSwINDoW.FIniSHadDiNG:End If:For fq=0 To b-1:Set l=sDb.alLvisiBLESOnglISt.Item(fq):If ep.ExIstS(CStr(l.id))Then sDB.mAiNtRaCkSWinDOw.seLecTED(fq)=True:Else If fq=0 Then sDB.MaINTRAcksWinDOW.SEleCTeD(0)=False:End If:End If:Next:SDb.MAiNtrACksWiNdow.fOcUsed=j0:End If:If h8 Then sDb.TOOls.sLeep 10:Sdb.pROCessMEsSAGeS:End If:iu=False:kz:End Sub:Function ca(h6):ca=Replace(h6,Chr(34),"''"):End Function:Sub aa(ia,gz,dl,dz,q,kq,ge,g,kg,h0,kt,io,ar,t):Dim l,v,m,fb,kk,ie,f8,kd,b5,l1,ck,a0,fa,fy,dm,fc,ef,ir,k5,o,bv:Set fa=CreateObject("Scripting.Dictionary"):kk=False:For bv=0 To jl.Count-1:v=kq(bv):If ji.exISTS(v)Then If g.BoOlValUE("TrackRedirection","Sync"&ji.Item(v))Then fb=jl.Item(v):If j1.eXISTs(v)Then Set l=ia:m=Eval("l."&fb):Set l=gz:If Eval("l."&fb)<>m Then Execute j1.Item(v):kk=True:End If:Else If Eval("gz."&fb)<>Eval("ia."&fb)Then Execute"gz."&fb&" = ia."&fb:kk=True:End If:End If:End If:End If:Next:If dz Then If gz.pLAYCOUnTER<>ia.pLAyCounteR Then gz.PlaYcOUnter=ia.PlaYcOUnteR:kk=True:End If:If gz.LasTPlAYeD<>ia.lASTplAYed Then gz.lAStPLaYED=ia.LAStplayEd:kk=True:End If:End If:If kk And Not gz.iSnTInDb Then On Error Resume Next:gz.UpDAtedb:If Err Then SDB.DaTaBAsE.COmMIT:Err=0:gz.uPDAtEdB:End If:If Err Then sDb.MEsSAgebOX gt,mtWarNING,Array(mBok):Exit Sub:End If:On Error GoTo 0:If a2 Then jh Now&" - Metadata synchronization: "&ia.PAtH&" -> "&gz.PAtH:End If:End If:ie=False:If h0 Then Set kd=gz.AlBUmArt:For bv=kd.Count-1 To ia.AlbumArt.Count Step-1:kd.dELetE bv:ie=True:Next:For bv=0 To ia.AlbumaRt.Count-1:Set b5=ia.albumarT.Item(bv):Set ck=b5.ImAge:f8=False:If kd.Count>bv Then Set l1=kd.Item(bv):If l1.iMAGe Is Nothing Or ck Is Nothing Then Do While kd.Count>bv:kd.DELETE kd.Count-1:Loop:Set l1=kd.ADDnEW:ie=True:If Not ck Is Nothing Then f8=True:End If:Else If l1.IMaGE.imAgEfORmat<>ck.iMAgEFOrMat Or l1.IMaGe.iMAgeDatALen<>ck.ImaGedatAleN Or l1.IMAgE.WIDtH<>ck.WIDth Or l1.imagE.hEiGHt<>ck.hEIGHT Then Do While kd.Count>bv:kd.delETE kd.Count-1:Loop:Set l1=kd.ADdNEw:ie=True:f8=True:End If:End If:Else Set l1=kd.adDNEw:ie=True:f8=True:End If:If l1.Description<>b5.Description Then l1.Description=b5.Description:ie=True:End If:If l1.ItEmTyPE<>b5.iTEmTYpE Then l1.IteMType=b5.iTEMTyPE:ie=True:End If:If f8 Then If b5.ITemSTOrAge=0 Or kt>0 Then If kt=2 And Len(io)>0 Then dm=Left(gz.paTH,InStrRev(gz.PAth,"\"))&Left(io,InStrRev(io,".")):If ia.aLBumArT.Count>1 Then dm=dm&bv+1&".":End If:Else dm=Left(gz.PAth,InStrRev(gz.PATh,"."))&bv+1&".":End If:dm=dm&cs(ck.imAGeforMat,"([^/-]+)$",0):Set a0=ge.CrEAtetEXTfIlE(dm,True):If Not a0 Is Nothing Then a0.WRiTEDaTA ck.ImAgEdATA,ck.imaGedAtaLen:a0.cLosE:If LCase(Right(gz.PATh,4))=".asx"Or Not dl Or kt=2 Then l1.ITEMstORagE=1:Else fa.ADD CStr(bv),dm:l1.ItEMStoragE=0:End If:Else l1.iTEmsToRaGe=1:End If:l1.RELaTivEpiCtUrEPatH=Mid(dm,InStrRev(dm,"\")+1):Else If InStr(b5.RElatiVepictUREpatH,"\")=0 Then dm=b5.pICtUrepATh:If ge.fileEXists(dm)Then ar.cOPyFiLE dm,Left(gz.pATH,InStrRev(gz.patH,"\")),True:l1.ReLATivEPiCtuREpAth=b5.rElAtIvePIcTURepaTH:Else l1.piCTurepath=b5.picTuREPATh:End If:Else l1.pICTurEPaTh=b5.PictuRePath:End If:l1.iTeMStORAge=b5.iteMStORAge:End If:End If:Next:If ie And Not gz.isntInDb Then On Error Resume Next:kd.UpdatEdB:If Err Then SdB.database.COmmit:Err=0:kd.uPdaTedB:End If:If Err Then sDB.MEssaGEbox gt,MTWaRniNg,Array(mBOk):Exit Sub:End If:On Error GoTo 0:If a2 Then jh Now&" - Album art synchronization: "&ia.PAth&" -> "&gz.paTH:End If:End If:End If:If(kk Or ie)And dl Then If LCase(Right(gz.paTh,4))=".asx"Then l0 gz,Nothing,True,False,q,kq,ge,kg:Else If ge.fIlEEXists(gz.pAtH)Then Set a0=ar.gETfILE(gz.paTh):fc=a0.dATElaSTAcCesSed:ef=a0.DATelastMOdIFIED:ir=a0.SIzE:End If:gz.wRitetaGS:If ie And fa.Count>0 And kt=0 And Not hz Then If t Is Nothing Then Set t=sdb.PRogRess:End If:t.TExt="Synchronizing Album Arts...":o=CLng(Timer)+5:On Error Resume Next:Do:sDB.pROCESSmESsaGes:sDb.toOls.SLEEP 10:If o<CLng(Timer)And ge.FIleexISTs(gz.PATH)Then Exit Do:Else If o+2<CLng(Timer)Then Exit Do:Else If fc=a0.DAteLasTACCEssEd And ef=a0.DATelAsTmOdIfiEd And ir=a0.size Then Err=0:Else Exit Do:End If:End If:End If:Loop Until t.termINAtE:On Error GoTo 0:SdB.proceSSMeSSAgeS:If ge.fiLeexIsTS(gz.PAtH)Then Set k5=Sdb.nEWSonGdata:k5.PaTh=gz.pAth:fc=a0.dAtelAStaCCeSSED:k5.rEAdTAgS:o=CLng(Timer)+2:On Error Resume Next:Do:SDB.pRocEssMeSSAGES:sdB.TOOlS.sleEP 10:If k5.AlBUMart.Count>0 Then Exit Do:Else If o<CLng(Timer)Then Exit Do:Else If fc=a0.DaTeLasTAcCessEd Then Err=0:Else Exit Do:End If:End If:End If:Loop Until t.TErmINaTE:On Error GoTo 0:If kd.Count>k5.aLbumArT.Count Then For bv=kd.Count-1 To 0 Step-1:If fa.ExISts(CStr(bv))Then kd.Item(bv).itemsToRaGe=1:fa.reMOvE CStr(bv):End If:Next:If Not gz.ISntInDB Then On Error Resume Next:kd.UPDATedB:If Err Then SDb.DAtABase.ComMiT:Err=0:kd.UPDATEDb:End If:If Err Then sDB.mEssAgeBOX gt,MTwarNinG,Array(MboK):Exit Sub:End If:On Error GoTo 0:End If:End If:Set k5=Nothing:End If:End If:End If:End If:If ie Then fy=fa.Keys:For bv=0 To fa.Count-1:If ge.FiLeeXisTS(fa.Item(fy(bv)))Then ge.DELeTeFile fa.Item(fy(bv)):End If:Next:End If:Set gz=Nothing:Set kd=Nothing:End Sub:Sub cq(ia,dl,ic,dz,q,kq,ge,g,kg):Dim a,x,gz,ar,t,h0,kt,io:Set ar=CreateObject("Scripting.FileSystemObject"):Set t=Nothing:h0=g.boOLVAlue("TrackRedirection","SyncAlbumArt"):kt=g.iNTValUe("TrackRedirection","AlbumArtStorage"):io=g.strINGValue("TrackRedirection","AlbumArtFileName"):x="ID IN (SELECT IDasx FROM TrackRedirection WHERE IDref = "&ia.ID&")":If Not ic Then x="("&x&" OR ID = (SELECT IDref FROM TrackRedirection WHERE IDasx = "&ia.id&") OR ID IN (SELECT IDasx FROM TrackRedirection WHERE IDref = (SELECT IDref FROM TrackRedirection WHERE IDasx = "&ia.ID&")))":End If:Set a=SdB.dAtabASE.querysongS(x&" AND ID <> "&ia.ID):Do While Not a.EOf:Set gz=a.Item:aa ia,gz,dl,dz,q,kq,ge,g,kg,h0,kt,io,ar,t:a.Next:Loop:Set a=Nothing:End Sub:Sub kn():Dim a,w:If Not sdb.ObJeCtS("RedirectionPlaylist")Is Nothing Then Set w=sdB.neWsOngLIst:SdB.ObjeCts("RedirectionPlaylist").Clear:Set a=sdb.DatABASe.QUerYSOnGS("ID IN (SELECT IDasx FROM TrackRedirection)"):Do While Not a.EOF:w.adD a.Item:a.Next:Loop:Set a=Nothing:SdB.ObJects("RedirectionPlaylist").addtRaCkS w:End If:End Sub:Sub k6(h):Dim n,x,kf:hh=h.texT:id=h.iteMiNdEx:cg="":d7="":he="":kf=sdB.SELeCTedSOngliST.Item(0).paTH:x="SELECT Year, TrackNumber, DiscNumber, CASE WHEN DriveLetter IS NOT NULL AND DriveType < 12345 THEN SubStr('ABCDEFGHIJKLMNOPQRSTUVWXYZ', DriveLetter + 1, 1) ELSE '' END || SongPath AS TrackPath FROM Songs LEFT JOIN Medias ON Songs.IDMedia = Medias.IDMedia WHERE Artist = '"&fz(gi)&"' AND Album = '"&fz(kj)&"' AND ID NOT IN (SELECT IDref FROM TrackRedirection)":If Len(gp)Then x=x&" AND"&gp:End If:If Not i4 Then x=x&" AND TrackPath <> '"&fz(kf)&"' COLLATE IUnicode":f="":End If:Set n=sdB.DatABaSe.oPENsqL(x&" AND SongTitle = '"&fz(hh)&"' AND ID NOT IN (SELECT IDasx FROM TrackRedirection) AND SubStr(SongPath, -4, 4) <> '.asx' COLLATE IUnicode"):If n.EOF Then Set n=SdB.dAtABAsE.oPeNsqL(x&" AND SongTitle = '"&fz(hh)&"' AND ID IN (SELECT IDasx FROM TrackRedirection) AND SubStr(SongPath, -4, 4) = '.asx' COLLATE IUnicode"):End If:If Not n.eoF Then cg=n.sTRInGbyiNDEX(0):If Int(cg)>0 Then cg=Left(cg,4)&dp(Int("0"&Mid(cg,5,2))>0,"-"&Mid(cg,5,2)&dp(Int("0"&Mid(cg,7,2))>0,"-"&Mid(cg,7,2),""),""):Else cg="":End If:If Len(n.stRIngbYINDex(1))>0 Then d7=n.STRiNGByINdEx(1):End If:If Len(n.StRiNgbYIndex(2))>0 Then he=n.sTRiNgbyiNdex(2):End If:If Not i4 Then f=f&n.strINGbYINDeX(3):End If:Else If Not i4 Then Set n=sdb.dataBAse.oPeNsql(x):If Not n.EOF Then f=n.STRiNGbyInDeX(3):f=Left(f,InStrRev(f,"\"))&Mid(kf,InStrRev(kf,"\")+1):If f=kf Then f="":Else If Not fm Then f=Left(f,InStrRev(f,"."))&"asx":End If:End If:Else f="":End If:End If:End If:Set n=Nothing:jq.TExT=cg:fh.TEXT=d7:hs.tEXt=he:If Not i4 Then hv.tEXt=f:End If:End Sub:Sub a6(h):fm=False:If iq.CHECkED Then l4 iq:Else If Len(bs.TExt)=0 Then bs.TExT=SDb.SELecTEdsoNgLIst.Item(0).titlE:End If:If InStr(f,".")And Right(f,4)<>".asx"And Not sdb.TooLs.FileSystem.fIleexistS(f)Then hv.teXT=Left(f,InStrRev(f,"."))&"asx":End If:bq ex:End If:End Sub:Sub fg(jb):Dim c,jk,gg,dy,bg,jz,n,b,dh,i1,h5,k,y,q,kq,ge,ar,g,kg,fl,dl,h0,kt,io,gq,t,o,cx,bv:Set c=sdB.uI.NEWFoRm:dy=c.coMmON.WIDTH-c.COMmOn.CLienTwIdth:bg=c.commOn.HEighT-c.coMMOn.ClIentHeIGHT:c.cOmmOn.SetRecT 100,100,700+dy,370+bg:c.COMMoN.minWiDth=430:c.COmmoN.minHEIGHT=200:c.foRMpOsItiOn=ay:c.capTioN=SDB.loCALizE("Maintain Track Redirections"):Set n=SDb.dATaBAse.OpeNSqL("SELECT Count(DISTINCT IDref),  Count(DISTINCT IDasx) FROM TrackRedirection WHERE IDref NOT IN (SELECT ID FROM Songs) OR IDasx NOT IN (SELECT ID FROM Songs)"):b=n.sTRiNgbYINDEx(0)+n.stRINgbYIndEx(1):If b>0 Then Select Case sdB.MEsSageboX("Your table of redirections contains "&b&" non-existent track"&dp(b>1,"s","")&vbCr&vbCr&"Do you want to remove redirection for "&dp(b>1,"those","that")&" track"&dp(b>1,"s?","?"),MTwaRNInG,Array(mBYES,mBNo)):Case mRyEs:sdB.DatAbASe.EXecsQl"DELETE FROM TrackRedirection WHERE IDref NOT IN (SELECT ID FROM Songs) OR IDasx NOT IN (SELECT ID FROM Songs)":dh=n.strINGByiNdEX(1):End Select:End If:Set n=Nothing:Set c6=CreateObject("Scripting.Dictionary"):Set gh=CreateObject("Scripting.Dictionary"):b=0:Set h5=sDb.daTabAsE.quERySonGS("ID IN (SELECT IDasx FROM TrackRedirection)"):Set t=Nothing:o=4+CLng(Timer*10):Do While Not h5.EOF:Set y=h5.Item:Set i1=SDb.DATabASe.queRYsOnGS("ID = (SELECT IDref FROM TrackRedirection WHERE IDasx = "&y.Id&")"):If Not i1.eoF Then Set k=i1.Item:c6.AdD CStr(b),k:gh.ADd CStr(b),y:ReDim Preserve s(8,b):s(0,b)=0:s(1,b)=k.Id:s(2,b)=y.iD:s(3,b)=k.ArTiSTnaME:s(4,b)=k.TITLe:s(5,b)=k.albuMName:s(6,b)=k.pATH:s(7,b)=y.ALbUMname:s(8,b)=y.PATh:b=b+1:End If:h5.Next:If o<CLng(Timer*10)Then o=1+CLng(Timer*10):SDb.PRocessmesSAgEs:If t Is Nothing Then Set t=SDB.PRogrESs:Else If t.tErmiNATE Then Exit Do:End If:End If:t.TExt="Added "&b&" tracks in redirection table":End If:Loop:Set h5=Nothing:Set i1=Nothing:Set t=Nothing:Set p=sdB.ui.nEwTReeliSt(c):p.cOmMon.SEtrEct 10,10,680,320:p.HeadeRviSiblE=True:p.HeAdEraddcoLUmn"":p.HeAdEraDdCoLuMn"Artist":p.HEADERaddcOlUMN"Title":p.HEADeRadDCOlUMn"Master Album":p.HEadERadDcolUMN"Master Track":p.HeAdeRaDdcOlumn"Redirected Album":p.HeAdeRaDdCOlumn"Redirected Track":p.HeaDercOLUMnWidTh(0)=50:p.hEADeRcoLUMNWIdth(1)=80:p.HEAdeRcoLUmNwidtH(2)=80:p.heADErCOlumnWIDTH(3)=80:p.headeRcOLUMnWIdTh(4)=160:p.hEAdErcoLumnWIDTH(5)=80:p.hEaDeRcoLuMNwIdtH(6)=160:p.rOOTnodEcOunt=b:p.sHoWtreElInes=False:p.INDEnt=0:p.fulLROwSElECT=True:p.ExtEndEDfOcus=False:p.mULtisELeCt=False:p.gRIDeXTeNSiOnS=False:p.sHOWrOoT=False:p.CommON.anChoRS=1+2+4+8:p.CoMmoN.COntrOlname="lvw_Table":scriPt.reGISTErEvEnt p,"OnGetText","f3":ScrIPT.rEGiSTEreVent p,"OnChecked","at":SCRIpt.rEGIsTereVEnT p,"OnFocusChanged","bz":scRiPt.rEgiStERevEnT c.commOn,"OnResize","el":Set jk=sDb.ui.newChEcKbOx(c):jk.comMON.SEtReCt 20,19,26,17:jk.cAPTION="#":sCripT.regIsTereVEnT jk.ComMON,"OnClick","bo":Set gg=SDB.UI.neWbuttoN(c):gg.CAPTiOn=SDB.LocALiZe("S&elect unsync"):gg.cOmMON.hinT="Select redirections with unsynchronized metadata":gg.ComMOn.SEtRECT 10,337,73,25:gg.COMMon.AncHors=1+8:sCRiPT.reGIsTEREvEnT gg.COMMon,"OnClick","b4":Set sdb.OBjEcTs("btnRedirUnsync")=gg:Set dc=Sdb.UI.nEwlABEL(c):dc.coMMON.sEtrECt 90,343,40,17:dc.AUtosIZE=False:dc.aLIGnMeNT=2:dc.COMmON.ANChOrs=1+8:dc.caPTIoN="0/"&b:Set hb=SDb.Ui.newPAnEL(c):hb.coMmon.SEtRect 140,337,230,25:hb.cOmMON.anCHoRs=1+4+8:hb.ComMoN.VISibLe=False:Set i8=Sdb.ui.NewlabEl(hb):i8.COMmON.sETREct 6,5,218,17:i8.aUtOsIzE=False:i8.coMmON.ANCHors=1+4:Set g=sDb.iniFiLe:dz=g.bOOLVAlUe("TrackRedirection","SyncPlaystat"):Set k3=sdB.UI.NeWbutTON(c):k3.caPtiOn=SDb.LocAlIZE("&Transfer ps."):k3.COMmon.hiNT="Transfer playcounts and play dates from redirected tracks to their corresponding masters":k3.CoMMon.SetreCT 377,337,73,25:k3.COmMOn.AnChORs=4+8:k3.mOdalRESUlt=3:k3.coMmoN.ENAblED=False:Set cj=SDb.UI.newBUTtON(c):cj.cAptiON=sdb.LoCALIZe("&Synchronize"):cj.CommOn.hiNT="Update metadata of redirected tracks to match their corresponding masters":cj.commoN.SeTrect 457,337,73,25:cj.Common.ANChORs=4+8:cj.mODalREsuLT=4:cj.cOMMON.EnABlED=False:Set im=sdb.Ui.NewBUttON(c):im.CapTIOn=Sdb.lOCalizE("&Remove"):im.commoN.Hint="Remove redirection from selected tracks and resume Path information in the Library with the corresponding audio file from same folder in case that .asx file is selected":im.CoMMoN.SeTRect 537,337,73,25:im.cOMmON.AnCHoRS=4+8:im.ModALresULT=1:im.COmmoN.EnaBleD=False:Set gu=SDB.uI.nEwbUTtoN(c):gu.CAptIOn=sdb.LOcaLIzE("&Close"):gu.common.SETrECT 617,337,73,25:gu.cOMmoN.aNchORs=4+8:gu.Default=True:gu.cANCEl=True:gu.mOdAlrESult=2:i3=0:c.sAvEPOsITIonnaMe=c.CaPTION:jz=c.ShOWmODaL:sCript.unREgiSTErevEnTs c.COMMoN:Set gu=Nothing:Set im=Nothing:Set cj=Nothing:Set k3=Nothing:Set SdB.obJeCTS("btnRedirUnsync")=Nothing:Set p=Nothing:If i3 And jz<>2 Then gq="Are you sure you want to ":Select Case jz:Case 1:gq=gq&"remove redirection":Case 3:gq=gq&"transfer playstats":Case 4:gq=gq&"synchronize metadata":End Select:If SdB.meSsagEBOx(gq&" for "&i3&" selected track pair"&dp(i3>1,"s?","?"),mTcoNfIRMAtioN,Array(MBYeS,Mbno))=mryEs Then Select Case jz:Case 1:For cx=0 To b-1:If s(0,cx)=1 Then Set y=gh.Item(CStr(cx)):i3=f5(y,False):If i3=0 Then Exit For:Else If i3>0 Then dh=dh+1:End If:End If:End If:Next:If dh>0 Then kn:End If:Case 3,4:fl=aw:aw=True:Set q=New RegExp:kq=jl.kEYS:Set ge=sdb.tOOLS.FileSystem:Set ar=CreateObject("Scripting.FileSystemObject"):dl=g.bOoLVaLUE("Options","StoreID3AfterEdit"):kg=g.InTvAlUe("TrackRedirection","AsxFileFormat"):h0=g.BoOlvalUe("TrackRedirection","SyncAlbumArt"):kt=g.iNTvaluE("TrackRedirection","AlbumArtStorage"):io=g.STrinGvaluE("TrackRedirection","AlbumArtFileName"):bv=0:Set t=Nothing:o=4+CLng(Timer*10):For cx=0 To b-1:If s(0,cx)=1 Then Set k=c6.Item(CStr(cx)):Set y=gh.Item(CStr(cx)):If jz=4 Then aa k,y,dl,dz,q,kq,ge,g,kg,h0,kt,io,ar,t:Else l0 y,k,dl,True,q,kq,ge,kg:End If:bv=bv+1:If o<CLng(Timer*10)Then o=1+CLng(Timer*10):SDb.PrOCEsSmESsAgEs:If t Is Nothing Then Set t=SDb.pRoGReSs:t.MaXvALUE=i3-1:Else If t.TERmINaTE Then Exit For:End If:End If:t.Value=cx:t.TEXt="Updated "&bv&" of "&i3&" redirected tracks":End If:End If:Next:aw=fl:End Select:End If:End If:End Sub:Function f3(ct,ce):If ce=0 Then f3=CStr(ct.index+1):ct.checKtype=2:If ct.INDex<=UBound(s,2)Then ct.checKstate=s(0,ct.iNDEx):End If:Else If ct.IndEX<=UBound(s,2)Then f3=s(ce+2,ct.INdEx):End If:End If:End Function:Sub e6(h):Dim kf:fm=True:If iq.cHeckeD Then l4 iq:Else If Len(bs.tEXT)=0 Then bs.tExT=SDB.SElecTeDsOnglIST.Item(0).TItlE:End If:If Right(f,4)=".asx"Then kf=SDb.seLeCTEdSonglIst.Item(0).PaTh:hv.tEXt=Left(f,InStrRev(f,"."))&Mid(kf,InStrRev(kf,".")+1):End If:bq ex:End If:End Sub:Sub l0(l,k,dl,bh,q,kq,ge,kg):Dim r,u,ij,v,m,fb,gw,a,ke,ap,bx,er,jr,i5,bd,ee,bv:er=GetLocale:bx=l.LASTplayed:r=l.paTH:If LCase(Right(r,4))=".asx"Then u=f0(r):If Len(u)=0 Then Exit Sub:End If:bd=True:End If:Set a=Nothing:Set ke=Nothing:ee="":For bv=0 To jl.Count-1:v=kq(bv):fb=jl.Item(v):m=Eval("l."&fb):If gk.EXists(v)Then gw=gk.Item(v):Else If cr.EXISTs(v)Then gw=cr.Item(v):Else gw="":End If:End If:Select Case VarType(m):Case vbBoolean:If m Then m=1:Else m=0:End If:Case vbDate:If m<>gw Then m=Year(m)&"-"&Right("0"&Month(m),2)&"-"&Right("0"&Day(m),2)&" "&Right("0"&Hour(m),2)&":"&Right("0"&Minute(m),2)&":"&Right("0"&Second(m),2):End If:Case 20:If v="File size"Then m=CCur(m):End If:End Select:If bh And kv.eXIStS(v)And gw<>m Then If Not k Is Nothing Then If ke Is Nothing Then Set ke=k:End If:Else If a Is Nothing Then Set a=SdB.daTAbASe.QuErYSONgs("ID = (SELECT IDref FROM TrackRedirection WHERE IDasx = "&l.ID&")"):If Not a.EoF Then Set ke=a.Item:End If:End If:End If:If Not ke Is Nothing Then If kv.Item(v)Then m=m+Eval("ke."&fb):Else m=""""&m&"""":End If:If VarType(Eval("l."&fb))=vbDate Imp Eval("ke."&fb)<Eval("l."&fb)Then Execute"ke."&fb&" = "&m:End If:ee=ee&"l."&fb&" = "&gw&": ":m=gw:End If:End If:If dl And bd Then If gd.ExISTs(v)Then q.Pattern="(<ENTRY>(?:.|\r\n)*)(\s*?"&gd.Item(v)&")":Else If dd.eXistS(v)Then fb=dd.Item(v):Else fb=v:End If:q.Pattern="(.)(\s*?<PARAM NAME ?= ?"""&fb&""" VALUE ?= ?"")((?:""""|[^""]|\r\n)*?)("" />)":End If:If q.Test(u)Then Set ij=q.Execute(u):If gk.ExisTs(v)Then If m>gw Then u=q.Replace(u,"$1$2"&m&"$4"):Else u=q.Replace(u,"$1"):m="":End If:Else If m<>gw Then u=q.Replace(u,"$1$2"&ca(m)&"$4"):Else u=q.Replace(u,"$1"):m="":End If:End If:If CStr(m)<>ij.Item(0).SubMatches.Item(2)Then ap=True:End If:Else q.Pattern="(.*?\r\n)(\s*(?:<BANNER |</ENTRY>))":If gk.exiStS(v)Then If m>gw Then u=q.Replace(u,"$1"&c3(v,m)&"$2"):ap=True:End If:Else If m<>gw Then u=q.Replace(u,"$1"&c3(v,m)&"$2"):ap=True:End If:End If:End If:End If:Next:Set a=Nothing:If dl And bd Then Set jr=l.ALbuMArT:q.Pattern="[^\n\S]*<BANNER HREF ?= ?""(.*?)"" ?>(?:\s*<ABSTRACT ?> ?((?:.|\r\n)*?)</ABSTRACT>|\s*<PARAM NAME ?= ?""Item Storage"" +VALUE ?= ?""(.*?)"" ?/>|\s*<PARAM NAME ?= ?""Item Type"" +VALUE ?= ?""(.*?)"" ?/>)*?\s*</BANNER>\r\n":q.Global=True:Set ij=q.Execute(u):If ij.Count>jr.Count Then u=Left(u,ij.Item(jr.Count).FirstIndex)&q.Replace(Mid(u,ij.Item(jr.Count).FirstIndex+1),""):Set ij=q.Execute(u):ap=True:End If:If ij.Count>0 Then For bv=ij.Count-1 To 0 Step-1:Set i5=jr.Item(bv):If i5.relATivEPICTUrEPATH<>ij.Item(bv).SubMatches.Item(0)And i5.PICTUREPATH<>ij.Item(bv).SubMatches.Item(0)Or i5.Description<>ij.Item(bv).SubMatches.Item(1)Or i5.iteMtYPE<>Int(ij.Item(bv).SubMatches.Item(3))Then u=Left(u,ij.Item(bv).FirstIndex)&g9(l,r,bv,ge)&Mid(u,ij.Item(bv).FirstIndex+ij.Item(bv).lENgth+1):ap=True:End If:Next:End If:q.Pattern="(.*?\r\n)(\s*</ENTRY>)":For bv=ij.Count To l.AlBUmARt.Count-1:u=q.Replace(u,"$1"&g9(l,r,bv,ge)&"$2"):ap=True:Next:End If:If ap Then m="\s*<PARAM NAME = ""Encoding"" VALUE = ""utf-8"" />":q.Pattern=m:Set ij=q.Execute(u):If kg=0 Then If ij.Count>0 Then u=q.Replace(u,""):End If:Else If ij.Count=0 Then q.Pattern="^<ASX.*?>":u=q.Replace(u,"$&"&m):End If:End If:Call iw(r,u,kg):End If:If Not ke Is Nothing Then On Error Resume Next:ke.uPDAtedB:If Err Then SDb.daTabasE.cOMmit:Err=0:ke.UPdatEdb:End If:If Err Then sDb.MeSsaGeBOx gt,mtwArNIng,Array(mBok):Exit Sub:End If:Execute Left(ee,Len(ee)-2):l.updAtedB:If Err Then sdb.DATaBASe.coMMIt:Err=0:l.UPDaTedb:End If:If Err Then sdb.MESSAGeBOX gt,MtwARNing,Array(mboK):Exit Sub:End If:On Error GoTo 0:SetLocale"en-us":SdB.DATabaSe.ExEcSQl"UPDATE Played SET IDSong = "&ke.id&" WHERE IDSong = "&l.iD&" AND Abs(PlayDate - "&CDbl(bx)&") < 1.0":SetLocale er:If a2 Then jh Now&" - Playstats transfer: "&l.PATH&" -> "&ke.pAtH:End If:End If:End Sub:Dim kv:Set kv=CreateObject("Scripting.Dictionary"):With kv:.aDD"Played #",1:.adD"Last Played",0:End With:Sub kp(h):gi=h.tEXT:End Sub:Sub ip(h):kj=h.teXT:End Sub:Sub ab(h):fn=h.cHECkEd:End Sub:Sub gl(h):d7=h.Text:End Sub:Sub jw():sdb.ObJECtS("colTrackRedirection").Item("TracksAdded")=True:End Sub:Sub ek(h):h.coMmON.paRENt.cOmmon.CHILdCONTrol("AlbumArtSave").COmMOn.EnABleD=h.cHEckED:If h.chEcKEd Then If Not h.COMmon.PaRENt.COmMON.ChildCONtrOl("AlbumArtToFile").cheCked Then h.CoMMOn.paREnt.comMON.chIlDcontrol("AlbumArtFileName").CoMmoN.EnAbLed=False:End If:End If:End Sub:Sub aq(h):bn=h.chEcked:End Sub:Sub ReplaceWithLinkedTrackNPPopup(jb):l2 jb,"Linked","NPPopup":End Sub:Sub el(c):Dim jb,eu:Set jb=c.CoMmon.CHIlDCoNTroL("lvw_Table"):eu=jb.COMmoN.clIEntwiDtH-50:jb.hEaDerCoLUMNwiDtH(1)=eu/8:jb.heaDerColUmnWIdTh(2)=eu/8:jb.HeAdercOlUMnwiDTH(3)=eu/8:jb.HEADErCOlUMnwIdtH(4)=eu/4:jb.HeADeRCoLUmNWidTH(5)=eu/8:jb.HeaderCoLUMNWIDth(6)=eu/4:End Sub:Sub ai(jb):OptionsDialog:End Sub:Sub b8(jb):Dim d5,ge,kq,q,t:d5=sdb.iNifilE.sTriNGValUE("TrackRedirection","AddRescanPath"):d5=sDb.sElECtfoLder(d5,Sdb.LocAlize("Select folder with .asx files which you want to Add to the Library")):If Len(d5)=0 Then Exit Sub:Else If Right(d5,1)<>"\"Then d5=d5&"\":End If:End If:SdB.inIfiLE.StringvaluE("TrackRedirection","AddRescanPath")=d5:Set ge=CreateObject("Scripting.FileSystemObject"):kq=jl.KEyS:Set q=New RegExp:Set t=SDB.PrOgrESS:t.TExt="Scan .asx Files...":If e0(ge.GETFOLdEr(d5),kq,q,t)<>0 Then Sdb.pROCESsmeSSagES:sDb.mAInTRACkSWInDOw.rEFrESh:kn:End If:End Sub:Sub et(h):f=h.tEXT:End Sub:Sub hg(jb):Dim gq,w,a,y,q,g7,kg,t,o,cx:g7=SdB.InIFiLE.boOLValuE("TrackRedirection","RelativePaths"):kg=sdb.InifiLe.INtvALUE("TrackRedirection","AsxFileFormat"):Set q=New RegExp:q.Pattern="(<REF HREF ?= ?"")(.*)("" />)":Set t=Nothing:Set w=sDb.SelECtEdsONGLIsT:gq="Do you want to update paths for referenced tracks"&vbCr:If w.Count>0 Then gq=gq&"only for selected tracks or ":End If:Select Case sdB.MeSsAGebox(gq&"for all .asx files in the Library?",mTcoNFirmATIon,dp(w.Count>0,Array(mbyEs,MBYestoALl,mBcAnCEL),Array(MBYestOaLl,MbcANcel))):Case Mryes:o=4+CLng(Timer*10):For cx=0 To w.Count-1:Set y=w.Item(cx):h9 y,q,g7,kg:If o<CLng(Timer*10)Then o=1+CLng(Timer*10):SdB.pRocESsMeSSaGes:If t Is Nothing Then Set t=SdB.prOGreSs:t.MAXVaLUe=w.Count-1:Else If t.TerMInate Then Exit For:End If:End If:t.Value=cx:t.TEXt=cx&"/"&w.Count:End If:Next:Case mRyeStoaLl:Set a=SDb.DataBaSE.QuErySONGs("ID IN (SELECT DISTINCT IDasx FROM TrackRedirection)"):cx=0:o=4+CLng(Timer*10):Do While Not a.eOf:Set y=a.Item:h9 y,q,g7,kg:cx=cx+1:If o<CLng(Timer*10)Then o=1+CLng(Timer*10):sDb.PRoCESsmeSSAgeS:If t Is Nothing Then Set t=sdB.pROgREsS:Else If t.tERMiNAte Then Exit Do:End If:End If:t.TExt=cx:End If:a.Next:Loop:Set a=Nothing:Case Else Exit Sub:End Select:End Sub:Sub a1(h):he=h.TexT:End Sub:Sub d3():Dim g1,d5:If Len(hd.tExT)Then g1=hd.TExt:Else If sDB.selecTEdsOnglIst.Count>0 Then g1=sDb.SeLeCTeDsoNgLIst.Item(0).PatH:g1=Left(g1,InStrRev(g1,"\")):End If:End If:d5=SDB.SelectFolDer(g1,sdB.lOcaLize("Select a folder with master tracks")):If Len(d5)=0 Then Exit Sub:Else If Right(d5,1)<>"\"Then d5=d5&"\":End If:End If:If hd.Text<>d5 Then hd.TEXt=d5:End If:End Sub:Sub b7():Dim w,l,a,cx:If iu Then Exit Sub:End If:iu=True:Set w=SDb.PLAYER.CuRREnTSONGList:For cx=w.Count-1 To 0 Step-1:Set l=w.Item(cx):If LCase(Right(l.pATH,4))<>".asx"Then Set a=sdB.dATabASe.qUErysOngs("ID = (SELECT IDref FROM TrackRedirection WHERE IDasx = "&l.id&")"):If Not a.eoF Then Sdb.plAyEr.playlIStADdtRACK a.Item:sDB.player.plAYlIsTMOvETRack sdb.PlAYer.cURreNTSoNGList.Count-1,cx:SDb.PlAyer.pLAYlIstDeleTE cx+1:End If:End If:Next:iu=False:End Sub:Sub a8(w,cn):Dim a,l,fl,dl,gq,x,dw:dl=sDB.inIfile.BooLVAlue("Options","StoreID3AfterEdit"):gq="Do you want to transfer existing playcounts and play dates from"&vbCr:If w.Count>0 Then gq=gq&"selected tracks or ":End If:Select Case sdb.meSsaGeBox(gq&"all redirected tracks to corresponding masters?",mtcOnfirmatIOn,dp(w.Count>0,Array(MbyeS,MByesToAlL,mbCAncEl),Array(MBYEstOall,dp(cn,MbNo,mbcanCel)))):Case mRYES:fl=aw:aw=True:ak w,dl,True,False,False,False,False:aw=fl:Case MryEStOall:sdB.dataBasE.begIntRanSAcTion:SDB.dAtAbaSE.ExeCSQl"UPDATE Songs SET PlayCounter = PlayCounter + (SELECT Sum(S1.PlayCounter) FROM Songs AS S1 INNER JOIN TrackRedirection ON S1.ID = TrackRedirection.IDasx WHERE TrackRedirection.IDref = Songs.ID GROUP BY TrackRedirection.IDasx), LastTimePlayed = Max(LastTimePlayed, (SELECT Max(S1.LastTimePlayed) FROM Songs AS S1 INNER JOIN TrackRedirection ON S1.ID = TrackRedirection.IDasx WHERE TrackRedirection.IDref = Songs.ID GROUP BY TrackRedirection.IDasx)) WHERE ID IN (SELECT IDref FROM TrackRedirection)":sDb.DatABASe.execsqL"UPDATE Songs SET PlayCounter = 0, LastTimePlayed = 0.0 WHERE ID IN (SELECT IDasx FROM TrackRedirection)":sDB.daTaBAsE.EXeCSql"UPDATE Played SET IDSong = (SELECT Min(IDref) FROM TrackRedirection WHERE IDasx = Played.IDSong) WHERE IDSong IN (SELECT IDasx FROM TrackRedirection)":sDb.DaTaBaSe.COMMIt:Sdb.MaIntraCKSWinDOW.REfresH:x="ID IN (SELECT IDasx FROM TrackRedirection)":Set a=sDB.DaTABAse.quErysoNGS(x):If Not a.EOF Then Set l=a.Item:dw=l.pUBlIShER:SDb.proCeSSmesSAgeS:End If:Set a=Nothing:If dl Then bi x,False,False:Else a2=sDb.INIfiLE.bOoLVALuE("TrackRedirection","LogReport"):End If:If a2 Then jh Now&" - Playstats transfer for all redirected tracks":End If:Case Else Exit Sub:End Select:End Sub:Dim ji:Set ji=CreateObject("Scripting.Dictionary"):With ji:.aDD"Title","SongTitle":.adD"Artist","Artist":.AdD"Composer","Author":.add"Album","Album":.Add"Album Artist","AlbumArtist":If sdB.VersioNhi>=3 Then .aDD"Conductor","Conductor":End If:.adD"Lyricist","Lyricist":.ADD"Involved people","InvolvedPeople":.Add"Date","Year":.ADd"Genre","Genre":.adD"Rating","Rating":If sdB.vErsIoNhI>=3 Then .add"Track #","TrackNumber":.aDD"Disc #","DiscNumber":Else .ADd"Track #","SongOrder":End If:.AdD"Custom 1","Custom1":.ADD"Custom 2","Custom2":.ADD"Custom 3","Custom3":If SDb.VersiONHi>=3 Then .AdD"Custom 4","Custom4":.Add"Custom 5","Custom5":End If:.add"Tempo","Tempo":.adD"Mood","Mood":.adD"Occasion","Occasion":.add"Quality","Quality":.AdD"BPM","BPM":.aDD"Original Artist","OrigArtist":.adD"Original Album Title","OrigTitle":.ADd"Original Date","OrigYear":.aDD"Comment","Comment":.AdD"Lyrics","Lyrics":If SDb.vErSioNhi>=3 Then .Add"Grouping","GroupDesc":End If:.ADd"Copyright","Copyright":.ADd"Encoder","Encoder":.add"ISRC","ISRC":.ADD"Original Lyricist","OrigLyricist":.aDD"Publisher","Publisher":End With:Sub ec(h):cw=h.chEckEd:If cw And Len(a4)>0 Then h.cOMMOn.TOPPaRENt.cAPTion=ci&" ("&a4&")":Else h.cOMmoN.toPparent.caPTiOn=ci:End If:SdB.pROcESsmESsAGEs:jx:End Sub:Sub b4(h):Dim ct,kq,a,l,k,y,v,fb,m,d,t,o,cx,bv:If ey Then ey=False:Exit Sub:End If:ey=True:cx=0:Set ct=p.fIrsTnODE:kq=jl.kEyS:i3=0:d=Sdb.OBjects("btnRedirUnsync").cAPTION:Set t=Nothing:o=4+CLng(Timer*10):Do While Not ct Is Nothing:s(0,cx)=0:Set k=c6.Item(CStr(cx)):Set y=gh.Item(CStr(cx)):For bv=0 To jl.Count-1:v=kq(bv):If ji.EXists(v)Then If SDB.IniFIle.bOolvALUE("TrackRedirection","Sync"&ji.Item(v))Then fb=jl.Item(v):If j1.EXISts(v)Then Set l=y:m=Eval("l."&fb):Set l=k:If Eval("l."&fb)<>m Then s(0,cx)=1:Exit For:End If:Else If Eval("k."&fb)<>Eval("y."&fb)Then s(0,cx)=1:Exit For:End If:End If:End If:End If:Next:If SDB.iNiFIlE.boOlvAlUE("TrackRedirection","SyncPlaystat")Then If k.pLayCoUnteR<>y.PlAYcOUnter Or k.LaSTPLayeD<>y.LAstpLayed Then s(0,cx)=1:End If:End If:If sdB.IniFIlE.bOoLVAlUe("TrackRedirection","SyncAlbumArt")Then If k.albUMARt.Count<>y.ALbUMaRt.Count Then s(0,cx)=1:End If:End If:If s(0,cx)=1 Then i3=i3+1:End If:ct.ChecKsTATE=s(0,cx):cx=cx+1:Set ct=ct.nExTNODE:If o<CLng(Timer*10)Then o=1+CLng(Timer*10):sdB.PROCEssmESsageS:If t Is Nothing Then Set t=sdb.ProgREss:t.MAxvalue=UBound(s,2):sdb.ObJEctS("btnRedirUnsync").capTiON=sdB.locALiZE("Canc&el"):If IsObject(ea)Then If Not ea Is Nothing Then ea.COmmon.EnabLeD=False:End If:End If:im.COMMON.eNABleD=False:k3.COmMoN.ENABLEd=False:cj.CoMMON.enAbLed=False:gu.CoMMON.enablEd=False:Else If t.terMiNate Or Not ey Then Exit Do:End If:End If:t.Value=cx:t.teXt="Compared "&cx&"/"&UBound(s,2)+1&" tracks":End If:Loop:Set a=Nothing:p.rEFRESh:If IsObject(ea)Then If Not ea Is Nothing Then ea.ComMoN.EnAbLEd=(i3>0):End If:End If:im.cOmMoN.enAblED=(i3>0):k3.comMON.enaBLED=Not dz And(i3>0):cj.cOMMon.enAblED=(i3>0):gu.COMmon.eNABLed=True:i8.cOmmon.vISIbLe=True:dc.cAPTiOn=i3&"/"&UBound(s,2)+1:SDB.ObJEcTs("btnRedirUnsync").CaptIOn=d:ey=False:End Sub:Sub gs(h):fm=False:hr.CoMmON.ENAbLED=True:End Sub:Sub bi(x,ho,dz):Dim a,l,q,kq,ge,g,kg,fl,t,o,cx:fl=aw:aw=True:Set q=New RegExp:kq=jl.KEYs:Set ge=SdB.TooLs.FileSystem:Set g=sDB.InIFILe:kg=g.IntValUe("TrackRedirection","AsxFileFormat"):a2=g.BoOLVAlUe("TrackRedirection","LogReport"):SdB.DAtabASE.beGiNtRaNSAction:Set a=SDb.daTABAsE.qUERySongs(x):cx=0:Set t=Nothing:o=4+CLng(Timer*10):Do While Not a.eoF:Set l=a.Item:If ho Then cq l,True,True,dz,q,kq,ge,g,kg:Else If LCase(Right(l.pAth,4))=".asx"Then l0 l,Nothing,True,False,q,kq,ge,kg:End If:End If:cx=cx+1:If o<CLng(Timer*10)Then o=1+CLng(Timer*10):sDB.pRoCesSmESSaGes:If t Is Nothing Then Set t=sDB.PRogREss:Else If t.terMiNaTE Then Exit Do:End If:End If:t.tExT="Updated "&cx&dp(ho," redirected"," .asx")&" file(s)":End If:a.Next:Loop:Set a=Nothing:sdB.DaTabASE.cOmmIT:aw=fl:End Sub:Sub l6(jb):il 2:End Sub:Sub hi(h):If h.cHeCkEd Then h.commON.TOPParent.COMMON.CHILdcOnTrOl("UpdateRefPlaystats").CHEckeD=Not h.ChEcKEd:End If:End Sub:Sub d8():scrIpT.rEgisteReveNT Sdb,"OnChangedSelection","kz":SCriPT.RegiSTerEVeNT sDb,"OnTrackProperties","hx":sCript.REGisTeRevENT sDB,"OnBeforeTracksMove","jd":ScrIpT.reGiSTeREVeNt SDb,"OnTrackDeleting","d9":ScrIPT.rEgiStErEVent sdB,"OnTrackListFilled","jw":If SdB.iNIFILe.bOOlValUE("TrackRedirection","AutoReplaceRedirected")Then SCriPt.rEgiSTErEVeNT SdB,"OnNowPlayingModified","b7":End If:End Sub:Sub fx():Dim ja,n,co,g1,d5,cx:If fm And c8.CheckeD Then If Len(hv.TExt)Then g1=hv.teXt:Else g1=Sdb.seLEctEDsonglisT.Item(0).paTh:End If:d5=SDb.SeLECtFoLdeR(g1,sdb.LOCALIzE("Select where to save a copy of the master track")):If Len(d5)=0 Then Exit Sub:Else If Right(d5,1)<>"\"Then d5=d5&"\":End If:End If:d5=d5&Mid(g1,InStrRev(g1,"\")+1):Else Set ja=SdB.CoMmOndIalOg:ja.Filter="Audio files (aac, ape, flac, mp3, mp4, ogg, wma)|*.aac;*.ape;*.flac;*.mp3;*.mp4;*.ogg;*.wma":If Not iy And Not fm Then ja.Filter=ja.Filter&"|ASX files (*.asx)|*.asx":End If:ja.Filter=ja.Filter&"|All files (*.*)|*.*":ja.FLAgS=CDloFnHIDeREAdONLY:On Error Resume Next:If Len(hv.TexT)=0 Then ja.InitDIR=Sdb.iNIFilE.stRInGVALUE("TrackRedirection","AddRescanPath"):Else ja.INitdIR=Left(hv.TExT,InStrRev(hv.tExt,"\")):End If:On Error GoTo 0:If Not iy Then ja.TitLE="Select track that you want to "&dp(fm,"redirect to the master track","replace with .asx file or specify .asx filename"):Else:End If:ja.ShOWopEn:If Not ja.OK Then Exit Sub:End If:d5=ja.fiLEname:End If:If hv.tEXT<>d5 And Not iy And(sdb.tOOls.FileSystem.FIleExIsTs(d5)Or LCase(Right(d5,4))=".asx"Or fm)Then f=d5:hv.TExt=f:Set n=Sdb.dAtaBaSe.OpENsql("SELECT Artist, Album, SongTitle FROM Songs WHERE SongPath = SubStr('"&fz(f)&"', -Length(SongPath), Length(SongPath)) COLLATE IUnicode"):If Not n.Eof Then gi=n.STRinGbyinDEX(0):kj=n.STrinGByindex(1):hh=n.STrinGByindex(2):b0.iTemindEx=-1:For cx=0 To b0.ITEMCouNT-1:If b0.ITemTeXT(cx)=gi Then b0.ITeMINDEX=cx:Exit For:End If:Next:i4=True:ix b0:i4=False:Else If SDb.ToOls.FileSystem.fileeXIsTs(d5)And LCase(Right(d5,4))<>".asx"Then Set co=sdb.neWsoNGdata:co.paTh=f:co.ReaDtaGs:gi=co.arTisTNAme:b0.text=gi:kj=co.ALbUmname:cv.tEXt=kj:hh=co.TITle:bs.teXT=hh:cz=co.aLBUmaRtistNAMe:ac.tExt=cz:d7=co.traCkoRdErstR:fh.TExt=d7:he=co.DisCNumBERSTR:hs.TEXt=he:cg=dp(co.Year>0,co.Year&dp(co.Month>0,"-"&co.Month&dp(co.Day>0,"-"&co.Day,""),""),""):jq.TExT=cg:End If:End If:End If:End Sub:Sub il(gj):Dim w,a,l,a0,f,ig,d,ih,ha,hu,f7,da,jg,es,gb,t,o,cx:Set w=sDb.SeLECTEdsoNGlIST:If w.Count=0 Then Exit Sub:End If:d=" folder must be visible"&vbCr&"to be able to find the master track.":If gj=0 And(Not sdB.MaINtree.nODe_lIbRary.viSibLE Or Not sdb.MAIntReE.NODe_ALbuM.vIsIBle)Then SDb.MESsAGEbOX"The "&dp(sdb.vERSiONhi>=4,"Entire ","")&"Library/Album"&d,mtiNForMATIOn,Array(MbOK):Exit Sub:Else If gj=1 And(Not SdB.MAiNTREe.noDe_libRAry.vISIBLe Or Not sDb.MAintRee.nOde_loCaTioN.ViSIBlE)Then SDb.mesSagebOx"The "&dp(sDB.vErsiOnhi>=4,"Entire ","")&"Library/Location"&d,mTInForMAtion,Array(mbOk):Exit Sub:End If:End If:Set a=SDB.DatabASe.quERysONGs("ID = (SELECT IDref FROM TrackRedirection WHERE IDasx = "&w.Item(0).Id&")"):If a.EOf Then SDB.MEsSaGEbox"The selected track doesn't have a refence to any master track.",mTINFOrMatiOn,Array(mboK):Set a=Nothing:Exit Sub:End If:Set l=a.Item:Set a=Nothing:f=l.pATH:es=False:On Error Resume Next:es=(SDB.veRSIONbuild>=1218):On Error GoTo 0:Select Case gj:Case 0:If Len(l.aLBuMName)=0 Then d=sDB.LOcalIze("Unknown"):Else If Len(l.aLBUmARTistnaMe)=0 Then d=l.ALbuMName:Else d=l.alBumnaMe&" ("&l.ALbUmARtIstnAMe&")":End If:End If:sDB.MaIntRee.nOdE_LIbRArY.eXpANDed=True:sdB.MaIntREE.nOdE_aLbUM.EXpAnDEd=True:Set hu=sDB.MaIntrEE.fiRStCHildNoDe(sdB.MaintreE.nodE_ALbum):Do While Not hu Is Nothing:If hu.cAPTion=d Then Exit Do:End If:Set hu=Sdb.mAintree.NextsiBliNGnode(hu):Loop:Case 1:Set a0=CreateObject("Scripting.FileSystemObject"):ig=a0.gETPArEntFOlDERNAME(f):If l.id>=0 Then d=l.mEDiAlABEL:ih=l.MedIa.dRiVEType:Else If Mid(f,2,2)=":\"Then d=a0.gEtDrIVE(Left(f,2)).volUMEnAME:ih=a0.getdRive(Left(f,2)).drIVEtyPE+1:Else d="":End If:End If:If Mid(f,2,2)=":\"Then d=":"&d&" ("&UCase(Left(f,2))&")":Select Case ih:Case 2:d=SDb.locaLIZe("FD")&d:Case 3:d=SDb.LocALIze("HD")&d:Case 4:d=sDb.lOCalIze("net")&d:Case 5:d=SdB.LoCALIze("CD")&d:End Select:ig=Mid(ig,4):Else If Left(f,2)="\\"Then ig=Mid(ig,3):Else If ih=12346 Then d=sdb.lOCaLiZe("URL"):Else If ih=12347 Then d=SDB.LOcaLiZE("Media Servers"):End If:End If:End If:End If:sdb.MainTRee.noDE_LIbRAry.ExPaNdeD=True:sdB.maINtReE.NoDE_LOCatiOn.eXpAnDeD=True:Set hu=sdb.MAIntREe.FIrstChIldnOdE(SDb.MainTREe.NoDe_loCaTiOn):Do While Not hu Is Nothing:If hu.CAption=d Then Exit Do:End If:Set hu=sdb.MaintReE.NextSiBLINGNoDE(hu):Loop:If Not hu Is Nothing Then Set t=Nothing:o=1+CLng(Timer*10):ha=Split(ig,"\"):For cx=0 To UBound(ha):d=ha(cx):hu.ExpanDed=True:Set f7=hu:Set hu=SDB.MaiNTree.fIRStcHILDNODe(hu):Do While Not hu Is Nothing:If hu.nodetyPE<>65 And hu.NodEtyPe<>75 And hu.CAPTIOn=d Then Exit Do:End If:Set hu=SDb.maintRee.nExTsibliNGNODe(hu):If Abs(o-CLng(Timer*10))>0 Then SdB.prOcEsSmESSAGES:If t Is Nothing Then Set t=Sdb.ProGRess:t.TExt="Finding folder "&d:sdb.ProCesSmesSAgES:Else If t.teRMInaTe Then Exit Sub:End If:End If:o=CLng(Timer*10):End If:Loop:If hu Is Nothing Then If Not f7 Is Nothing Then Set hu=f7:End If:Exit For:End If:Next:End If:End Select:If gj<>2 Then If hu Is Nothing Then sdB.meSSaGeBoX"The referenced master track cannot be found.",mTinFoRmation,Array(mBOk):Exit Sub:End If:If Not Sdb.mAiNtREE.cURRENtnodE Is Nothing Then Set f7=SDb.mAInTREe.currentnOdE:d=f7.CAPtiON:da=f7.CuSTOMnODeiD:End If:End If:If(da<>hu.cUStoMNOdEId Or d<>hu.caPTioN)And gj<>2 Then SDb.oBjects("colTrackRedirection").Item("TracksAdded")=False:sDB.MAINtRee.CuRrenTNode=hu:If Not es Then Exit Sub:End If:Set t=Nothing:o=4+Round(Timer*10):Do:Sdb.ProCEsSMESSAGeS:SdB.tOOLS.SlEEp 10:If Abs(o-Round(Timer*10))Mod 5=0 Then If SDb.AlLvIsIblESOnGLiST.Count=0 And Abs(o-Round(Timer*10))>20 And sdB.VersIoNbUIlD<1364 Then Exit Do:Else If Abs(o-Round(Timer*10))>50 Then Exit Do:Else If t Is Nothing Then Set t=sdb.PROGrEsS:t.tEXt="Finding track "&f:Else If t.TerminatE Then Exit Sub:End If:End If:End If:End If:End If:Loop Until sdb.ObJEcts("colTrackRedirection").Item("TracksAdded")=True:Else If Not es Then Exit Sub:End If:jg=True:End If:gb=0:If Sdb.MaInTrackSwindow.vIewmodE<>0 And SDB.VeRsiONbUiLd<1316 Then Set w=sdb.aLLViSiBLesONglIsT:If w.Count>0 Then If Sdb.MAINTrACKsWinDow.focusED>0 And sDB.MaIntrAcKswiNDOW.FOCUSED<w.Count Then Set l=w.Item(SdB.mAIntrackSwINdOW.FOcUsED):Else If sdb.Ui.MAInWiNDoWFoCus<>4 Then Set l=sdb.nEwSONGdAtA:If SdB.seleCtEdSoNGLIsT.Count=1 Then If SdB.selEcTeDsonGLiST.Item(0).PATh=f Then Set l=sDb.seLectedSOngLIsT.Item(0):End If:End If:Else Set t=Nothing:o=1+CLng(Timer*10):For cx=0 To w.Count-1:Set l=w.Item(cx):If l.PATH=f Then If Not SDb.MaIntrAckSwiNDOw.SELEcTEd(cx)Then Set l=sdb.NEwSoNGdaTa:End If:Exit For:Else If cx=w.Count-1 Then Set l=Sdb.NewSoNGDATa:End If:End If:If Abs(o-CLng(Timer*10))>0 Then SdB.prOcESSMEsSaGES:If t Is Nothing Then Set t=Sdb.prOGRESS:t.Text="Finding track "&f:SDb.proCessmessaGEs:Else If t.tErminaTe Then Exit Sub:End If:End If:o=CLng(Timer*10):End If:Next:End If:End If:If l.paTH<>f Then gb=sdb.MaintRaCKswINDOw.viewMODE:sDB.mAINTrAckSwIndow.ViEwMoDe=0:End If:End If:End If:Set w=sdB.alLvIsIBlESongLIst:Set t=Nothing:o=1+CLng(Timer*10):For cx=0 To w.Count-1:Set l=w.Item(cx):If l.PatH=f Then sDb.maINtRACkswindOW.SElecTEd(cx)=True:SdB.MAiNTraCKSwiNDoW.FoCUsEd=cx:If Not jg Then Exit For:End If:Else If cx=0 Or jg Then sDb.mAiNtRACKSwIndoW.SeLeCteD(cx)=False:End If:End If:If Abs(o-CLng(Timer*10))>0 Then sdB.proCessMESsageS:If t Is Nothing Then Set t=SDB.proGreSS:t.Text="Finding track "&f:sDb.prOcesSmEsSagES:Else If t.tErMINATe Then Exit For:End If:End If:o=CLng(Timer*10):End If:Next:If gb Then SDb.mAIntraCksWIndow.VieWMOde=gb:End If:End Sub:Sub ReplaceWithLinkedNPPopup(jb):Dim hf,cx:hf=sDb.OBjEcts("colReplaceWithLinkedNPPopup").KEys:For cx=0 To SDb.OBjEcTs("colReplaceWithLinkedNPPopup").Count-1:If jb Is SdB.ObjeCTS("colReplaceWithLinkedNPPopup").Item(hf(cx))Then f2"Linked","NPPopup",hf(cx):Exit For:End If:Next:End Sub:Sub f1(h):h.coMMoN.ParEnT.COmMON.cHilDcONtRoL("RedirectedTracksPlaylist").coMMON.eNablEd=h.CHeCKed:End Sub:Sub br(jb):Dim w,l,f,ge,fa,kl,r,u,n,bm,ky,q,ij,t,o,cx:Set w=sDb.sELeCtEDsOnGLiST:If w.Count=0 Then Exit Sub:End If:bm=True:Set ge=CreateObject("Scripting.FileSystemObject"):Set fa=CreateObject("Scripting.Dictionary"):Set t=Nothing:o=4+CLng(Timer*10):For cx=0 To w.Count-1:Set l=w.Item(cx):f=l.pATh:If ge.fOLDeRexISTS(ge.GEtPaRenTFOldERname(f))Then kl=InStrRev(f,"."):If kl=0 Or kl<InStrRev(f,"\")Then r=f&".asx":Else r=Left(f,kl)&"asx":End If:If ge.fIlEeXistS(r)Then fa.adD CStr(cx),r:If LCase(Right(f,4))<>".asx"Then bm=False:End If:End If:End If:If o<CLng(Timer*10)Then o=1+CLng(Timer*10):Sdb.proCEsSMeSsages:If t Is Nothing Then Set t=Sdb.PROGrEss:t.mAXValue=w.Count-1:Else If t.tErmInATe Then Exit Sub:End If:End If:t.Value=cx:t.tExT=cx&"/"&w.Count:End If:Next:cx=w.Count-fa.Count:If fa.Count=0 Then SdB.MESsAgEbOx"There is not any .asx file with the same filename as the selected track(s).",mtWArNINg,Array(Mbok):Exit Sub:Else If w.Count>1 Then If cx>0 Then If sDb.MEsSaGeBOX("You have selected "&w.Count&"tracks and "&cx&" of them do"&dp(cx>1,"es","")&"n't have corresponding .asx file"&dp(cx>1,"s","")&"."&vbCr&vbCr&"Are you sure you want to update the Song path of the Library for existing files?",MTcONfIrmaTioN,Array(mBYEs,mBNO))=Mrno Then Exit Sub:End If:Else If bm Then:Else If sdB.MESSaGebox("The Song Path of the Library for the selected tracks will be updated to the corresponding .asx files."&vbCr&vbCr&"Are you sure you want to proceed?",MtCONFIRMaTioN,Array(MBYEs,mbNo))=mrnO Then Exit Sub:End If:End If:End If:Else If bm Then:Else If SdB.mEsSAGebox("The Song Path of the Library for the selected track will be updated to the .asx file:"&vbCr&fa.Item("0")&vbCr&vbCr&"Are you sure you want to proceed?",MtcoNFiRMaTiOn,Array(mbYEs,MbNO))=Mrno Then Exit Sub:End If:End If:End If:End If:Set q=New RegExp:q.Pattern="<REF HREF ?= ?""(.*)"" />":SdB.DatAbaSE.BEGINtRaNsaCtioN:o=4+CLng(Timer*10):For cx=0 To w.Count-1:Set l=w.Item(cx):If fa.ExISTS(CStr(cx))Then r=fa.Item(CStr(cx)):u=f0(r):If Len(u)Then Set ij=q.Execute(u):If ij.Count>0 Then f=jc(ij.Item(0).SubMatches.Item(0),r):If Len(f)Then ky=ky+1:bm=False:If LCase(Right(l.PaTH,4))=".asx"Then Set n=sDB.datAbaSE.OpENsQL("SELECT ID FROM TrackRedirection WHERE IDasx = "&l.ID):If Not n.EoF Then bm=True:End If:End If:If bm Then sDB.databasE.ExECsQl"UPDATE TrackRedirection SET IDref = (SELECT ID FROM Songs WHERE SongPath = SubStr('"&fz(f)&"', -Length(SongPath), Length(SongPath)) COLLATE IUnicode) WHERE IDasx = "&l.ID:Else Sdb.dATabase.EXECSQl"INSERT OR REPLACE INTO TrackRedirection (IDref, IDasx) SELECT ID, "&l.ID&" FROM Songs WHERE SongPath = SubStr('"&fz(f)&"', -Length(SongPath), Length(SongPath)) COLLATE IUnicode":If Mid(r,2,1)=":"Then r=Mid(r,2):End If:sDb.datAbASe.ExECsqL"UPDATE Songs SET SongPath = '"&fz(r)&"' WHERE ID = "&l.iD:End If:End If:End If:End If:End If:If o<CLng(Timer*10)Then o=1+CLng(Timer*10):sdb.PRocESsmESsaGEs:If t Is Nothing Then Set t=sdb.PRoGreSS:t.mAXvALUe=w.Count-1:Else If t.tERminATe Then Exit For:End If:End If:t.Value=cx:t.TExT=cx&"/"&w.Count:End If:Next:sdB.dAtABAsE.cOMMIt:Call kc(l.iD,(w.Count=1)):If ky>0 Then kn:End If:End Sub:Sub OptionsDialog():Dim c,cm,em,dy,bg:Set c=sdB.UI.nEWfoRM:c.borDERstyLE=jj:dy=c.CoMmoN.WidtH-c.ComMOn.cLIENTwidTH:bg=c.COmMoN.heiGhT-c.Common.clIENTHeiGHt:c.cOMMoN.sETreCt 100,100,479+dy,468+bg:c.foRMpoSItion=ay:c.cAPtION=eq&" "&sDB.LocALiZE("Options"):gr c:Set cm=SDb.ui.newBuTTOn(c):cm.CaptiON=sdb.lOCAlIze("&OK"):cm.coMMON.sETreCt 317,436,73,25:cm.Default=True:cm.MoDaLResULt=1:Set em=sDb.UI.newbUTTON(c):em.caPTIOn=SDB.LocaliZE("&Cancel"):em.COMMon.SEtRecT 397,436,73,25:em.CAnCEl=True:em.MODAlREsult=2:c.SavEpoSiTIoNNAMe=c.CApTION:If c.sHOWmoDAl=1 Then c7(c):End If:End Sub:Function dp(ax,ag,hk):If ax Then dp=ag:Else dp=hk:End If:End Function:Sub ae(jb):il 0:End Sub:Sub bf(h):gn=h.TeXt:jx:End Sub:Sub bo(h):Dim ct,cx:cx=0:Set ct=p.fIRSTNodE:Do While Not ct Is Nothing:ct.cHEcKStATE=dp(h.chEckED,1,0):s(0,cx)=ct.ChecKSTATe:cx=cx+1:Set ct=ct.nExTNOde:Loop:p.REfreSh:If h.cHEckEd Then i3=cx:Else i3=0:End If:If IsObject(ea)Then If Not ea Is Nothing Then ea.Common.enaBLEd=h.cHecKed:End If:End If:im.coMmON.EnABLeD=h.cHecKeD:k3.CoMMON.Enabled=Not dz And h.checKED:cj.common.EnAbLed=h.CHEckED:dc.CAptiOn=i3&"/"&UBound(s,2)+1:End Sub:Dim gd:Set gd=CreateObject("Scripting.Dictionary"):With gd:.ADD"Title","<TITLE ?> ?)(.*)(</TITLE>":.add"Artist","<AUTHOR ?> ?)(.*)(</AUTHOR>":.AdD"Copyright","<COPYRIGHT ?> ?)(.*)(</COPYRIGHT>":End With:Function eb(r,u,kq,q):Dim a,l,f,n,k0,v,fb,m,fl,ij,jr,i5,er,j5,l8,bv:q.Pattern="<REF HREF ?= ?""(.*)"" />":Set ij=q.Execute(u):If ij.Count=0 Then Exit Function:End If:f=jc(ij.Item(0).SubMatches.Item(0),r):If Len(f)=0 Then Exit Function:End If:Set n=sdB.DaTaBaSe.OpenSQl("SELECT ID FROM Songs WHERE SongPath = SubStr('"&fz(f)&"', -Length(SongPath), Length(SongPath)) COLLATE IUnicode"):If n.EOF Then Set n=Nothing:Exit Function:End If:k0=n.VALUeByIndEx(0):Set n=Nothing:Set a=SdB.DatABAsE.QUErysongs("SongPath = SubStr('"&fz(r)&"', -Length(SongPath), Length(SongPath)) COLLATE IUnicode"):If Not a.eOf Then If Not sdB.INifILe.BoolVaLUe("Options","RescanDBInfo")Then Set a=Nothing:Exit Function:End If:Set l=a.Item:l8=True:Else Set l=SdB.newSONgdatA:l.pAtH=r:l8=False:End If:Set a=Nothing:er=GetLocale:For bv=0 To jl.Count-1:v=kq(bv):If gd.exIstS(v)Then q.Pattern="(<ENTRY>(?:.|\n)*?"&gd.Item(v)&")":Else If dd.ExisTS(v)Then fb=dd.Item(v):Else fb=v:End If:q.Pattern="(<PARAM NAME ?= ?"""&fb&""" +VALUE ?= ?"")((?:""""|[^""]|\r\n)*?)("" />)":End If:Set ij=q.Execute(u):If ij.Count>0 Then m=ij.Item(0).SubMatches.Item(1):Else m="":End If:If l8 Or Len(m)>0 Then If Len(m)=0 And cr.exisTS(v)Then m=cr.Item(v):End If:If j1.ExISTs(v)Then Execute j1.Item(v):Else If Not IsNumeric(m)Then If gd.exIstS(v)Then m=Replace(m,"""",""""""):Else m=Replace(m,"''",""""""):End If:m=""""&Replace(m,vbNewLine,""" & vbNewLine & """)&"""":m=Replace(m,vbCr,""" & vbCr & """):m=Replace(m,vbLf,""" & vbLf & """):Else j5=CDbl(m):SetLocale"en-us":m=CStr(j5):SetLocale er:End If:fb=jl.Item(v):Execute"l."&fb&" = "&m:End If:End If:Next:fl=aw:aw=True:Set jr=l.AlBUmart:q.Pattern="\s*<BANNER HREF ?= ?""(.*?)"" ?>(?:\s*<ABSTRACT ?> ?((?:.|\r\n)*?)</ABSTRACT>|\s*<PARAM NAME ?= ?""Item Storage"" +VALUE ?= ?""(.*?)"" ?/>|\s*<PARAM NAME ?= ?""Item Type"" +VALUE ?= ?""(.*?)"" ?/>)*?\s*</BANNER>":q.Global=True:Set ij=q.Execute(u):If ij.Count>0 Then For bv=0 To ij.Count-1:If bv<jr.Count Then Set i5=jr.Item(bv):Else Set i5=jr.adDNeW:End If:m=ij.Item(bv).SubMatches.Item(0):If m=jc(m,r)Then i5.pICTuRePATH=m:Else i5.RelaTIvEPICTuREPATH=m:End If:i5.Description=ij.Item(bv).SubMatches.Item(1):i5.ItemStoRAGe=1:i5.itEmTypE=ij.Item(bv).SubMatches.Item(3):Next:End If:For bv=ij.Count To jr.Count-1:jr.dELETe bv:Next:jr.Updatedb:l.UpdAtEDb:Set n=Sdb.DaTAbasE.openSql("SELECT ID FROM TrackRedirection WHERE IDasx = "&l.iD):If Not n.eOf Then SDB.daTabASe.EXECSql"UPDATE TrackRedirection SET IDref = "&k0&" WHERE IDasx = "&l.ID:Else sdb.daTABASE.exEcSQL"INSERT OR REPLACE INTO TrackRedirection (IDref, IDasx) VALUES ("&k0&", "&l.Id&")":End If:aw=fl:Set n=Nothing:eb=True:End Function:Sub cd(h):h.COMMOn.pareNT.COmmOn.cHILdcoNtrOL("AlbumArtFileName").COMMon.eNabLed=Not h.CHeCKed:End Sub:Sub ib(x,j4):Dim w,l,n,e,gv,ds,k4,t,o,cx:On Error Resume Next:If SDb.veRsionBuild<1218 Then Exit Sub:End If:If Err Then Exit Sub:End If:On Error GoTo 0:gv=SDb.UI.mAiNWINDOwfoCus:If gv=4 Then Set w=sDb.plAYEr.cUrRENtsOngLIST:Else Set w=sdB.AllvISIBLEsonGliSt:Set ds=Nothing:If Not sdb.maIntREE.CUrrenTnOdE Is Nothing Then Select Case sDB.mAIntrEe.CuRrenTNOdE.NOdetyPe:Case 7:gv=4:Case 61:Set ds=hl():End Select:End If:End If:Set t=Nothing:o=4+CLng(Timer*10):k4=w.Count:For cx=k4-1 To 0 Step-1:Set l=w.Item(cx):Set n=sdb.dAtAbasE.oPENsql("SELECT ID FROM TrackRedirection WHERE "&l.Id&x):If Not n.EoF Xor j4 Then e=True:Else e=False:End If:If gv=4 Then If e Then sDb.plAyER.pLaylIstDELete cx:End If:Else If ds Is Nothing Then SDb.maiNTRaCKSwiNDOW.seLECTED(cx)=e:Else If e Then w.deleTe cx:End If:End If:End If:If o<CLng(Timer*10)Then o=1+CLng(Timer*10):sdb.prOCESSmESsAGeS:If t Is Nothing Then Set t=sDB.pRoGreSS:t.MAxvalUE=k4-1:Else If t.tErminATE Then Exit For:End If:End If:t.Value=cx:t.tEXT="Selecting: "&cx&"/"&k4:End If:Next:Set n=Nothing:If gv<>4 Then If ds Is Nothing Then sDB.maintracKSwIndow.REMOveSELectedtrACkS:Else If k4<>w.Count Then ds.Clear:ds.aDDTrACKS w:End If:End If:End If:End Sub:Sub ix(h):Dim n,jy,x,cx:gi=h.tExT:ah=h.itEmiNdEx:cx=cv.iteMcOuNt-1:Do While cx>=0:cv.DEleTEitem cx:cx=cx-1:Loop:jy=-1:cx=0:If Not i4 Then kj=sdB.seleCTedSonGliSt.Item(0).AlbUmnAmE:hh=sdb.sElEctEdsonGLiST.Item(0).tItle:x=" Artist = '"&fz(gi)&"' AND SubStr(SongPath, -4, 4) <> '.asx' COLLATE IUnicode AND ID NOT IN (SELECT IDasx FROM TrackRedirection) AND ID NOT IN (SELECT IDref FROM TrackRedirection)":If Len(gp)Then x=x&" AND"&gp:End If:x=x&" ORDER BY Album":Set n=SDB.DaTAbAsE.opENsql("SELECT Album FROM Songs WHERE SongTitle = '"&fz(hh)&"' AND Album <> '"&fz(kj)&"' AND"&x):If Not n.eOf Then kj=n.strInGbYINDeX(0):Else Set n=sDB.daTaBaSe.oPenSQl("SELECT Album FROM Songs WHERE SongTitle LIKE '"&fz(hh)&"%' AND"&x):If Not n.eOF Then kj=n.stRingbYINDEx(0):Else Set n=SDb.DaTaBaSE.oPeNSql("SELECT Album FROM Songs WHERE Album <> '"&fz(kj)&"' AND"&x):If Not n.eof Then kj=n.STRingbYINDex(0):Else kj="":End If:End If:End If:End If:Set n=Sdb.dataBase.OpeNSQL("SELECT Album FROM Songs WHERE Artist = '"&fz(gi)&"'"&dp(Len(gp)," AND"&gp,"")&" GROUP BY Album ORDER BY Album"):Do While Not n.EOF And cx<32000:cv.ADdITem n.StRINgbYiNdEx(0):If jy=-1 And kj=n.StrINgbYinDeX(0)Then jy=cx:End If:n.Next:cx=cx+1:Loop:Set n=Nothing:cv.iTEmiNdeX=jy:ka cv:End Sub:Sub c1(jb):fj"DISTINCT IDref FROM TrackRedirection":End Sub:Function e5(ei):Dim n,x,fo,fi,js,cx,bv:If Len(ei)Then Set fi=SdB.playListbytITLe(ei):If fi.iD>0 Then x="SELECT Count(*), IfNull(IDPlaylist, 0) FROM Playlists WHERE PlaylistName = '"&Replace(ei,"'","''")&"' AND (IsAutoPlaylist <> 1 OR IsAutoPlaylist IS NULL)":Set n=Sdb.datABasE.OPeNsQl(x):If n.valUEBYiNdeX(0)=1 Then If n.vaLuebyInDEx(1)=fi.id Then Set n=Nothing:Set e5=fi:Exit Function:End If:End If:Set n=Nothing:End If:fo=Split(ei,"\"):Set fi=SDb.pLAYLISTbYTitle(""):For cx=0 To UBound(fo):Set js=fi.chILdPlaYlisTS:If js.Count Then bv=0:Do While bv<js.Count:If js.Item(bv).TitLE=fo(cx)And(cx=UBound(fo)Imp Not js.Item(bv).isaUToplaYlIST)Then Set fi=js.Item(bv):Exit Do:Else If bv=js.Count-1 Then Set fi=Nothing:Exit For:End If:End If:bv=bv+1:Loop:Else Set fi=Nothing:Exit For:End if:Next:Else Set fi=Nothing:End If:Set e5=fi:End Function:Sub dx(h):cz=h.TExt:End Sub:Sub j2(jb):ib" = IDref",True:End Sub:Sub jo(jb):ib" = IDasx",True:End Sub:Sub ft(jb):Dim hu,bt,l,w,jg,dn,d,c4,j3,gp,a,t,o,cx:On Error Resume Next:If sdb.vERSiONBuiLD<1218 Then Exit Sub:End If:If Err Then Exit Sub:End If:On Error GoTo 0:If Not sdb.mAiNTrEE.noDE_LibRaRy.visIBLE Or Not sDB.MaIntrEe.NOdE_filEsToEDiT.visIbLE Then sdb.MESsaGEBox"The "&dp(SDb.VeRsionhI>=4,"Entire ","")&"Library/Files To Edit folder must be visible"&vbCr&"to be able to find the duplicate titles.",MTinFORMaTiOn,Array(mbok):Exit Sub:End If:gp=je:j3=SDb.INIfIle.STRiNGvaluE("TrackRedirection","DuplicatesExtList"):c4=sdB.iNIFiLE.BOoLvalUE("TrackRedirection","DuplicatesCriteria"):Set bt=CreateObject("Scripting.Dictionary"):Set a=SDb.DATabAsE.QUErySoNgs(e3(c4,j3,gp)):Do While Not a.Eof:Set l=a.Item:If Not bt.EXISts(CStr(l.iD))Then bt.add CStr(l.id),l.id:End If:a.Next:Loop:Set a=Nothing:SdB.maiNtrEe.nodE_libRArY.exPANDeD=True:Sdb.mainTREe.noDe_FilEsTOedIT.expANDed=True:Set hu=SdB.MAIntrEe.FIRstCHILdNODE(sdb.MAinTree.node_FILESToedIT):Do While Not hu Is Nothing:If hu.CAPtioN=sdB.LOCaLizE("Duplicate Titles")Then Exit Do:End If:Set hu=SDB.mAiNtRee.NExTsIBlIngNoDE(hu):Loop:If hu Is Nothing Then Sdb.MeSsAGeBOx"The Duplicate Titles folder cannot be found.",MtInfORMATiOn,Array(MbOk):Exit Sub:End If:If Not SDb.MaInTrEE.currenTnOde Is Nothing Then dn=Sdb.mAintrEe.CURreNTnODe.custOMNODEiD:d=sdb.mAiNtREE.cURrEnTNode.caPTIoN:End If:If dn<>hu.cUstOmNoDeiD Or d<>hu.cAPTION Then sdb.obJecTS("colTrackRedirection").Item("TracksAdded")=False:sdB.maIntree.CuRrEnTnodE=hu:Set t=Nothing:o=4+Round(Timer*10):Do:sdB.PROCESSMessagEs:SDb.ToOLs.SleEp 10:If Abs(o-Round(Timer*10))Mod 5=0 Then If sDB.allVIsibLesonglist.Count=0 And Abs(o-Round(Timer*10))>20 And SDB.veRSiOnBUilD<1364 Then Exit Do:Else If Abs(o-Round(Timer*10))>50 Then Exit Do:Else If t Is Nothing Then Set t=sDb.pRogreSS:t.TEXt="Finding duplicate tracks":Else If t.TErminATE Then Exit Sub:End If:End If:End If:End If:End If:Loop Until SDb.obJECts("colTrackRedirection").Item("TracksAdded")=True:Else jg=True:End If:Set w=SdB.AllVisiblEsOnGliST:Set t=Nothing:o=4+CLng(Timer*10):For cx=0 To w.Count-1:Set l=w.Item(cx):If bt.EXIsTs(CStr(l.ID))Then SDb.maInTrackswINdOW.sELecTEd(cx)=True:SDB.MAinTRackSWINDOw.FocUSed=cx:Else If cx=0 Or jg Then SdB.MaINtrACksWiNDow.Selected(cx)=False:End If:End If:If o<CLng(Timer*10)Then o=1+CLng(Timer*10):SDb.processMEsSAGeS:If t Is Nothing Then Set t=SDb.prOGReSS:t.maxvaluE=w.Count-1:Else If t.TermInaTE Then Exit For:End If:End If:t.Value=cx:t.tExT="Selecting: "&cx&"/"&w.Count:End If:Next:End Sub:Sub hn(jb):Dim g,kq,v,x,cx:Set g=Sdb.iNiFiLe:kq=ji.KEyS:For cx=0 To ji.Count-1:v=ji.Item(kq(cx)):If g.boOlvaluE("TrackRedirection","Sync"&v)Then x=x&"Songs."&v&" <> S1."&v&" OR ":End If:Next:If g.BOoLVaLue("TrackRedirection","SyncPlaystat")Then x=x&"Songs.PlayCounter <> S1.PlayCounter OR Songs.LastTimePlayed <> S1.LastTimePlayed OR ":End If:If g.BoOlVAluE("TrackRedirection","SyncAlbumArt")Then x=x&"(SELECT Count(*) FROM Covers WHERE IDSong = Songs.ID) <> (SELECT Count(*) FROM Covers WHERE IDSong = S1.ID) OR ":End If:If Len(x)Then x="DISTINCT IDref FROM TrackRedirection INNER JOIN Songs ON IDref = Songs.ID INNER JOIN Songs AS S1 ON IDasx = S1.ID WHERE "&Left(x,Len(x)-3):Else x="-1 WHERE 0":End If:fj x:End Sub:Sub bz(ct,ce):Dim kq,a,l,k,y,v,fb,m,d,bv:d="":If Not ct Is Nothing Then Set k=c6.Item(CStr(ct.iNdEX)):Set y=gh.Item(CStr(ct.INDEx)):kq=jl.keYs:For bv=0 To jl.Count-1:v=kq(bv):If ji.exIsts(v)Then If sdb.inIFIlE.BOOLVALUe("TrackRedirection","Sync"&ji.Item(v))Then fb=jl.Item(v):If j1.EXISTS(v)Then Set l=y:m=Eval("l."&fb):Set l=k:If Eval("l."&fb)<>m Then d=d&v&": "&Eval("l."&fb)&" <~> "&m&"; ":End If:Else If Eval("k."&fb)<>Eval("y."&fb)Then d=d&v&": "&Eval("k."&fb)&" <~> "&Eval("y."&fb)&"; ":End If:End If:End If:End If:Next:If sDb.InIfiLe.BoolVaLUE("TrackRedirection","SyncPlaystat")Then If k.pLayCoUNTer<>y.PLAYcounTER Then d=d&"PlayCounter: "&k.pLayCOUNtER&" <~> "&y.PLaYcoUNter&"; ":End If:If k.LaSTplaYED<>y.laSTPLayed Then d=d&"LastPlayed: "&k.lASTpLaYed&" <~> "&y.LAstpLAyEd&"; ":End If:End If:If sdB.iniFILE.boOlvALUe("TrackRedirection","SyncAlbumArt")Then If k.ALbUmaRt.Count<>y.albuMART.Count Then d=d&"AlbumArt.Count: "&k.ALBumArT.Count&" <~> "&y.AlBumArT.Count&"; ":End If:End If:If Len(d)Then d=Left(d,Len(d)-2):hb.cOMMoN.vISiblE=True:Else hb.COMmon.visIBLE=False:End If:Else hb.coMMoN.VISiBLE=False:End If:i8.CAPTioN=d:End Sub:Sub gr(fd):Dim g,h,ki,cf,kw,kg,g7,kt,g0,f9,di,fr,ko,cx:Set g=sDb.iNiFiLe:Set h=sdB.Ui.NewlAbel(fd):h.CaPTioN="v"&j8&" ":h.cOmMon.ALiGN=4:On Error Resume Next:h.COMMOn.FONTColOR=&hf0:Err=0:Set ki=SDB.uI.NEwGrOUpbOx(fd):If Err Then Set ki=sdB.Ui.NEwPANeL(fd):End If:On Error GoTo 0:ki.cOMmoN.sEtrecT 8,15,215,55:kg=g.intvaluE("TrackRedirection","AsxFileFormat"):Set h=SDb.ui.nEWrADIObUtTON(ki):h.CAPtion="Save .asx files in ANSI format":h.ChECKed=(kg=0):h.CoMmon.SETReCt 10,5,180,20:h.COmMon.ConTrOlNAmE="FileFormatANSI":Set h=SDB.Ui.NeWRADIObutTON(ki):h.cApTiOn="Save .asx files in UTF-8 format":h.cHECked=(kg=1):h.ComMon.SetReCt 10,30,180,20:h.coMmON.CoNTROlNaME="FileFormatUTF8":On Error Resume Next:Set ki=sDb.ui.NEwgRouPBOx(fd):If Err Then Set ki=Sdb.Ui.NEwPAnel(fd):End If:On Error GoTo 0:ki.cOMmoN.setrect 235,15,235,55:g7=g.bOoLVAlUe("TrackRedirection","RelativePaths"):Set h=sDb.uI.NEwRadIobuTton(ki):h.CAptioN="Save references with absolute paths":h.COmMoN.SeTREct 10,5,210,20:h.checkEd=Not g7:h.cOMMOn.contROLnAME="AbsolutePaths":Set h=sdB.UI.neWraDioBUttoN(ki):h.capTion="Save references with relative paths":h.cOMMON.SETREct 10,30,210,20:h.ChEcked=g7:h.cOmMon.conTRolname="RelativePaths":Set kw=sDB.ui.newcHEcKbOX(fd):kw.coMMOn.setrEct 10,77,240,20:kw.CoMmOn.COntRoLnAME="chkUpdateRedirectedPlaylist":kw.CApTiON="Update playlist when add/remove redirection:":kw.cheCKeD=g.BOoLvaLUE("TrackRedirection","UpdateRedirectedPlaylist"):sCriPT.rEGISTerEVenT kw.COMMON,"OnClick","f1":Set h=sDb.UI.nEwDROpDOwN(fd):h.ComMOn.sEtrect 253,76,217,20:h.ComMOn.coNtROLNAME="RedirectedTracksPlaylist":ko=g.sTrIngValue("TrackRedirection","RedirectedTracksPlaylist"):Set f9=CreateObject("Scripting.Dictionary"):a3 f9,SDB.PLayLiSTByTitlE("").CHIlDPlAYLIstS,"":di=f9.Keys:fr=-1:For cx=0 To f9.Count-1:h.ADDiteM di(cx):If di(cx)=ko Then fr=cx:End If:Next:If fr>-1 Then h.iTemiNdex=fr:Else If Len(ko)=0 Then h.TeXt=sDb.lOCAlIzE("Redirected Tracks"):Else h.tExT=ko:End If:End If:f1 kw:Set kw=SDB.Ui.nEwcHeCKbOx(fd):kw.COMmoN.SetRect 10,102,455,20:kw.coMmoN.CONtROlnamE="UpdateRefPlaystats":kw.CAPTION="Update playcount && play dates for master track on playback of redirected .asx/audio file":kw.ChEcKeD=g.boOLVaLUe("TrackRedirection","UpdateRefPlaystats"):SCRIpt.rEgiSTerevEnT kw.common,"OnClick","af":On Error Resume Next:Set ki=sdb.ui.nEWGROUpBOx(fd):If Err Then Set ki=sDB.Ui.nEwPANEl(fd):End If:On Error GoTo 0:ki.COMMON.SeTreCT 8,125,462,249:Set h=Sdb.UI.NEWLABEL(ki):h.CoMmON.seTrEcT 10,8,130,20:h.capTIoN="Synchronize metadata for:":Set h=sdb.ui.NEWrADIoButToN(ki):h.comMOn.SETRECT 145,5,92,20:h.cAPTIOn="all linked tracks":h.chEckEd=Not g.bOolVaLUe("TrackRedirection","SyncMetadataMasterOnly"):Set h=sdB.Ui.NEWradIoBUtTon(ki):h.CommON.SEtrecT 245,5,210,20:h.cOmmOn.ConTrolNaMe="SyncMetadataMasterOnly":h.CaPTion="redirected tracks to match masters only":h.cheCkED=g.boOlvALUe("TrackRedirection","SyncMetadataMasterOnly"):Set h=sdb.UI.neWcHEckBOX(ki):h.CoMMON.seTRECt 25,30,80,20:h.COMMON.cOnTroLnAME="SyncSongTitle":h.CApTIon="Title":h.ChECkED=g.bOoLVAlUE("TrackRedirection","SyncSongTitle"):Set h=sDb.Ui.nEwCHeCkbOX(ki):h.COMMoN.SETrEct 113,30,80,20:h.coMMon.ContrOLnAME="SyncArtist":h.captioN="Artist":h.CHECKED=g.boolVaLUE("TrackRedirection","SyncArtist"):Set h=sDB.uI.nEwChECKbOX(ki):h.CoMMOn.SEtReCT 201,30,80,20:h.commOn.contrOlNamE="SyncAuthor":h.capTIoN="Composer":h.cHecKeD=g.boolValUE("TrackRedirection","SyncAuthor"):Set h=sdB.Ui.NewCHeCKboX(ki):h.CommON.SetRECT 289,30,80,20:h.Common.COnTROLNAMe="SyncAlbum":h.CapTIon="Album":h.CHeckEd=g.bOOLVaLUe("TrackRedirection","SyncAlbum"):Set h=SDb.UI.NEwCheckbOX(ki):h.CoMmon.setReCt 377,30,80,20:h.comMOn.cOntROLnamE="SyncAlbumArtist":h.cAPTIoN="Album Artist":h.CHeckEd=g.bOOlVaLUe("TrackRedirection","SyncAlbumArtist"):Set h=SDb.UI.nEwcheCKbox(ki):h.ComMon.sEtrECT 25,54,80,20:h.COMMON.conTrolname="SyncConductor":h.caPTiOn="Conductor":h.cheCkEd=g.boOlVaLue("TrackRedirection","SyncConductor"):Set h=sdb.UI.nEWCHECkBOx(ki):h.COMmON.setREct 113,54,80,20:h.coMMOn.ConTrOLNamE="SyncLyricist":h.CAPtiON="Lyricist":h.ChECKED=g.BOoLvalue("TrackRedirection","SyncLyricist"):Set h=SDb.uI.nEwcHEckbOX(ki):h.CoMMON.SEtRECT 201,54,80,20:h.CommON.cONtrOlNAME="SyncInvolvedPeople":h.cAption="Invol. people":h.cHEckeD=g.bOOlVALue("TrackRedirection","SyncInvolvedPeople"):Set h=sdB.ui.NeWCheckbOx(ki):h.coMMon.setRect 289,54,80,20:h.COmmoN.coNtroLnAme="SyncYear":h.CAPtiON="Date":h.CHECKed=g.BOOlvalue("TrackRedirection","SyncYear"):Set h=SDB.uI.NeWcHECKBoX(ki):h.CoMMON.SEtRecT 377,54,80,20:h.cOmmoN.COntROLnaMe="SyncGenre":h.CAPTion="Genre":h.cHECked=g.boOLvALuE("TrackRedirection","SyncGenre"):Set h=SDb.Ui.nEwChEckboX(ki):h.cOmmOn.SeTREct 25,78,80,20:h.CoMMon.CoNtrOlNAmE="SyncRating":h.CapTioN="Rating":h.cHeCKED=g.booLVALue("TrackRedirection","SyncRating"):Set h=sdb.Ui.NEwChEcKBOX(ki):h.coMMon.SetREct 113,78,80,20:h.CoMMoN.CoNTrOlNAMe="SyncTrackNumber":h.CAPtiON="Track #":h.checKEd=g.BooLVaLue("TrackRedirection","SyncTrackNumber"):Set h=sdB.ui.neWchEckbOX(ki):h.CoMmON.SETReCt 201,78,80,20:h.CoMmON.ControlName="SyncDiscNumber":h.CAPTIOn="Disc #":h.CheCkEd=g.boOLVALUe("TrackRedirection","SyncDiscNumber"):Set h=sDB.ui.newCHeCkBOx(ki):h.coMmon.SetRECT 289,78,80,20:h.CoMMON.ContROlnAmE="SyncComment":h.cAptIon="Comment":h.CHeCKeD=g.BoolVAlUE("TrackRedirection","SyncComment"):Set h=SDb.UI.nEwCHecKBOX(ki):h.cOMmON.SeTRECt 377,78,80,20:h.cOMMoN.COntrOlnAme="SyncLyrics":h.capTIOn="Lyrics":h.CHeckEd=g.BOoLVaLUE("TrackRedirection","SyncLyrics"):Set h=sDb.uI.neWcHECkboX(ki):h.cOMmoN.sETreCT 25,102,80,20:h.cOmmon.cOntROLnAmE="SyncCustom1":h.caPtIon=sdB.inIfile.STringvaLUe("CustomFields","Fld1Name"):h.cHECKeD=g.BOoLValUE("TrackRedirection","SyncCustom1"):Set h=sDb.Ui.neWcHecKbox(ki):h.CoMMON.SETRecT 113,102,80,20:h.CommoN.controLnAME="SyncCustom2":h.CapTion=SDB.inIFIlE.sTrInGvAlue("CustomFields","Fld2Name"):h.chECkED=g.BoOlValUe("TrackRedirection","SyncCustom2"):Set h=sdb.Ui.newcHeCKBoX(ki):h.cOmmon.SETrect 201,102,80,20:h.coMmON.cONTrOlnaME="SyncCustom3":h.CaPtion=SDb.iniFiLE.sTRiNGVALUe("CustomFields","Fld3Name"):h.cHecKed=g.BooLVALUe("TrackRedirection","SyncCustom3"):Set h=SDb.UI.nEWChEcKbOx(ki):h.COMMoN.seTREcT 289,102,80,20:h.comMON.coNTRoLNAmE="SyncCustom4":h.cApTION=sdB.iniFiLE.sTRingVAlUe("CustomFields","Fld4Name"):h.ChEckEd=g.BoolVAlUE("TrackRedirection","SyncCustom4"):Set h=SDB.uI.newchecKBox(ki):h.COmMOn.seTrEcT 377,102,80,20:h.cOMMOn.COnTROlnAMe="SyncCustom5":h.caPtiOn=SDB.InIfILe.strINgvAlUe("CustomFields","Fld5Name"):h.cHeCked=g.BooLVaLUE("TrackRedirection","SyncCustom5"):Set h=sdb.Ui.newchECkBox(ki):h.cOMmON.SETRecT 25,126,80,20:h.COMMon.CoNTRoLnAME="SyncTempo":h.CapTiOn="Tempo":h.cHECkED=g.bOOLVAlue("TrackRedirection","SyncTempo"):Set h=SDb.ui.NEwcHeckBOX(ki):h.CoMmOn.setReCt 113,126,80,20:h.COmMon.CoNTrOLNaME="SyncMood":h.cApTION="Mood":h.ChEcKED=g.booLvALUe("TrackRedirection","SyncMood"):Set h=SDB.uI.neWCHECKBOX(ki):h.CoMmoN.sEtrECt 201,126,80,20:h.CommON.coNtrolnAMe="SyncOccasion":h.captIon="Occasion":h.CHecked=g.booLvALue("TrackRedirection","SyncOccasion"):Set h=sdB.Ui.NEwcHEckBOX(ki):h.ComMoN.SEtreCT 289,126,80,20:h.COmMON.COnTRoLNaME="SyncQuality":h.cAptIOn="Quality":h.CHeCKeD=g.BooLvAluE("TrackRedirection","SyncQuality"):Set h=sDB.ui.nEwCheCkbOX(ki):h.cOmMON.SeTRECT 377,126,80,20:h.coMMOn.ControLNaME="SyncBPM":h.CaptIon="BPM":h.chECkED=g.bOOLvALUE("TrackRedirection","SyncBPM"):Set h=Sdb.uI.newChECkBox(ki):h.common.SETrECT 25,150,80,20:h.cOMmOn.CoNTRoLNAMe="SyncOrigArtist":h.cAPTiON="Orig. Artist":h.ChecKed=g.bOolVALue("TrackRedirection","SyncOrigArtist"):Set h=Sdb.ui.neWCheCKbOX(ki):h.coMMON.setrEct 113,150,80,20:h.COmMon.CoNtrOlNaME="SyncOrigTitle":h.cAPtIoN="Original Title":h.cHEcKeD=g.BOOLvaLUe("TrackRedirection","SyncOrigTitle"):Set h=SDB.uI.neWchecKbOx(ki):h.commON.sETREct 201,150,80,20:h.cOMMOn.ConTRoLNamE="SyncOrigYear":h.CaPtiON="Original Date":h.CHeCKED=g.BooLvAlUe("TrackRedirection","SyncOrigYear"):Set h=SDB.UI.NeWCHEcKbox(ki):h.commOn.setREct 289,150,80,20:h.COmMON.COntrOlNaME="SyncOrigLyricist":h.CAPtIoN="Orig. Lyricist":h.CHecKED=g.BooLVAlUe("TrackRedirection","SyncOrigLyricist"):Set h=SDb.UI.NewcheCkBOx(ki):h.ComMOn.sETrECT 377,150,80,20:h.CommON.cOntRolnamE="SyncGroupDesc":h.cAPtion="Grouping":h.ChEcKEd=g.BOOLValuE("TrackRedirection","SyncGroupDesc"):Set h=sDB.Ui.neWCHeCkBOX(ki):h.cOmmon.SeTRecT 25,174,80,20:h.COMmon.CoNtrOLnAmE="SyncCopyright":h.capTion="Copyright":h.checKEd=g.BOOlValUe("TrackRedirection","SyncCopyright"):Set h=SDb.ui.NEWchEckbOx(ki):h.COmMoN.sETreCt 113,174,80,20:h.cOmMOn.CONtrolnamE="SyncEncoder":h.CaPTion="Encoder":h.CHECkED=g.boOlvALUE("TrackRedirection","SyncEncoder"):Set h=sdB.Ui.newcHeCKbox(ki):h.CoMmoN.seTREct 201,174,80,20:h.COMMoN.coNtROLnAmE="SyncISRC":h.CapTIOn="ISRC":h.chECKeD=g.BoOlvalUE("TrackRedirection","SyncISRC"):Set h=sDb.uI.NEwcHECKbox(ki):h.cOMMoN.sETREct 289,174,80,20:h.coMMoN.COnTROlnAme="SyncPublisher":h.CaPTIOn="Publisher":h.cHEcKEd=g.booLvalUE("TrackRedirection","SyncPublisher"):Set h=sDb.ui.newcHeCkbOX(ki):h.cOmMon.SEtReCT 377,174,80,20:h.cOmMoN.CoNTroLNaMe="SyncPlaystat":h.cAptIoN="Playstats":h.cheCkeD=g.boOlvAlue("TrackRedirection","SyncPlaystat"):SCRipt.rEGisteRevEnT h.CoMMOn,"OnClick","hi":Set kw=sdb.Ui.neWChECkBOX(ki):kw.COmmON.SeTRect 25,199,80,20:kw.CommON.cONTrOlNAmE="SyncAlbumArt":kw.CapTiOn="Album Art":kw.ChECkED=g.BoOLvAlUe("TrackRedirection","SyncAlbumArt"):SCrIPT.REGisTErEVenT kw.COmmOn,"OnClick","ek":On Error Resume Next:Set cf=SDB.ui.neWgRoUpBOx(ki):If Err Then Set cf=sdB.UI.neWpanEl(ki):End If:On Error GoTo 0:cf.coMMon.SETrecT 105,195,350,28:cf.cOMMON.cOntRolname="AlbumArtSave":Set h=sdb.ui.neWlABEL(cf):h.COmmOn.sETReCT 8,8,40,20:h.CaptioN="Save to:":kt=g.iNTVAlUe("TrackRedirection","AlbumArtStorage"):Set h=SDB.UI.newradiobutTON(cf):h.CommoN.setreCT 57,4,85,20:h.comMoN.cOntrolnAMe="AlbumArtSame":h.CApTIoN="same storage":h.CHEckeD=(kt=0):scrIpT.RegIstEREVeNT h.cOmmon,"OnClick","cd":Set h=SDb.uI.NewRaDiOBuTtON(cf):h.CommON.SETreCT 150,4,37,20:h.cOmmoN.CoNtRolNaMe="AlbumArtToTag":h.cAption="tag":h.CHeckeD=(kt=1):sCrIpT.RegISTErEvEnT h.Common,"OnClick","cd":Set h=Sdb.ui.NewRADiOBuTtoN(cf):h.cOMMON.sETREcT 195,4,40,20:h.cOmmoN.CONTrOlnaMe="AlbumArtToFile":h.CaPtIOn="file:":h.CHeCKED=(kt=2):sCRipT.REGISTErevENt h.cOMMON,"OnClick","gx":Set h=sDB.Ui.NeweDiT(cf):h.COmMoN.sEtreCT 235,3,110,20:h.cOmmOn.cOnTrOLnAME="AlbumArtFileName":h.tExt=g.StrIngvaLUE("TrackRedirection","AlbumArtFileName"):If kt<>2 Then h.COMMoN.enaBled=False:End If:ek kw:Set h=sdb.Ui.newcHEckBOX(ki):h.CoMMON.seTRecT 10,224,442,20:h.cOMmon.cONTRolNamE="SynchronizedMetadata":h.CApTION="Automatically synchronize metadata on modification of linked/master track":h.chECkEd=g.booLVaLue("TrackRedirection","SynchronizedMetadata"):On Error Resume Next:If sdb.VersIoNbUILd<1217 Then:Else Set h=sdb.ui.neWLABel(fd):h.coMmOn.seTRecT 10,383,170,20:h.CAptiON="Select Duplicates' main criteria:":g0=g.bOolvAlue("TrackRedirection","DuplicatesCriteria"):Set h=Sdb.UI.NeWRAdIobUttoN(fd):h.commOn.seTReCT 170,380,95,20:h.common.CoNTRoLnAMe="DuplicatesBitrate":h.captIOn="Maximal bitrate":h.cHecKED=Not g0:SCript.REGiSTeREveNt h.CommOn,"OnClick","k1":Set h=sdb.UI.nEWradiObuTtoN(fd):h.CommoN.seTrECt 275,380,80,20:h.commON.ConTRolNaMe="DuplicatesExtensions":h.cAptiON="Extensions:":h.cheCked=g0:sCRipt.regisTEREvEnT h.COMmON,"OnClick","b1":Set h=Sdb.ui.NEwEdiT(fd):h.COMmON.SeTrECt 360,379,110,20:h.CoMMOn.contRoLNAMe="DuplicatesExtList":h.teXT=g.strINGVALUe("TrackRedirection","DuplicatesExtList"):If Not g0 Then h.ComMon.eNabLED=False:End If:Set h=SDB.ui.nEwCHEckBOX(fd):h.cOmmON.sEtRecT 10,405,455,20:h.COmmoN.COnTrOlnaME="AutoReplaceRedirected":h.CAptION="Replace redirected audio file with corresponding master on playback or drag && drop to NP":h.CHEcKED=g.boOlvAlUE("TrackRedirection","AutoReplaceRedirected"):End If:On Error GoTo 0:End Sub:Sub h9(y,q,g7,kg):Dim r,u,ij,a,l,f:r=y.paTh:If LCase(Right(r,4))<>".asx"Then Exit Sub:End If:u=f0(r):If Len(u)=0 Then Exit Sub:End If:Set ij=q.Execute(u):If ij.Count=0 Then Exit Sub:End If:Set a=SdB.daTAbASe.QUErYsOngS("ID = (SELECT IDref FROM TrackRedirection WHERE IDasx = "&y.id&")"):If a.EOf Then Exit Sub:End If:Set l=a.Item:If g7 Then f=ch(l.PaTh,Left(r,InStrRev(r,"\"))):Else f=l.PatH:End If:If LCase(ij.Item(0).SubMatches.Item(1))<>LCase(f)Then u=q.Replace(u,"$1"&f&"$3"):Call iw(r,u,kg):End If:End Sub:Sub ReplaceWithAlbumMain(jb):Dim hf,cx:hf=sdb.obJEctS("colReplaceWithAlbumMain").kEyS:For cx=0 To Sdb.OBjECTs("colReplaceWithAlbumMain").Count-1:If jb Is sDB.oBJEcts("colReplaceWithAlbumMain").Item(hf(cx))Then f2"Album","Main",hf(cx):Exit For:End If:Next:End Sub:Sub b9(h):Dim w,n,jy,cx:cw=h.cHeCKED:If cw And Len(a4)>0 Then h.CoMmoN.topPaReNT.cAption=ci&" ("&a4&")":gp=je:Else h.COmMOn.topPARenT.CaPtION=ci:gp="":End If:sdb.pROceSSMessAgeS:Set w=sdB.SELectedsongLiST:gi=w.Item(0).aRtisTNaMe:cx=b0.iTEMCOuNT-1:Do While cx>=0:b0.DElEtEiTEM cx:cx=cx-1:Loop:jy=0:cx=0:Set n=sDB.DAtABASE.oPenSQL("SELECT Artist FROM Songs"&dp(Len(gp)," WHERE"&gp,"")&" GROUP BY Artist ORDER BY Artist"):Do While Not n.eof And cx<32000:b0.AdditEM n.stRInGByinDEX(0):If jy=0 And gi=n.sTringbyinDEx(0)Then jy=cx:End If:n.Next:cx=cx+1:Loop:Set n=Nothing:If jy>=0 Then b0.IteMINdEx=jy:End If:ix b0:End Sub:Sub bq(h):Dim ao,d,bh:iy=False:If Len(a4)Then gm.ComMOn.ENABLED=True:End If:If SDb.sElecTEDSoNGlIST.Count=1 Then ao=False:Else ao=True:End If:bh=SDB.INIfILe.boOlvAlUE("TrackRedirection","UpdateRefPlaystats"):d="You could choose the Album with the track"&dp(ao,"s","")&" which you want to ":If fm Then d=d&"redirect to the selected track"&dp(ao,"s","")&vbCr&dp(bh,"(when you play track"&dp(ao,"s","")&" from that Album, the playstats will be updated for the master track"&dp(ao,"s","")&")","(turn on the ""Update playstats"" option first if you want to update master tracks on playback)"):Else d=d&"replace with an .asx metafile"&dp(ao,"s","")&vbCr&"(.asx metafile"&dp(ao,"s","")&" with the reference to the master track"&dp(ao,"s","")&" will be created in the album folder)":End If:b0.iTemINdEx=ah:cv.itemINDeX=de:bs.itEmiNDeX=id:If Not ao Then d=d&","&vbCr&"or you could specify the target "&dp(fm,"audio file",".asx filename")&" in the File Path field if you don't have a duplicate.":Else d=d&"."&vbCr&"If you press OK button, the database will be updated without any further confirmation.":End If:dc.cAPtIon=d:b0.common.EnabLEd=True:cv.cOmmoN.enABleD=True:bs.cOmMON.eNAbLED=Not ao:ac.COMmOn.EnablED=Not ao:fh.comMON.eNaBleD=Not ao:hs.coMMOn.enABLeD=Not ao:jq.ComMON.enAblEd=Not ao:hv.common.EnaBLED=Not ao:cu.commoN.EnablEd=Not ao:hr.caPTIoN="Delete audio file"&dp(ao,"s from the specified album"," stated in the File Path field")&" after creating the corresonding .asx file"&dp(ao,"s",""):c8.cAPtIOn="Copy master (selected) track"&dp(ao,"s","")&" to the Album folder if it doesn't contain duplicate file"&dp(ao,"s",""):c8.cOMmON.eNABleD=(fm And Not iy And Not ao):k7 hv:End Sub:Dim dd:Set dd=CreateObject("Scripting.Dictionary"):With dd:.adD"Composer","WM/Composer":.adD"Album","WM/AlbumTitle":.add"Album Artist","WM/AlbumArtist":If SDb.VErsIonhi>=3 Then .add"Conductor","WM/Conductor":End If:.AdD"Lyricist","WM/Writer":.adD"Date","WM/Year":.aDD"Genre","WM/Genre":.ADD"Track #","WM/TrackNumber":If sdB.VerSioNhi>=3 Then .add"Disc #","WM/PartOfSet":End If:.add"File size","FileSize":.AdD"Mood","WM/Mood":.add"BPM","WM/BeatsPerMinute":.add"Original Artist","WM/OriginalArtist":.add"Original Album Title","WM/OriginalAlbumTitle":.ADD"Original Date","WM/OriginalReleaseYear":.adD"Comment","Description":.ADd"Lyrics","WM/Lyrics":If sdb.vERSIoNhI>=3 Then .aDD"Grouping","WM/ContentGroupDescription":End If:.aDd"ISRC","WM/ISRC":.aDd"Original Lyricist","WM/OriginalLyricist":.adD"Publisher","WM/Publisher":.adD"VBR","IsVBR":End With:Function je():On Error Resume Next:je=sDb.DAtabAse.ActIvEfiltErQUeRy:If Err Then je="":Else If Len(je)>0 Then je=" ("&je&")":End If:End If:On Error GoTo 0:End Function:Sub hc(h):f6=h.CheCkeD:Sdb.PRoCeSSMESsAgES:jx:End Sub:Sub fw(jb):il 1:End Sub:Function jc(i9,b2):Dim i2,ge,k2:jc=i9:If Left(i9,1)="\"And Mid(i9,2,1)<>"\"Then i2=InStr(InStr(b2,"\\")+2,b2,"\"):If i2=0 Then Exit Function:End If:jc=Left(b2,i2-1):Else If Left(i9,2)<>"\\"And Mid(i9,2,1)<>":"Then Set ge=CreateObject("Scripting.FileSystemObject"):If ge.FOlderEXIStS(b2)Then k2=b2:If Right(k2,1)<>"\"Then k2=k2&"\":End If:Else i2=InStrRev(b2,"\"):If i2=0 Then Exit Function:End If:k2=Left(b2,i2):End If:jc=ge.gETaBSoLutEpathname(k2&i9):End If:End If:End Function:Sub ReplaceWithLinkedTrackMain(jb):l2 jb,"Linked","Main":End Sub:Function f5(y,jm):Dim r,ge,en,a0,fa,hj,co,c,h,cm,em,ga,dy,bg,u,q,ij,jr,i5,d,bv:r=y.pAth:If LCase(Right(r,4))<>".asx"Then sDb.daTabASe.exeCsqL"DELETE FROM TrackRedirection WHERE IDasx = "&y.ID:f5=1:Exit Function:End If:Set ge=CreateObject("Scripting.FileSystemObject"):hj=0:Set fa=CreateObject("Scripting.Dictionary"):If ge.fOldErExISTS(ge.GetPaREntfoldeRnAMe(r))Then Set en=ge.getFolder(ge.gETpaRentfOlDErnAme(r)):For Each a0 in en.fILeS:If LCase(ge.gEtEXteNsioNnamE(a0.PAtH))<>"asx"And LCase(ge.GETbaSEnAME(a0.pATH))=LCase(ge.getbaSEname(r))Then fa.aDD CStr(hj),a0.patH:hj=hj+1:End If:Next:If hj=0 Then d="There is not any audio file with the same filename as:":End If:Else d="Folder with the selected .asx file doesn't exists:":End If:If hj=0 Then Select Case Sdb.mESsaGEbOx(d&vbCr&r&vbCr&vbCr&"Do you want to remove redirection from that track anyway?",MtwarniNg,dp(jm,Array(mBYEs,mbno),Array(mByes,MbNO,MBABORt))):Case MrYEs:SDB.daTAbASE.EXEcsql"DELETE FROM TrackRedirection WHERE IDasx = "&y.iD:f5=1:Case MBaBort:f5=0:Case Else f5=-1:End Select:Exit Function:Else If hj>1 Then Set c=SdB.Ui.neWFORm:dy=c.COMMON.WiDtH-c.COMMOn.CLIENTwiDtH:bg=c.cOmmon.heigHT-c.CoMMOn.clIEnTheIGht:c.CoMmON.SeTREct 100,100,467+dy,120+bg:c.FoRMPOsiTIOn=ay:c.CAPtION=sdB.LOcaLize("Resume Redirection"):c.common.MiNwIDTh=440+dy:c.cOMMON.miNHEIGht=120+bg:c.cOmMOn.maxhEiGHt=120+bg:Set h=SDB.Ui.nEwLaBEl(c):h.cOmMoN.sEtrECT 10,15,400,40:h.CaPtIon="Folder with the selected .asx file contains many files with the same filename as .asx file."&vbCr&"You should choose one of them and .asx file will be replaced with it in the Library.":Set g3=SDb.ui.NEwDRoPdoWN(c):g3.COMmOn.setReCT 10,55,447,19:g3.STYlE=d4:g3.COMmON.ANChors=1+2+4:script.ReGiSTeREvent g3,"OnSelect","et":Set cm=sdb.UI.nEWButtON(c):cm.CapTiON="&OK":cm.COmmON.SEtrEct 225,90,73,25:cm.cOMmON.anchoRS=2+4:cm.Default=True:cm.MODAlResult=1:Set em=sDB.UI.NewBUtTon(c):em.CAPtIoN="&Cancel":em.coMMON.SEtRECT 305,90,73,25:em.CommoN.aNcHORS=2+4:em.canCeL=True:em.mODAlResuLT=2:Set ga=sDB.ui.nEwbUTTON(c):ga.cAPTiON="&Abort":ga.COmMON.SETReCt 385,90,73,25:ga.CoMMon.anCHoRs=2+4:ga.MoDalREsuLt=3:If jm Then ga.cOMMon.enaBLeD=False:End If:For hj=0 To fa.Count-1:g3.AdditEm fa.Item(CStr(hj)):Next:g3.itemiNdex=0:f=fa.Item("0"):c.SAVePoSItIONnAMe=c.CAptioN:Select Case c.sHowmODaL:Case 2:Select Case sDb.mEsSaGeBOx("The Song Path of the Library will not be updated for:"&vbCr&r&vbCr&vbCr&"Do you want to remove redirection from that track anyway?",MtcoNfIRMatiON,dp(jm,Array(mbyeS,mbnO),Array(MbyeS,mbNo,mBaboRt))):Case MrYEs:SdB.dAtAbase.eXEcsql"DELETE FROM TrackRedirection WHERE IDasx = "&y.Id:f5=1:Case mBabOrT:f5=0:Case Else f5=-1:End Select:Exit Function:Case 3:f5=0:Exit Function:End Select:Else f=fa.Item("0"):End If:End If:Set co=SDB.NEWsongDAtA:co.PATh=f:co.READTAgS:If y.albUmNaME<>co.aLBuMNaME Or y.ARtisTnaME<>co.ARTIstnAmE Or y.tItle<>co.tITLE Then Select Case sdb.MESsagEbOX("The file: "&ge.GEtFIlenaMe(f)&vbCr&"doesn't have same metadata as the selected .asx file."&vbCr&vbCr&"Do you want to update the Library with its path anyway?",MtwarNINg,dp(jm,Array(mBYEs,mbno),Array(MbyEs,mBno,mBABorT))):Case mRNo:f5=-1:Exit Function:Case MbABort:f5=0:Exit Function:End Select:Else If jm Then If SDB.messAgebOx("The Song Path of the Library with selected .asx file will be updated to the file:"&vbCr&f&vbCr&vbCr&"Are you sure you want to proceed?",MTCONFIrmaTioN,Array(mBYES,mBNO))=MRNo Then f5=-1:Exit Function:End If:End If:End If:If Mid(f,2,1)=":"Then f=Mid(f,2):End If:Sdb.DATabASE.ExecSqL"UPDATE Songs SET SongPath = '"&fz(f)&"' WHERE ID = "&y.Id:u=f0(r):If Len(u)Then Set jr=y.alBUMaRt:Set q=New RegExp:q.Pattern="\s*<BANNER HREF ?= ?""(.*?)"" ?>(?:\s*<ABSTRACT ?> ?(.*?)</ABSTRACT>|\s*<PARAM NAME ?= ?""Item Storage"" +VALUE ?= ?""(.*?)"" ?/>|\s*<PARAM NAME ?= ?""Item Type"" +VALUE ?= ?""(.*?)"" ?/>)*?\s*</BANNER>":q.Global=True:Set ij=q.Execute(u):If ij.Count>0 Then For bv=0 To ij.Count-1:If bv>jr.Count Then Exit For:End If:If Int(ij.Item(bv).SubMatches.Item(2))=0 Then sDb.dAtaBASe.eXEcSQL"UPDATE Covers SET CoverStorage = 0 WHERE IDSong = "&y.ID:End If:Next:End If:End If:SDB.daTABAsE.Execsql"DELETE FROM TrackRedirection WHERE IDasx = "&y.id:f5=1:End Function:Sub ReplaceWithLinkedPopup(jb):Dim hf,cx:hf=Sdb.obJeCtS("colReplaceWithLinkedPopup").keYS:For cx=0 To sdB.ObJEcTs("colReplaceWithLinkedPopup").Count-1:If jb Is sDb.ObJeCTS("colReplaceWithLinkedPopup").Item(hf(cx))Then f2"Linked","Popup",hf(cx):Exit For:End If:Next:End Sub:Sub kz():Dim e,bw,i6,es:If sdB.SeleCTEdSonGLISt.Count>0 Then e=True:If SDB.SELECtedSoNglIst.Count>1 Then i6=True:End If:If LCase(Right(Sdb.seLectEDSOnGLiSt.Item(0).PatH,4))<>".asx"Then bw=False:Else bw=True:End If:Else e=False:End If:es=True:On Error Resume Next:If SDB.versioNbUILD<1218 Then es=False:End If:If Err Then es=False:End If:On Error GoTo 0:If es Then If IsObject(sdB.OBjeCts("mnuMainReplaceWithAlbumTrack"))Then If Not SdB.ObJECts("mnuMainReplaceWithAlbumTrack")Is Nothing Then Sdb.oBJEcTS("mnuMainReplaceWithAlbumDups").VIsIBlE=i6:SdB.ObJECtS("mnuPopupReplaceWithAlbumDups").viSIbLe=i6:sdB.objECts("mnuNPPopupReplaceWithAlbumDups").vIsiBLe=i6:Sdb.objects("mnuNPListReplaceWithAlbumDups").VISIBle=i6:sdB.OBjECTS("mnuMainReplaceWithAlbumTrack").viSIBLe=Not i6:sDB.obJeCts("mnuPopupReplaceWithAlbumTrack").VisIblE=Not i6:sdb.OBjEcTs("mnuNPPopupReplaceWithAlbumTrack").vISIble=Not i6:sdB.OBjEcts("mnuNPListReplaceWithAlbumTrack").vIsIBLE=Not i6:sdb.oBjEcts("mnuMainReplaceWithAlbumTrack").enaBled=e:SdB.oBjeCTs("mnuPopupReplaceWithAlbumTrack").enABLED=e:SDB.OBJectS("mnuNPPopupReplaceWithAlbumTrack").EnablEd=e:SDB.OBJECTs("mnuNPListReplaceWithAlbumTrack").enABlED=e:End If:End If:If IsObject(Sdb.obJEcts("mnuMainReplaceWithLinkedTrack"))Then If Not SdB.ObJECTs("mnuMainReplaceWithLinkedTrack")Is Nothing Then Sdb.ObJecTs("mnuMainReplaceWithLinkedDups").visIBlE=i6:SdB.OBJecTS("mnuPopupReplaceWithLinkedDups").ViSible=i6:sdb.oBjECts("mnuNPPopupReplaceWithLinkedDups").viSiBLe=i6:SDb.ObjEcTS("mnuNPListReplaceWithLinkedDups").visibLE=i6:SDB.OBjects("mnuMainReplaceWithLinkedTrack").VisIBle=Not i6:SdB.OBJecTS("mnuPopupReplaceWithLinkedTrack").VisibLE=Not i6:SDb.OBJecTs("mnuNPPopupReplaceWithLinkedTrack").VIsibLe=Not i6:sdb.ObJEcts("mnuNPListReplaceWithLinkedTrack").vIsIbLe=Not i6:sdb.ObjEcTS("mnuMainReplaceWithLinkedTrack").EnAbLEd=e:Sdb.objEctS("mnuPopupReplaceWithLinkedTrack").enABLed=e:sdb.oBJEcTs("mnuNPPopupReplaceWithLinkedTrack").eNAblED=e:sdB.oBJeCts("mnuNPListReplaceWithLinkedTrack").ENABLED=e:End If:End If:End If:Sdb.oBJeCtS("mnuMainCreateTrackRedirections").ENaBLEd=e And(Not bw Or i6):SDb.ObJeCts("mnuPopupCreateTrackRedirections").enableD=e And(Not bw Or i6):SDb.objEcTs("mnuNPPopupCreateTrackRedirections").eNABlED=e And(Not bw Or i6):sDb.objEcTS("mnuNPListCreateTrackRedirections").eNaBLed=e And(Not bw Or i6):SDB.ObjeCTs("mnuMainSynchronizeAsxMetadata").eNableD=e And(bw Or i6):Sdb.OBJeCTS("mnuPopupSynchronizeAsxMetadata").eNabLed=e And(bw Or i6):sdb.oBjectS("mnuNPPopupSynchronizeAsxMetadata").enabLEd=e And(bw Or i6):Sdb.OBJectS("mnuNPListSynchronizeAsxMetadata").ENABLed=e And(bw Or i6):sDb.ObJEcTs("mnuMainAssignRedirections").ENaBleD=e:SDb.oBjECTs("mnuPopupAssignRedirections").ENabLEd=e:sdB.OBjECTS("mnuNPPopupAssignRedirections").ENABLed=e:sDB.objECTS("mnuNPListAssignRedirections").enAblEd=e:If sDb.SELEctEDsoNGLiST.Count>1 Then e=False:End If:SDb.OBjecTS("mnuMainFindReferencedMaster").eNaBleD=e:sdb.ObJects("mnuPopupFindReferencedMaster").EnaBled=e:SDb.ObjecTs("mnuNPPopupFindReferencedMaster").EnAblED=e:sDb.OBJeCts("mnuNPListFindReferencedMaster").enAbLeD=e:SDb.ObjECtS("mnuMainEditAsxFileWithNotepad").eNaBlEd=e And bw:SDb.oBJECTS("mnuPopupEditAsxFileWithNotepad").EnablEd=e And bw:sDb.ObJECTS("mnuNPPopupEditAsxFileWithNotepad").eNaBLEd=e And bw:Sdb.OBJeCtS("mnuNPListEditAsxFileWithNotepad").enABlEd=e And bw:sdB.oBJEctS("mnuMainRemoveRedirection").EnABleD=e:sdB.OBJEcTS("mnuPopupRemoveRedirection").eNABLED=e:SDb.ObjECtS("mnuNPPopupRemoveRedirection").EnablEd=e:SDb.oBjecTs("mnuNPListRemoveRedirection").enaBLed=e:End Sub:Sub it(h):Dim a,l,bt,cy,fp,gy,b,cx:Set bt=CreateObject("Scripting.Dictionary"):Set cy=CreateObject("Scripting.Dictionary"):Set a=sdB.datABase.QUERysongS("ID IN (SELECT IDref FROM TrackRedirection)"):Do While Not a.eOF:Set l=a.Item:bt.aDD CStr(l.iD),l.id:a.Next:Loop:For b=0 To UBound(s,2):fp=s(1,b):If Not cy.EXIstS(CStr(fp))Then cy.aDd CStr(fp),b:Else cy.Item(CStr(fp))=cy.Item(CStr(fp))&" "&b:End If:Next:Set a=Nothing:For b=0 To UBound(s,2):If s(0,b)=1 Then fp=s(2,b):If Not bt.EXiSTS(CStr(fp))Then s(2,b)=s(1,b):s(1,b)=fp:fp=s(5,b):s(5,b)=s(7,b):s(7,b)=fp:fp=s(6,b):s(6,b)=s(8,b):s(8,b)=fp:fp=s(2,b):If cy.exIstS(CStr(fp))Then gy=Split(cy.Item(CStr(fp))):For cx=0 To UBound(gy):If CStr(gy(cx))<>CStr(b)Then If s(0,gy(cx))=1 Then s(0,gy(cx))=0:i3=i3-1:End If:s(1,gy(cx))=s(1,b):s(3,gy(cx))=s(3,b):s(4,gy(cx))=s(4,b):s(5,gy(cx))=s(5,b):s(6,gy(cx))=s(6,b):End If:Next:cy.kEY(CStr(fp))=CStr(s(1,b)):End If:End If:End If:Next:p.ReFResh:dc.cAPtioN=i3&"/"&UBound(s,2)+1:End Sub:Sub a9(jb):ht sDb.SELECtEdsOngliST,False:End Sub:Sub ReplaceWithAlbumPopup(jb):Dim hf,cx:hf=sDB.ObJects("colReplaceWithAlbumPopup").kEys:For cx=0 To SDb.oBjects("colReplaceWithAlbumPopup").Count-1:If jb Is sdb.OBJECts("colReplaceWithAlbumPopup").Item(hf(cx))Then f2"Album","Popup",hf(cx):Exit For:End If:Next:End Sub:Function d9(l,db):Dim n:Set n=Sdb.DATABasE.openSQl("SELECT ID FROM TrackRedirection WHERE IDasx = "&l.id&" OR IDref = "&l.id):If Not n.EOf Then Sdb.DaTABAse.exECSqL"DELETE FROM TrackRedirection WHERE IDasx = "&l.iD&" OR IDref = "&l.Id:kn:End If:Set n=Nothing:d9=False:End Function:Function f0(au):Dim a0,a5:If sdB.tOols.FileSystem.FileExists(au)Then Set a0=CreateObject("Scripting.FileSystemObject").oPenTExtfIlE(au,1):a5=a0.reaDalL:If AscW(Left(a5,1))=255 And AscW(Mid(a5,2,1))=254 Then Set a0=CreateObject("Scripting.FileSystemObject").opEnTexTFILE(au,1,False,-1):a5=a0.rEadAll:Else If AscW(Left(a5,1))=239 And AscW(Mid(a5,2,1))=187 And AscW(Mid(a5,3,1))=191 Then Set a0=CreateObject("ADODB.Stream"):a0.opeN:a0.cHarSeT="UTF-8":a0.loADfrOMFiLE au:a5=a0.REadTExt(-1):End If:End If:a0.CLOSe:f0=a5:End If:End Function:Sub ReplaceWithAlbumNPPopup(jb):Dim hf,cx:hf=Sdb.ObjECTs("colReplaceWithAlbumNPPopup").KEYS:For cx=0 To sdB.OBJEctS("colReplaceWithAlbumNPPopup").Count-1:If jb Is sDb.OBJeCTs("colReplaceWithAlbumNPPopup").Item(hf(cx))Then f2"Album","NPPopup",hf(cx):Exit For:End If:Next:End Sub:Sub e7(jb):ib" IN (IDasx, IDref)",True:End Sub:Sub az(h):hh=h.tEXT:End Sub:Sub cp(jb):Dim w,l,kx,an,cb,m,n,e,gv,c4,j3,gp,q,a,t,o,cx:On Error Resume Next:If sDB.VErSiOnbuILd<1218 Then Exit Sub:End If:If Err Then Exit Sub:End If:On Error GoTo 0:gv=Sdb.uI.MaINwiNDOwFocuS:If gv=4 Then Set w=sdb.PLAyER.curreNtSONglisT:Else Set w=SDB.aLlVISibLESOnglIst:End If:Set kx=CreateObject("Scripting.Dictionary"):Set an=CreateObject("Scripting.Dictionary"):Set cb=CreateObject("Scripting.Dictionary"):Set c6=CreateObject("Scripting.Dictionary"):Set gh=CreateObject("Scripting.Dictionary"):j3=SDB.iNIFIlE.sTRiNgvaluE("TrackRedirection","DuplicatesExtList"):c4=SDB.iNIFile.bOolvalue("TrackRedirection","DuplicatesCriteria"):Set q=New RegExp:q.IgnoreCase=True:q.Global=False:q.Pattern="\."&Replace(j3,"|","$|\.")&"$":Set n=SdB.dAtAbAsE.oPENSQL("SELECT IDasx FROM TrackRedirection"):Do While Not n.EoF:m=n.sTRinGByiNdEX(0):If Not gh.eXISts(m)Then gh.Add m,m:End If:n.Next:Loop:Set n=Nothing:gp=je:Set a=sdb.DATAbAsE.QUeRySOnGS(e3(c4,j3,gp)):Do While Not a.EOF:Set l=a.Item:If Not c6.ExIsTS(CStr(l.Id))Then c6.adD CStr(l.ID),l.iD:End If:a.Next:Loop:Set a=Nothing:Set t=Nothing:o=4+CLng(Timer*10):For cx=0 To w.Count-1:Set l=w.Item(cx):If LCase(Right(l.pAtH,4))<>".asx"Then If Not gh.eXistS(CStr(l.iD))Then m=UCase(l.ArtiStNAME&"@#$"&l.TITlE):If Not cb.exiSTs(m)Then If c6.EXIsTS(CStr(l.Id))Then kx.AdD m,2147483647:Else kx.Add m,l.bitRAte:End If:an.aDD m,1:cb.add m,l.ID:Else If c6.eXISts(CStr(l.Id))Then kx.Item(m)=2147483647:cb.Item(m)=l.iD:Else If c4 And q.Test(l.path)Then If kx.Item(m)<l.bitratE Then kx.Item(m)=l.BitRATE:cb.Item(m)=l.id:End If:Else If kx.Item(m)<l.BItRaTE Then kx.Item(m)=l.BiTrATE:cb.Item(m)=l.Id:Else If kx.Item(m)=l.BItraTe And Len(j3)>0 Then If q.Test(l.pATH)Then kx.Item(m)=l.bitrATe:cb.Item(m)=l.iD:End If:End If:End If:End If:End If:an.Item(m)=an.Item(m)+1:End If:End If:End If:If o<CLng(Timer*10)Then o=1+CLng(Timer*10):sdb.pROcESSmEssagEs:If t Is Nothing Then Set t=SdB.PRogRESS:t.mAxvAlue=w.Count-1:Else If t.TerMINAtE Then Exit For:End If:End If:t.Value=cx:t.tEXt=cx&"/"&w.Count:End If:Next:Set n=Nothing:o=4+CLng(Timer*10):For cx=0 To w.Count-1:Set l=w.Item(cx):m=UCase(l.arTIStNAmE&"@#$"&l.TiTLe):If an.EXISts(m)Then If an.Item(m)>1 And cb.Item(m)=l.Id Then e=True:If gv=4 Then sdb.PlAYeR.pLAYlisTFoCUsED=cx:Else SdB.MaIntRAcKSWiNDoW.FOcuSed=cx:End If:Else e=False:End If:Else e=False:End If:If gv=4 Then sDb.PLaYEr.plAylistSELECTeD(cx)=e:Else sDb.mAiNTRacKSWINDOW.seleCted(cx)=e:End If:If o<CLng(Timer*10)Then o=1+CLng(Timer*10):SDb.proCeSSmESSAges:If t Is Nothing Then Set t=sDb.PrOGress:t.maxvALue=w.Count-1:Else If t.teRMInATe Then Exit For:End If:End If:t.Value=cx:t.texT="Selecting: "&cx&"/"&w.Count:End If:Next:End Sub:Dim gt:gt="There is a problem during update of the database,"&vbCr&"most probably because of some previous program error."&vbCr&vbCr&"It is recommended to restart the program.":Dim gi,kj,hh,cz,cg,d7,he,f,dj,a7,bn,fn,i4,fm,iy,ah,de,id,c5,gp,ex,iq,dc,b0,cv,bs,ac,cu,fh,hs,jq,hv,hr,c8,ew,j6,av:Dim du,gm,hd,dq,gf,ba,ea,cj,k3,im,gu,dz,h1,f6,cw,gn,l5,c6,gh,ci,a4:Dim ey:Dim g3:Dim s(),i3,p,hb,i8:Dim iu:Sub c7(fd):Dim jp,ei,bh,ho:sdB.iNifile.booLVaLUE("TrackRedirection","AsxFileFormat")=fd.coMMOn.chiLDconTROl("FileFormatUTF8").cHecKED:SDb.iniFilE.bOOLVaLuE("TrackRedirection","RelativePaths")=fd.coMMon.ChIldConTRol("RelativePaths").CHeckeD:ei=fd.COmMON.cHildCONTROL("RedirectedTracksPlaylist").tEXt:jp=fd.commOn.CHiLdConTRol("chkUpdateRedirectedPlaylist").checkeD:If jp And(Not sdB.inifiLE.booLvaLue("TrackRedirection","UpdateRedirectedPlaylist")Or ei<>sdB.IniFIle.STRINGvaluE("TrackRedirection","RedirectedTracksPlaylist"))Then If Len(ei)=0 Then ei=SdB.lOCALIZe("Redirected Tracks"):End If:sdb.inIFIlE.STRiNgValuE("TrackRedirection","RedirectedTracksPlaylist")=ei:Set sDb.objects("RedirectionPlaylist")=e5(ei):If sdB.objEcTs("RedirectionPlaylist")Is Nothing Then Set sdB.ObjecTS("RedirectionPlaylist")=ej(ei):If sDb.obJecTs("RedirectionPlaylist")Is Nothing Then Sdb.MesSaGEbOx sDb.loCALize("Track Redirection")&":"&vbCr&sdb.LocALize("The specified playlist cannot be created")&":"&vbCr&ei,MtwArNIng,Array(MBoK):End If:End If:If Not sdB.objeCtS("RedirectionPlaylist")Is Nothing Then kn:Else jp=False:End If:Else If Not jp And SdB.InIfIle.BoOLvAluE("TrackRedirection","UpdateRedirectedPlaylist")Then Set SDb.obJectS("RedirectionPlaylist")=Nothing:End If:End If:SdB.InIfILe.BOolvaLUe("TrackRedirection","UpdateRedirectedPlaylist")=jp:bh=fd.coMMOn.chiLdcONtrOl("UpdateRefPlaystats").cHECkED:If Sdb.IniFIlE.BOOlvaLue("TrackRedirection","UpdateRefPlaystats")<>bh Then sdb.InIFiLe.bOoLvaLuE("TrackRedirection","UpdateRefPlaystats")=bh:Else bh=False:End If:ho=fd.COmMoN.CHILDControl("SynchronizedMetadata").ChECkeD:If SDB.iniFIlE.booLvALUe("TrackRedirection","SynchronizedMetadata")<>ho Then SDb.iNiFIlE.bOoLvaluE("TrackRedirection","SynchronizedMetadata")=ho:Else ho=False:End If:SDb.inIFIlE.BOoLvAluE("TrackRedirection","SyncMetadataMasterOnly")=fd.COmMON.ChiLDCoNTroL("SyncMetadataMasterOnly").CHeCked:Sdb.iniFiLe.BoolvALue("TrackRedirection","SyncSongTitle")=fd.coMmoN.ChildCoNtROL("SyncSongTitle").CHeCKeD:sDb.inIFIlE.bOoLValue("TrackRedirection","SyncArtist")=fd.comMON.CHIlDCONtROL("SyncArtist").CHeCkED:sDB.iNIfiLe.boOLvAlUe("TrackRedirection","SyncAuthor")=fd.CoMMoN.childcONtrol("SyncAuthor").CHECKED:SDb.INifile.BOoLvaluE("TrackRedirection","SyncAlbum")=fd.cOmmOn.ChildCoNtrOL("SyncAlbum").CHeCkED:SDB.inIfilE.boOlvaLUe("TrackRedirection","SyncAlbumArtist")=fd.COMmON.chILdcOnTRoL("SyncAlbumArtist").CHEcKed:sdB.INIfILe.BooLVaLuE("TrackRedirection","SyncConductor")=fd.cOmMon.cHIldcONtRol("SyncConductor").CHECKeD:SDB.iniFIlE.bOOlvalUE("TrackRedirection","SyncLyricist")=fd.commON.chiLdconTROl("SyncLyricist").CHecKED:sdb.iNiFIlE.bOOlvalUE("TrackRedirection","SyncInvolvedPeople")=fd.Common.ChilDCONtRol("SyncInvolvedPeople").CHeCKeD:SDB.iNIfIle.boOLvAlUe("TrackRedirection","SyncYear")=fd.coMMOn.cHILDCONtROL("SyncYear").CHeCkEd:Sdb.inIfILE.boOlvALUE("TrackRedirection","SyncGenre")=fd.comMoN.chIlDCoNTRoL("SyncGenre").CHeckED:sDb.iNifilE.BOoLVaLuE("TrackRedirection","SyncRating")=fd.CommOn.CHiLDCONTROl("SyncRating").CHeCkeD:sDB.iNIfiLE.bOOlValUe("TrackRedirection","SyncTrackNumber")=fd.CommON.CHilDconTrol("SyncTrackNumber").cHECKEd:SdB.InifilE.bOOLVAlUe("TrackRedirection","SyncDiscNumber")=fd.ComMoN.cHildCOntROL("SyncDiscNumber").cheCkeD:SDb.inIfiLE.BOOlvALuE("TrackRedirection","SyncCustom1")=fd.commoN.CHIlDcoNtrOl("SyncCustom1").cHEcKED:sDb.InIfiLE.boOLVaLUe("TrackRedirection","SyncCustom2")=fd.cOmMON.cHIldcontRol("SyncCustom2").ChEckED:SDb.InIFile.bOolVALuE("TrackRedirection","SyncCustom3")=fd.comMon.ChIlDCoNTrOl("SyncCustom3").cheCKEd:SDB.inIfIlE.BoOlvaLUe("TrackRedirection","SyncCustom4")=fd.CoMMoN.chilDCoNTrol("SyncCustom4").CheckED:sdB.inIfiLE.bOOLvalue("TrackRedirection","SyncCustom5")=fd.coMmoN.CHiLDcONTRol("SyncCustom5").cHEcKED:sdB.iNIFIlE.BOOLvAlue("TrackRedirection","SyncTempo")=fd.COmMoN.chIldcoNTROL("SyncTempo").chECked:SDb.INifiLE.bOolvalUE("TrackRedirection","SyncMood")=fd.COmMON.cHildconTrOl("SyncMood").CheCKED:SDb.inIfIle.bOOLvALUE("TrackRedirection","SyncOccasion")=fd.COMMOn.ChIlDCOnTRoL("SyncOccasion").CheckED:Sdb.inIfILe.bOoLVaLuE("TrackRedirection","SyncQuality")=fd.COmMon.chilDCoNtROl("SyncQuality").chECKeD:sdB.iniFIle.boOLvaLUe("TrackRedirection","SyncBPM")=fd.COmmoN.CHildCOnTrOL("SyncBPM").CHecKeD:sDb.INifilE.BoOlVAlUe("TrackRedirection","SyncOrigArtist")=fd.cOMMON.cHilDcontrol("SyncOrigArtist").ChECkED:sDb.iniFILE.bOOLVaLue("TrackRedirection","SyncOrigTitle")=fd.COmMoN.ChIlDCONtrOl("SyncOrigTitle").cHeCkeD:sdb.inifILe.boOLvaLUe("TrackRedirection","SyncOrigYear")=fd.ComMoN.CHilDConTrOl("SyncOrigYear").cHecKeD:Sdb.INiFile.bOOLvAlUe("TrackRedirection","SyncOrigLyricist")=fd.COMMON.ChiLDCONTroL("SyncOrigLyricist").CHeckeD:sDb.InIFILe.BOoLValUe("TrackRedirection","SyncComment")=fd.coMMoN.CHIlDCOntROL("SyncComment").cHECked:SDB.iniFILe.BoolvaLuE("TrackRedirection","SyncLyrics")=fd.ComMon.childCoNTrOl("SyncLyrics").CHeckEd:Sdb.INifilE.bOoLVAlUe("TrackRedirection","SyncGroupDesc")=fd.Common.ChildCONTrOL("SyncGroupDesc").chEcKEd:SDb.inifIlE.boOlVALUe("TrackRedirection","SyncCopyright")=fd.COmMon.ChILdCOnTROL("SyncCopyright").cHecKED:sDb.inIfIlE.bOOLvAluE("TrackRedirection","SyncEncoder")=fd.cOMMoN.chilDCONTroL("SyncEncoder").CheCKED:Sdb.InIfIlE.BooLValUe("TrackRedirection","SyncISRC")=fd.COMmOn.ChiLdcONTrOl("SyncISRC").CheckeD:sdB.inIfILe.BooLvaLue("TrackRedirection","SyncPublisher")=fd.COmmoN.ChILdcOnTroL("SyncPublisher").cHeCKed:jp=fd.ComMon.cHiLDConTroL("SyncPlaystat").checkEd:If sdB.inIfILE.boOlValuE("TrackRedirection","SyncPlaystat")<>jp Then Sdb.iniFile.BoolVALuE("TrackRedirection","SyncPlaystat")=jp:sDb.oBjeCtS("mnuMainTransferRedirectedPlaystats").eNAbled=Not jp:Sdb.OBJects("mnuPopupTransferRedirectedPlaystats").enABLEd=Not jp:SdB.OBJecTs("mnuNPPopupTransferRedirectedPlaystats").eNABLed=Not jp:SdB.ObJECTs("mnuNPListTransferRedirectedPlaystats").enablED=Not jp:End If:jp=fd.COMmON.CHIldcONTrOl("SyncAlbumArt").chEcKED:SDB.iniFILe.BoolVALue("TrackRedirection","SyncAlbumArt")=jp:If jp Then If fd.ComMoN.ChiLDCOnTrOL("AlbumArtToTag").CHEcKEd Then SDB.INIFILE.IntvaLUe("TrackRedirection","AlbumArtStorage")=1:Else If fd.cOMmON.cHildcONTrOl("AlbumArtToFile").CHecKed Then sDB.iNIfILE.INTvaLUE("TrackRedirection","AlbumArtStorage")=2:sDB.inIfILe.StRiNGVALUE("TrackRedirection","AlbumArtFileName")=fd.comMON.CHildcoNTROL("AlbumArtFileName").TeXT:Else SDB.INIFile.Intvalue("TrackRedirection","AlbumArtStorage")=0:End If:End If:End If:On Error Resume Next:If SDB.VERsiOnbuILD<1217 Then:Else On Error GoTo 0:jp=fd.COmMoN.cHilDCOnTrOl("DuplicatesExtensions").chECkeD:sDb.INIFILE.bOOlvAlue("TrackRedirection","DuplicatesCriteria")=jp:If jp Then SDB.iNIfiLE.stRiNgVALUe("TrackRedirection","DuplicatesExtList")=fd.cOMMoN.ChIlDConTRoL("DuplicatesExtList").TeXt:End If:jp=fd.CoMMoN.ChIlDCoNTroL("AutoReplaceRedirected").chEcked:If SDB.inIFilE.bOOlVALue("TrackRedirection","AutoReplaceRedirected")<>jp Then sdB.INifile.bOoLVAlUE("TrackRedirection","AutoReplaceRedirected")=jp:If jp Then SCript.RegisTEreVEnt sDB,"OnNowPlayingModified","b7":Else On Error Resume Next:SCRipT.uNreGIsTERhAnDLeR"b7":On Error GoTo 0:End If:End If:End If:On Error GoTo 0:If bh Then a8 SDB.NEWsongLIst,True:End If:If ho Then ht SdB.nEwsONglIsT,True:End If:End Sub:Sub ReplaceWithAlbumNPList(jb):Dim hf,cx:hf=sDb.objECtS("colReplaceWithAlbumNPList").kEys:For cx=0 To sDb.ObJECts("colReplaceWithAlbumNPList").Count-1:If jb Is SDB.ObJects("colReplaceWithAlbumNPList").Item(hf(cx))Then f2"Album","NPList",hf(cx):Exit For:End If:Next:End Sub:Sub aj(jb):h1=False:du.ComMON.ENableD=True:hd.COMmON.EnABled=False:dq.ComMOn.eNABleD=False:gf.CoMmON.ENabLed=False:ba.CoMMOn.eNaBLeD=False:jx:End Sub:Sub ReplaceWithLinkedTrackPopup(jb):l2 jb,"Linked","Popup":End Sub:Sub jt(jb):h1=True:du.COmmOn.enableD=False:jx:hd.CoMMoN.ENablEd=True:dq.CoMMON.EnaBleD=True:gf.COMmON.ENablEd=True:ba.cOMMON.ENAbled=True:End Sub:Sub ReplaceWithAlbumTrackPopup(jb):l2 jb,"Album","Popup":End Sub:Sub fj(x):Dim w,l,n,e,gv,m,bt,t,o,cx:On Error Resume Next:If SDB.VERsIoNBUILd<1218 Then Exit Sub:End If:If Err Then Exit Sub:End If:On Error GoTo 0:gv=Sdb.ui.MaINwiNDoWfoCus:If gv=4 Then Set w=sdB.PlAyer.CuRREntSoNGLiST:Else Set w=SDB.allVISibLeSonGlISt:End If:Set bt=CreateObject("Scripting.Dictionary"):Set n=sdb.daTaBasE.OpENSQl("SELECT "&x):Do While Not n.eoF:m=n.stRInGbYinDEX(0):If Not bt.EXISts(m)Then bt.adD m,m:End If:n.Next:Loop:Set n=Nothing:Set t=Nothing:o=4+CLng(Timer*10):For cx=0 To w.Count-1:Set l=w.Item(cx):If bt.eXists(CStr(l.ID))Then e=True:If gv=4 Then SdB.PlAYeR.plaYliStFOcuSEd=cx:Else SDb.MaInTRACksWINDoW.foCUseD=cx:End If:Else e=False:End If:If gv=4 Then sDb.pLayER.PlaylistsELeCTeD(cx)=e:Else sDb.MAintrACKsWiNDoW.SELEcteD(cx)=e:End If:If o<CLng(Timer*10)Then o=1+CLng(Timer*10):Sdb.PRoCESsMESSaGES:If t Is Nothing Then Set t=sdb.pRoGreSs:t.mAxvALUE=w.Count-1:Else If t.TERmiNaTE Then Exit For:End If:End If:t.Value=cx:t.texT="Selecting: "&cx&"/"&w.Count:End If:Next:End Sub:Sub bc(h):l5=h.TExT:jx:End Sub:Sub ReplaceWithAlbumTrackNPList(jb):l2 jb,"Album","NPList":End Sub:Sub ak(w,dl,bh,ho,ic,dz,bu):Dim n,l,a,k,q,kq,ge,g,kg,x,t,o,cx:Set q=New RegExp:kq=jl.KEYS:Set ge=SDb.TOols.FileSystem:Set g=SDb.INIFIle:kg=g.intvALuE("TrackRedirection","AsxFileFormat"):a2=g.BoOlVAlue("TrackRedirection","LogReport"):Set t=Nothing:o=4+CLng(Timer*10):For cx=0 To w.Count-1:Set l=w.Item(cx):If ho Then x="SELECT ID FROM TrackRedirection WHERE IDref = "&l.Id:If Not ic Then x=x&" OR IDasx = "&l.iD:End If:Set n=sDb.dAtaBaSE.OPEnsQl(x):If Not n.eof Then Set n=Nothing:cq l,dl,ic,dz,q,kq,ge,g,kg:End If:End If:If bu Or Not ho Then Set a=SdB.daTaBASe.qUerYsoNGS("ID = (SELECT IDref FROM TrackRedirection WHERE IDasx = "&l.Id&")"):If Not a.Eof Then Set k=a.Item:Set a=Nothing:l0 l,k,dl,bh,q,kq,ge,kg:End If:End If:If o<CLng(Timer*10)Then o=1+CLng(Timer*10):SdB.pROCESsmessAges:If t Is Nothing Then Set t=sdB.proGrESS:t.MaXVALUE=w.Count-1:Else If t.teRMINaTe Then Exit For:End If:End If:t.Value=cx:t.Text="Updated "&cx&"/"&w.Count&" tracks":End If:Next:End Sub:Sub l2(jb,ju,iz):Dim w,l,x,gp,a,hf,z,cx:Set w=sDB.seleCTEdsOnGLisT:If w.Count=0 Then Exit Sub:End If:If w.Count=1 Then Set l=w.Item(0):If ju="Album"Then x="Artist COLLATE IUnicode = '"&fz(l.artisTname)&"' AND SongTitle COLLATE IUnicode = '"&fz(l.tiTLe)&"' AND ID <> "&l.ID:Else x="(ID = (SELECT IDref FROM TrackRedirection WHERE IDasx = "&l.id&") OR ID IN (SELECT IDasx FROM TrackRedirection WHERE IDref = "&l.Id&") OR ID IN (SELECT IDasx FROM TrackRedirection WHERE IDref = (SELECT IDref FROM TrackRedirection WHERE IDasx = "&l.ID&"))) AND ID <> "&l.iD:End If:iz=ju&iz:hf=sdb.obJeCTs("colReplaceWith"&iz).kEys:For cx=0 To UBound(hf):SdB.objeCtS("colReplaceWith"&iz).kEY(hf(cx))="ID"&cx:hf(cx)="ID"&cx:Next:gp=je:If Len(gp)Then x=x&" AND"&gp:End If:Set a=SDB.dataBASE.quERYSongS(x):cx=0:Do While Not a.eof:Set l=a.Item:If cx>=sdb.ObJEcTs("colReplaceWith"&iz).Count Then Set z=SDb.ui.AddmEnuiTem(jb,0,0):SDb.oBJECTs("colReplaceWith"&iz).Add l.Id,z:Else Set z=sDb.OBjEcts("colReplaceWith"&iz).Item(hf(cx)):z.VISIBLe=True:SDB.OBJectS("colReplaceWith"&iz).KEY(hf(cx))=l.ID:End If:z.CAPTIoN=l.aLBumnAme&" ("&l.SOnglEnGthsTriNG&", "&Mid(l.pATh,InStrRev(l.PAth,"."))&", "&l.bItraTe\1000&" kbps)":z.hInt=l.Path:z.onClickFunC="ReplaceWith"&iz:z.UsEScriPT=SCrIPt.ScrIptPath:cx=cx+1:a.Next:Loop:Set a=Nothing:Do While cx<UBound(hf)+1:SDb.OBjecTs("colReplaceWith"&iz).Item(hf(cx)).VISIBle=False:cx=cx+1:Loop:Else f2 ju,iz,cx:End If:End Sub:Sub go(h):dj=h.cHECkEd:End Sub:Sub d2(jb):ib" = IDasx",False:End Sub:Function hl():Dim ds,hu,h7,jf,hw(),cx,bv:Set hu=sDb.MaINtReE.cuRrENTNOdE:On Error Resume Next:If Sdb.VErSIOnbUild<1346 Then On Error GoTo 0:Select Case hu.NOdETyPE:Case 6:Set ds=Sdb.PlAylISTBYTitLE(""):Case 61,71:Set h7=hu:cx=-1:Do:cx=cx+1:Set jf=h7:bv=-1:Do:Set jf=sDB.mAintREE.PReviOussIBlInGnoDE(jf):bv=bv+1:Loop Until jf Is Nothing:Redim Preserve hw(cx):hw(cx)=bv:Set h7=sdb.mAiNTRee.pArEnTNOde(h7):Loop Until h7.nodETYpe=6:Set ds=SdB.PLaYliStbYTITlE(""):For bv=cx To 0 Step-1:Set ds=ds.chiLdplayListS.Item(hw(bv)):Next:If ds.tItlE<>hu.capTIon Then Set ds=Nothing:End If:Case Else Set ds=Nothing:End Select:Set hl=ds:Else On Error GoTo 0:Set hl=sdb.PlayLisTbYID(hu.RelatEdobjectiD):End If:End Function:Sub jx():Dim w,bt,a,fe,bb,k,y,gp,x,m,au,c4,j3,e4,t,o,b,cx:If ey Then ey=False:Exit Sub:End If:ey=True:i3=0:p.RootNoDECount=0:p.RefrESH:dc.CapTioN="0/0":SDB.OBjecTS("btnRedirUnsync").ComMon.EnABLED=False:ea.COmmOn.ENablED=False:k3.CoMMoN.EnAbLED=False:cj.coMMoN.EnABLEd=False:im.cOMmON.eNaBled=False:gu.cOmMOn.ENabLed=False:sDB.PRoCesSMeSsAGEs:Set c6=CreateObject("Scripting.Dictionary"):Set gh=CreateObject("Scripting.Dictionary"):Set bt=CreateObject("Scripting.Dictionary"):Set fe=CreateObject("Scripting.Dictionary"):Set bb=CreateObject("Scripting.Dictionary"):ReDim s(8,0):If cw Then gp=je:Else gp="":End If:b=0:Set t=Nothing:o=4+CLng(Timer*10):If Not h1 Then If f6 Then Set w=sdb.selECTeDSongLIst:For cx=0 To w.Count-1:Set k=w.Item(cx):m=UCase(k.ArtIsTnAMe&"@#$"&k.TitLe):If Not bt.ExISts(m)Then bt.add m,k:End If:Next:x="ID IN (SELECT IDasx FROM TrackRedirection)":Set a=sDB.DATABaSe.qUErYSoNgS(x):Do While Not a.EOF:Set y=a.Item:bb.ADD CStr(y.id),y.ID:a.Next:Loop:x="SongTitle || '@#$' || Artist COLLATE IUnicode IN (SELECT SongTitle || '@#$' || Artist COLLATE IUnicode FROM Songs WHERE SubStr(SongPath, -4, 4) <> '.asx' COLLATE IUnicode AND ID NOT IN (SELECT IDasx FROM TrackRedirection)":If Len(gp)Then x=x&" AND"&gp:End If:x=x&" GROUP BY Artist, SongTitle COLLATE IUnicode HAVING Count(*) > 1) AND SubStr(SongPath, -4, 4) <> '.asx' COLLATE IUnicode AND ID NOT IN (SELECT IDasx FROM TrackRedirection) AND ID NOT IN (SELECT IDref FROM TrackRedirection)":If Len(gp)Then x=x&" AND"&gp:End If:Set a=sdb.DatabASE.QuerYsongs(x):Do While Not a.eoF:Set y=a.Item:m=UCase(y.aRtISTNAmE&"@#$"&y.TItlE):If bt.ExIStS(m)Then Set k=bt.Item(m):If y.Id<>k.ID And Not fe.exIsTS(CStr(y.Id))And Not bb.eXIsts(CStr(k.Id))And LCase(Right(k.paTh,4))<>".asx"Then If Not fe.ExiSTS(CStr(k.id))Then fe.Add CStr(k.Id),k.Id:End If:fe.adD CStr(y.iD),y.ID:bb.aDd CStr(y.id),y.iD:c6.ADd CStr(b),k:gh.ADD CStr(b),y:ReDim Preserve s(8,b):s(0,b)=0:s(1,b)=k.Id:s(2,b)=y.id:s(3,b)=k.artistNAMe:s(4,b)=k.TItLe:s(5,b)=k.AlBuMNAMe:s(6,b)=k.PaTh:s(7,b)=y.ALBUmnAMe:s(8,b)=y.Path:b=b+1:End If:End If:a.Next:If o<CLng(Timer*10)Then o=1+CLng(Timer*10):SdB.pRocESSMeSSaGEs:If t Is Nothing Then Set t=SDb.progrESs:Else If t.TeRmINaTe Or Not ey Then Exit Do:End If:End If:t.tExt="Added "&b&" tracks to the table of redirections":End If:Loop:Else j3=SdB.inifilE.StRinGValuE("TrackRedirection","DuplicatesExtList"):c4=SDB.InifIle.BooLValUe("TrackRedirection","DuplicatesCriteria"):x=e3(c4,j3,gp):Set a=sDb.DATaBase.QueRySONGS(x):Do While Not a.EOF:Set k=a.Item:m=UCase(k.aRTiStNAme&"@#$"&k.tITle):bt.Add m,k:a.Next:If o<CLng(Timer*10)Then o=1+CLng(Timer*10):Sdb.PrOcEssmESsAGeS:If t Is Nothing Then Set t=SdB.ProgrEss:t.tEXt="Finding duplicates...":Else If t.TermiNaTe Or Not ey Then e4=True:Exit Do:End If:End If:End If:Loop:If Not e4 Then x="NOT ("&x&") AND SongTitle || '@#$' || Artist COLLATE IUnicode IN (SELECT SongTitle || '@#$' || Artist COLLATE IUnicode FROM Songs WHERE SubStr(SongPath, -4, 4) <> '.asx' COLLATE IUnicode AND ID NOT IN (SELECT IDasx FROM TrackRedirection)":If Len(gp)Then x=x&" AND"&gp:End If:x=x&" GROUP BY Artist, SongTitle COLLATE IUnicode HAVING Count(*) > 1) AND SubStr(SongPath, -4, 4) <> '.asx' COLLATE IUnicode AND ID NOT IN (SELECT IDasx FROM TrackRedirection) AND ID NOT IN (SELECT IDref FROM TrackRedirection)":If Len(gp)Then x=x&" AND"&gp:End If:Set a=sDB.dATabASe.QuERYSongs(x):Do While Not a.EOf:Set y=a.Item:m=UCase(y.ArtIStnAMe&"@#$"&y.titlE):If bt.exISts(m)Then Set k=bt.Item(m):c6.ADD CStr(b),k:gh.AdD CStr(b),y:ReDim Preserve s(8,b):s(0,b)=0:s(1,b)=k.ID:s(2,b)=y.Id:s(3,b)=k.arTistNAme:s(4,b)=k.tItlE:s(5,b)=k.AlbumnAmE:s(6,b)=k.PATH:s(7,b)=y.aLBUMNAMe:s(8,b)=y.PatH:b=b+1:End If:a.Next:If o<CLng(Timer*10)Then o=1+CLng(Timer*10):SDB.pROCESsMesSAges:If t Is Nothing Then Set t=sdb.PRoGResS:Else If t.TerMinaTe Or Not ey Then Exit Do:End If:End If:t.tExT="Added "&b&" tracks to the table of redirections":End If:Loop:End If:End If:Else If Len(gn)>0 And Len(l5)>0 Then If Len(gp)Then x=gp&" AND":End If:x=x&" SubStr(SongPath, -4, 4) <> '.asx' COLLATE IUnicode AND ID NOT IN (SELECT IDasx FROM TrackRedirection) AND SubStr((SELECT CASE WHEN DriveLetter IS NOT NULL AND DriveType < 12345 THEN SubStr('ABCDEFGHIJKLMNOPQRSTUVWXYZ', DriveLetter + 1, 1) ELSE '' END FROM Medias WHERE Songs.IDMedia = Medias.IDMedia) || UpperW(SongPath), 1, ":Set a=SDB.DaTabaSe.quErYsoNgS(x&Len(gn)&") = '"&fz(UCase(gn))&"'"):Do While Not a.EOf:Set k=a.Item:au=UCase(Mid(Left(k.pAth,InStrRev(k.Path,".")),Len(gn))):If Not bt.EXIStS(au)Then bt.add au,k:End If:a.Next:If o<CLng(Timer*10)Then o=1+CLng(Timer*10):SDb.ProcesSMEsSAgeS:If t Is Nothing Then Set t=sDB.pRoGReSS:t.TeXT="Finding duplicates...":Else If t.tERMinaTE Or Not ey Then e4=True:Exit Do:End If:End If:End If:Loop:If Not e4 Then Set a=sDB.daTABAse.qUerYSoNgs(x&Len(l5)&") = '"&fz(UCase(l5))&"' AND ID NOT IN (SELECT IDref FROM TrackRedirection)"):Do While Not a.EOF:Set y=a.Item:au=UCase(Mid(Left(y.patH,InStrRev(y.paTh,".")),Len(l5))):If bt.exisTS(au)Then Set k=bt.Item(au):If y.Id<>k.iD And Not fe.exisTS(CStr(y.iD))And Not bb.ExISTs(CStr(k.id))Then fe.ADD CStr(k.ID),k.Id:fe.aDd CStr(y.id),y.ID:bb.ADD CStr(y.ID),y.ID:c6.Add CStr(b),k:gh.add CStr(b),y:ReDim Preserve s(8,b):s(0,b)=0:s(1,b)=k.ID:s(2,b)=y.iD:s(3,b)=k.artistName:s(4,b)=k.TItLe:s(5,b)=k.ALBUmNAME:s(6,b)=k.pAth:s(7,b)=y.alBuMnaME:s(8,b)=y.paTH:b=b+1:End If:End If:a.Next:If o<CLng(Timer*10)Then o=1+CLng(Timer*10):SDB.pRocESsmEsSagEs:If t Is Nothing Then Set t=Sdb.progReSs:Else If t.terMinaTe Or Not ey Then Exit Do:End If:End If:t.tEXT="Added "&b&" tracks to the table of redirections":o=1+CLng(Timer*10):End If:Loop:End If:End If:End If:Set a=Nothing:If b Then p.ROoTNODecoUnT=b:p.reFRESh:dc.cAptIoN="0/"&b:SdB.obJEcts("btnRedirUnsync").CoMMOn.EnAblEd=True:End If:gu.cOmmOn.enAblEd=True:ey=False:End Sub:Sub l4(h):Dim ao:iy=True:gm.CoMMon.enABLeD=False:If SdB.SELeCTedsoNGlIst.Count=1 Then ao=False:Else ao=True:End If:dc.caPtion="You have selected "&SdB.SelecTEDSongLIst.Count&" track"&dp(ao,"s","")&" that "&dp(c5=0,"could","will")&" be kept as a master"&dp(ao,"s","")&dp(c5=0,". However, you don't have any"&vbCr&"unselected track with same Artist and Title as "&dp(ao,"those","that")&" master track"&dp(ao,"s","")&" which could be "&dp(fm,"redirected.","replaced.")&vbCr&"You could try with the ""Find Duplicate Titles and Select Maximal Bitrate"" option first.",". The "&c5&" unselected track"&dp(c5>1,"s have"," has")&vbCr&"same Artist and Title as "&dp(ao,"those","that")&" master track"&dp(ao,"s","")&" and will be "&dp(fm,"redirected to the master track","replaced with the .asx metafile")&dp(ao,"s","")&"."&vbCr&"If you press OK button, the database will be updated without any further confirmation."):b0.iteMInDeX=-1:cv.ITEmINDEx=-1:bs.ITeMIndEX=-1:b0.coMMoN.eNaBLEd=False:cv.COMmON.eNaBLEd=False:bs.cOmmon.ENAbLED=False:ac.CoMmon.ENaBleD=False:fh.cOMMON.enabLED=False:hs.COmmon.enAbled=False:jq.cOMmOn.ENABled=False:hv.cOMMoN.Enabled=False:cu.commoN.enabLEd=False:hr.captioN="Delete "&c5&" unselected audio file"&dp(c5>1,"s","")&" after creating "&dp(c5>1,"their","its")&" corresonding .asx metafile"&dp(c5>1,"s",""):c8.CAptiON="Copy master (selected) track"&dp(ao,"s","")&" to the Album folder if it doesn't contain duplicate file"&dp(ao,"s",""):c8.Common.eNablEd=(fm And Not iy):k7 hv:End Sub:Sub b6(jb):If sDB.SELECtEDsonGLIST.Count=0 Then Exit Sub:Else If Sdb.mESSAGebOx("This will update the metadata of the selected"&vbCr&".asx files so that they match your library."&vbCr&vbCr&"Are you sure you want to proceed?",mTCONfIRmATIon,Array(mByes,MBNo))=Mryes Then ak sDb.SElECtEdsonGlIST,True,False,False,False,False,False:End If:End If:End Sub